<?php
defined("SAWANNA") or die();

class CCalendar extends CSawanna 
{
	var $db;
	var $language;
	var $session;
	var $tpl;
	var $user;
	var $node;
	var $workspace;
	var $_workspace;
	var $element;
	
	function CCalendar()
	{
		$this->db=null;
		$this->language=null;
		$this->session=null;
		$this->tpl=null;
		$this->user=null;
		$this->node=null;
		$this->workspace='';
		$this->_workspace='article';
		$this->element='body';
	}
	
	function build()
	{	
		if (!isset($this->tpl->javascript['jquery']) || !$this->tpl->javascript['jquery'])
		{
			echo '<script language="JavaScript" src="'.HOME.'/addons/calendar/jquery-1.3.2.min.js"></script>';
			$this->tpl->javascript['jquery']=true;
		}
		echo '<script language="JavaScript" src="'.HOME.'/addons/calendar/jcalendar.js"></script>';
		echo '<script language="JavaScript">';
		echo '$("head").append("<link rel=\"stylesheet\" type=\"text/css\" href=\"/addons/calendar/jcalendar.css\" />");';
	    $months = array(1=>'january', 2=>'february', 3=>'march', 4=>'april', 5=>'may', 6=>'june', 7=>'july', 8=>'august', 9=>'september', 10=>'october', 11=>'november', 12=>'december');
		echo "days = ['[string]sunday[/string]', '[string]monday[/string]', '[string]tuesday[/string]', '[string]wednesday[/string]', '[string]thursday[/string]', '[string]friday[/string]', '[string]saturday[/string]'];";
		echo "navLinks = {p:'[string]previous[/string]', n:'[string]next[/string]', t:'[string]today[/string]'};";
		echo '$(document).ready(function() {';
		echo '$(\'fieldset.jcalendar\').jcalendar();';
		echo '});';
		
		echo 'function getDateSelected()';
		echo '{';
		echo '	var sday=jQuery("select.jcalendar-select-day").get(0).options[jQuery("select.jcalendar-select-day").get(0).selectedIndex].value;';
		echo '	var smonth=jQuery("select.jcalendar-select-month").get(0).options[jQuery("select.jcalendar-select-month").get(0).selectedIndex].value;';
		echo '	var syear=jQuery("select.jcalendar-select-year").get(0).options[jQuery("select.jcalendar-select-year").get(0).selectedIndex].value;';
			
		echo '	var date={\'day\':sday,\'month\':smonth,\'year\':syear};';
		echo '	return date;';
		echo '}';
		
		echo 'function requestCalendarData()';
		echo '{';
		echo '	var date=getDateSelected();';
		echo '	$.post("'.parent::build_url('ajax/calendar').'",{day:date.day,month:date.month,year:date.year},showCalendarData);';
		echo '}';
		
		echo 'function showCalendarData(data)';
		echo '{';
		echo 'if (data.length > 0) {';
		echo '  var b=$("#'.$this->element.'");';
		echo '  b.animate({opacity:0},300,function() {b.empty(); b.append(data); b.animate({opacity:1},300);});';
		echo '} else {';
		if ($this->workspace!='news')
			echo 'alert("[string]no_articles_this_date[/string]");';
		else 
			echo 'alert("[string]no_news_this_date[/string]");';
		echo '};';
		echo '}';

		echo '</script>';
		
		echo '<div class="field_caption">[string]calendar[/string]</div>';
		echo '<div class="field_body">';
			
		echo '<form>';
		echo '<fieldset class="jcalendar">';
		echo '<div class="jcalendar-wrapper">';
		echo '<div class="jcalendar-selects">';
		echo '<select name="day" id="day" class="jcalendar-select-day">';
		echo '<option value="0"></option>';
		for ($i=1;$i<32;$i++) {
			echo '<option value="'.$i.'">'.$i.'</option>';
		}
		echo '</select>';
		echo '<select name="month" id="month" class="jcalendar-select-month">';
		echo '<option value="0"></option>';
		for ($i=1;$i<13;$i++) {
			echo '<option value="'.$i.'">[string]'.$months[$i].'[/string]</option>';
		}
		echo '</select>';
		echo '<select name="year" id="year" class="jcalendar-select-year">';
		echo '<option value="0"></option>';
		for ($i=1982;$i<2033;$i++) {
		echo '<option value="'.$i.'">'.$i.'</option>';
		}
		echo '</select>';
		echo '</div>';
		echo '</div>';
		echo '</fieldset>';
		echo '</form>	';
			
		echo '</div><div style="width:100%" class="shadow_1"></div>';
	}
	
	function sendData()
	{
		
		if (empty($_POST['day']) || empty($_POST['month']) || empty($_POST['year'])) return;
		if (!is_numeric($_POST['day']) || !is_numeric($_POST['month']) || !is_numeric($_POST['year'])) return;
		
		$time1=mktime(0,0,0,$_POST['month'],$_POST['day'],$_POST['year']);
		$time2=mktime(23,59,59,$_POST['month'],$_POST['day'],$_POST['year']);
		
		$html='';
		
		$condition="language='".$this->db->escape_string($this->language->current)."'";
		
		switch ($this->user->group)
		{
			case 1 :
				$condition.='';
				break;
			case 2 :
				$condition.=' and ';
				$condition.="access <> '0'";
				break;
			default:
				$condition.=' and ';
				$condition.="access = '1'";
				break;
		}
		
		$condition.=" and published > '".$this->db->escape_string($time1)."' and published < '".$this->db->escape_string($time2)."'";
		$condition.=" and workspace='".$this->db->escape_string($this->_workspace)."' and mark='".($this->_workspace == 'news' ? 'short' : '')."'";
		
		$result=$this->db->sub_query("select * from ".DB_PREFIX."_nodes where ".$condition." order by published desc");
	
		if (isset($result) && !empty($result)) 
		{
			
			while ($node=$this->db->fetch_array($result))
			{
				
				$thumb='';
				if (file_exists(ROOT_DIR.'/upload/thumbs/'.$this->_workspace.'_'.$node['link'].'.jpg'))
				{
					$thumb_size=@getimagesize(ROOT_DIR.'/upload/thumbs/'.$this->_workspace.'_'.$node['link'].'.jpg');
					$dimm=(array_key_exists(3,$thumb_size)) ? $thumb_size[3] : 'width="80" height="60"';
					$thumb='<img src="'.HOME.'/upload/thumbs/'.$this->_workspace.'_'.$node['link'].'.jpg" '.$dimm.' class="thumbnail" align="left" style="margin-right:10px;margin-top:5px;margin-bottom:5px" />';
				}
				
				$this->title='';
				$html.= parent::build_anchor($this->_workspace.'/'.$node['link'],'<div style="font-weight:bold;margin-bottom:3px">'.$node['name'].'</div>');
				
				if (($teaser=strpos($node['content'],'[break]')) !== false)
				{
					$content=strip_tags(substr($node['content'],0,$teaser),'<p><P><br /><BR /><br><BR>');
				} elseif (function_exists('mb_substr'))
				{
					$content=mb_substr(strip_tags($node['content'],'<p><P><br /><BR /><br><BR>'),0,1000);
				} else 
				{
					$content=substr(strip_tags($node['content'],'<p><P><br /><BR /><br><BR>'),0,1000);
				}
				$html.= $thumb.$content.'<br clear="all" />';
				
				$comments=array('workspace'=>$this->_workspace,'link'=>$node['link'],'mark'=>'comment','access'=>'1');
				$res=$this->node->get($comments);
				$count=$this->db->num_rows($res);
				
				$_res=$this->db->sub_query("select name,login,gender from ".DB_PREFIX."_users where id = '".$this->db->escape_string($node['author_id'])."'");
				$user=$this->db->fetch_array($_res);
				$author=(!empty($user['name'])) ? $user['name'] : $user['login'];
				$gender='';
				if (!empty($user['gender']))
				{
					switch ($user['gender'])
					{
						case 'M' :
							$gender.='<img src="'.HOME.'/sawanna/images/male.gif" width="10" height="10" align="bottom" border="0" />&nbsp;';
							break;
						case 'F' :
							$gender.='<img src="'.HOME.'/sawanna/images/female.gif" width="10" height="10" align="bottom" border="0" />&nbsp;';
							break;
					}
				}
	
				$html.='<div style="width:100%;border-bottom:1px solid #DDDDDD;text-align:right;height:15px">'.parent::build_anchor($this->_workspace.'/'.$node['link'],'<span  class="read_more">[string]read_more[/string]</span>').'</div>';
				$html.= '<div style="width:50%;font-size:10px;text-align:left;margin-top:3px;float:left">[string]author[/string]:&nbsp;'.$gender.parent::build_anchor('user/view/'.$user['login'],'<span style="font-size:10px;cursor:pointer">'.$author.'</span>').'</div><div style="width:200px;font-size:10px;text-align:right;margin-top:3px;float:right"><font color="#963A16">[string]date[/string]: '.date('d.m.Y',$node['published']).'</font>&nbsp;&nbsp;&nbsp;<font color="#163196">[string]comments[/string]: '.((!empty($count)) ? $count : 0).'</font></div>';
				$html.= '<br /><br /><br />';
			}
			
		}
		
		if (!empty($html))
		{
			echo '<br clear="all" />';
			echo '<div style="padding:5px">';
			if ($this->_workspace == 'news')
				echo '<div class="section"><div style="float:left">'.date('d.m.Y',$time1).' | [string]published_news[/string]</div>';
			else 
				echo '<div class="section"><div style="float:left">'.date('d.m.Y',$time1).' | [string]published_articles[/string]</div>';
			
			echo '</div>';
			echo '<div style="padding:5px">';	
			echo $html;
			echo '</div>';
			echo '</div>';
		}
	}
}

function calendar_init($env)
{
	global $SawannaCalendar;
	
	$SawannaCalendar=new CCalendar();
	$SawannaCalendar->db=&$env['db'];
	$SawannaCalendar->language=&$env['language'];
	$SawannaCalendar->session=&$env['session'];
	$SawannaCalendar->tpl=&$env['tpl'];
	$SawannaCalendar->user=&$env['user'];
	$SawannaCalendar->node=&$env['node'];
	$SawannaCalendar->workspace=$env['workspace'];
	
	if ($SawannaCalendar->workspace == 'ajax' && isset($_SERVER['HTTP_REFERER']))
	{
		$query=array();
		
		$referer=$_SERVER['HTTP_REFERER'];
		if (substr($referer,-1,1) != '/') $referer.='/';
		if (strpos($referer,HOME.'/index.php') !== 0) $referer=HOME.'/index.php?'.str_replace(HOME.'/','',$referer);
		
		$QUERY_STRING=str_replace(HOME.'/index.php','',$referer);
		if (substr($QUERY_STRING,0,1)=='?') $QUERY_STRING=substr($QUERY_STRING,1);
		
		if (!empty($QUERY_STRING))
		{
			if (count($SawannaCalendar->language->languages) > 1)
			{
				$query=explode("/",urldecode($QUERY_STRING),3);
			} else 
			{
				$query=explode("/",urldecode($QUERY_STRING),2);
				array_unshift($query,'');
			}
		}
		
		if (!empty($query) && $query[1]=='news')
			$SawannaCalendar->_workspace='news';
	}
}

function calendar_exec()
{
	global $SawannaCalendar;
	
	if ($SawannaCalendar->workspace != 'ajax')
		$SawannaCalendar->build();
	else 
		$SawannaCalendar->sendData();
}

function calendar_clear()
{
	global $SawannaCalendar;
	
	unset(
		  $SawannaCalendar->db,
		  $SawannaCalendar->language,
		  $SawannaCalendar->session,
		  $SawannaCalendar->tpl,
		  $SawannaCalendar->user,
		  $SawannaCalendar->node,
		  $SawannaCalendar->workspace,
		  $SawannaCalendar->_workspace,
		  $SawannaCalendar->element
		 );
}
?>