<?php
defined("SAWANNA") or die();

class CSawannaCustomCode extends CSawanna
{
	var $db;
	var $session;
	var $language;
	var $tpl;
	var $message;
	var $error;
	var $limit;
	var $get;
	
	function CSawannaCustomCode()
	{
		$this->db=null;
		$this->session=null;
		$this->language=null;
		$this->tpl=null;
		$this->message='';
		$this->error='';
		$this->limit=10;
		$this->get=(isset($_GET['get']) && !empty($_GET['get']) && is_numeric($_GET['get']) && $_GET['get']>0 ) ? $_GET['get'] : 1;
	}
	
	function show()
	{
		$html='<div align="left" style="padding:10px">';
		
		if (!isset($_GET['act']))
		{
			$html.='&nbsp;&nbsp;&nbsp;'.parent::build_anchor(ADMIN_WORKSPACE.'/&component=code&act=create','<img src="'.HOME.'/sawanna/images/create.png" width="20" height="20" border="0" align="absmiddle" hspace="5" /><b>[string]create_code[/string]</b>');
		}
		$html.='<div style="border-bottom:1px solid #000000">&nbsp;</div><br />';
		
		$current=(intval($this->get)-1)*$this->limit+1;
		$co=0;
		$this->db->query("select * from ".DB_PREFIX."_blocks order by id desc");
		while ($code=$this->db->fetch_array()) {
			$co++;
			if ($co<$current) continue;
			
			$html.='<div style="height:20px">'.parent::build_anchor(ADMIN_WORKSPACE.'/&component=code&act=edit&id='.$code['id'],'<img src="'.HOME.'/sawanna/images/edit.png" width="20" height="20" title="[string]edit[/string]" border="0" align="absmiddle" />').'&nbsp;&nbsp;'.parent::build_anchor(ADMIN_WORKSPACE.'/&component=code&act=del&id='.$code['id'],'<img src="'.HOME.'/sawanna/images/delete.png" width="20" height="20" title="[string]delete[/string]" border="0" align="absmiddle" />').'&nbsp;&nbsp;'.$code['page'].' ( '.$code['component'].' ) '.'&nbsp;&nbsp;'.htmlspecialchars(substr($code['code'],0,50)).' ...'.'</div>';
			if ($co>=$this->limit+$current-1) break;
		}
		
		$count=$this->db->num_rows();
		if ($count > $this->limit)
		{
			$html.='<br /><br />';
			$html.=parent::build_limiter($count,$this->limit,ADMIN_WORKSPACE.'/&component=code',$this->get,true);
		}
		
		$html.='</div>';
		
		echo $html;
	}
	
	function build_create_form()
	{
		$page=(isset($_POST['page']) && !empty($_POST['page'])) ? $_POST['page'] : '';
		$component=(isset($_POST['component']) && !empty($_POST['component'])) ? $_POST['component'] : '';
		$code=(isset($_POST['code']) && !empty($_POST['code'])) ? $_POST['code'] : '';
		$weight=(isset($_POST['weight']) && !empty($_POST['weight'])) ? $_POST['weight'] : '';
		
		$html='';
			
		
		$elems=array(
					'text',
					'custom',
					'text',
					'custom',
					'text',
					'submit'
					);
					
		$desc=array(
					'[string]address[/string]',
					'[string]component[/string]',
					'[string]or[/string]',
					'',
					'[string]weight[/string]',
					' '
					);
		
		$attr=array(
					'name="page" style="width:250px" value="'.$page.'"',
					'',
					'name="component" id="component" style="width:250px" value="'.$component.'"',
					'',
					'name="weight" style="width:100px" value="'.$weight.'"',
					'value="[string]send[/string]"'
					);
					
		$component_elem='<select name="component_sel" id="component_sel" style="width:250px" onchange="document.getElementById(\'component\').value=this.options[this.selectedIndex].value">';
		$component_elem.='<option value="">[string]choose[/string]</option>';
		
		foreach ($this->tpl->components as $tpl_component)
		{
			if ($tpl_component != 'title' && $tpl_component != 'header' && $tpl_component != 'message' && $tpl_component != 'breadcrumbs')
			{
				$component_elem.='<option value="'.$tpl_component.'">'.$tpl_component.'</option>';
			}
		}
		
		$component_elem.='</select>';
					
		$custom=array(
					'',
					$component_elem,
					'',
					'<textarea name="code" cols="70" rows="10" style="width:100%">'.$code.'</textarea>'
					);
		
		$html.='<p align="left" style="padding:0px 10px">[string]paste_code_str[/string]</p><br />';
		$html.=parent::build_form(ADMIN_WORKSPACE.'/&component=code&act=docreate',$elems,500,$desc,$attr,$custom);
		
		echo $html; 
	}
	
	function create()
	{
		if (!isset($_POST['component']) || empty($_POST['component']))
		{
			$this->error='[string]component_required[/string]';
			$this->build_create_form();
			return ;
		}
		
		if (!isset($_POST['code']) || empty($_POST['code']))
		{
			$this->error='[string]code_required[/string]';
			$this->build_create_form();
			return ;
		}
		
		$page=(isset($_POST['page']) && !empty($_POST['page'])) ? $_POST['page'] : null;
		$weight=(isset($_POST['weight']) && !empty($_POST['weight']) && is_numeric($_POST['weight'])) ? $_POST['weight'] : 0;
		
		if (!$this->db->query("insert into ".DB_PREFIX."_blocks values (null,'".$this->db->escape_string($_POST['code'])."','".$this->db->escape_string($_POST['component'])."','".$this->db->escape_string($page)."','".$this->db->escape_string($weight)."',null)"))
		{
			$this->error='[string]database_error[/string]';
			$this->build_create_form();
			return ;
		}
		
		$this->message='[string]code_inserted[/string]';
	}
	
	function build_edit_form()
	{
		if (!isset($_GET['id']) || empty($_GET['id']))
		{
			$this->error='[string]code_not_found[/string]';
			return;
		}
		
		$this->db->query("select * from ".DB_PREFIX."_blocks where id='".$this->db->escape_string($_GET['id'])."'");
		$block=$this->db->fetch_array();
		
		if (empty($block))
		{
			$this->error='[string]code_not_found[/string]';
			return;
		}
		
		$html='';
			
		
		$elems=array(
					'text',
					'custom',
					'text',
					'custom',
					'text',
					'submit'
					);
					
		$desc=array(
					'[string]address[/string]',
					'[string]component[/string]',
					'[string]or[/string]',
					'',
					'[string]weight[/string]',
					' '
					);
		
		$attr=array(
					'name="page" style="width:250px" value="'.$block['page'].'"',
					'',
					'name="component" id="component" style="width:250px" value="'.$block['component'].'"',
					'',
					'name="weight" style="width:100px" value="'.$block['weight'].'"',
					'value="[string]send[/string]"'
					);
					
		$component_elem='<select name="component_sel" id="component_sel" style="width:250px" onchange="document.getElementById(\'component\').value=this.options[this.selectedIndex].value">';
		$component_elem.='<option value="">[string]choose[/string]</option>';
		
		foreach ($this->tpl->components as $tpl_component)
		{
			if ($tpl_component != 'title' && $tpl_component != 'header' && $tpl_component != 'message')
			{
				$component_elem.='<option value="'.$tpl_component.'">'.$tpl_component.'</option>';
			}
		}
		
		$component_elem.='</select>';
					
		$custom=array(
					'',
					$component_elem,
					'',
					'<textarea name="code" cols="70" rows="10" style="width:100%">'.$block['code'].'</textarea>'
					);
		
		$html.='<p align="left" style="padding:5px">[string]paste_code_str[/string]</p><br />';
		$html.=parent::build_form(ADMIN_WORKSPACE.'/&component=code&act=doedit&id='.$_GET['id'],$elems,500,$desc,$attr,$custom);
		
		echo $html; 
	}
	
	function edit()
	{
		if (!isset($_GET['id']) || empty($_GET['id']))
		{
			$this->error='[string]code_not_found[/string]';
			return;
		}
		
		if (!isset($_POST['component']) || empty($_POST['component']))
		{
			$this->error='[string]component_required[/string]';
			$this->build_edit_form();
			return ;
		}
		
		if (!isset($_POST['code']) || empty($_POST['code']))
		{
			$this->error='[string]code_required[/string]';
			$this->build_edit_form();
			return ;
		}
		
		$page=(isset($_POST['page']) && !empty($_POST['page'])) ? $_POST['page'] : '';
		$weight=(isset($_POST['weight']) && !empty($_POST['weight']) && is_numeric($_POST['weight'])) ? $_POST['weight'] : 0;
		
		if (!$this->db->query("update ".DB_PREFIX."_blocks set code='".$this->db->escape_string($_POST['code'])."', component='".$this->db->escape_string($_POST['component'])."', page='".$this->db->escape_string($page)."', weight='".$this->db->escape_string($weight)."' where id='".$this->db->escape_string($_GET['id'])."'"))
		{
			$this->error='[string]database_error[/string]';
			$this->build_edit_form();
			return ;
		}
		
		$this->message='[string]code_edited[/string]';
	}
	
	function build_delete_form()
	{
		if (!isset($_GET['id']) || empty($_GET['id']))
		{
			$this->error='[string]code_not_found[/string]';
			return;
		}
		
		$this->db->query("select * from ".DB_PREFIX."_blocks where id='".$this->db->escape_string($_GET['id'])."'");
		$block=$this->db->fetch_array();
		
		if (empty($block))
		{
			$this->error='[string]code_not_found[/string]';
			return;
		}
		
		$html='';
		
		$html.='<div align="left" style="padding:10px">';
		$html.='<b><em>'.$block['page'].' ( '.$block['component'].' ) '.'</em></b>';
		$html.='<br /><br /><span>'.htmlspecialchars($block['code']).'</span>';
		$html.='<p style="color:red">[string]code_delete_confirm[/string]</p>';
		$html.=parent::build_anchor(ADMIN_WORKSPACE.'/&component=code&act=dodel&id='.$_GET['id'],'<b>[string]delete[/string]</b>');
		$html.='</div>';
		
		echo $html;
	}
	
	function delete()
	{
		if (!isset($_GET['id']) || empty($_GET['id']))
		{
			$this->error='[string]code_not_found[/string]';
			return;
		}
		
		if (!$this->db->query("delete from ".DB_PREFIX."_blocks where id='".$this->db->escape_string($_GET['id'])."'"))
		{
			$this->error='[string]database_error[/string]';
			$this->build_edit_form();
			return ;
		}
		
		$this->message='[string]code_deleted[/string]';
	}
	
}

function code_init($env)
{
	global $SawannaCustomCode;
	
	$SawannaCustomCode=new CSawannaCustomCode();
	$SawannaCustomCode->db=&$env['db'];
	$SawannaCustomCode->session=&$env['session'];
	$SawannaCustomCode->language=&$env['language'];
	$SawannaCustomCode->tpl=&$env['tpl'];
}

function code_exec()
{
	global $SawannaCustomCode;
	
	if (isset($_GET['component']) && $_GET['component']=='code')
	{
		echo '<h2><img src="'.HOME.'/sawanna/images/wpalm.png" width="40" height="40" align="absmiddle">&nbsp;[string]paste_code[/string] :</h2>';
		echo '<p style="padding:10px 10px 0px 10px">[string]code_str[/string]</p>';
		echo '<div align="center" style="padding-top:10px;padding-bottom:10px">';
		
		if (isset($_GET['act']))
		{
			switch ($_GET['act'])
			{
				case 'create' :
					$SawannaCustomCode->build_create_form();
					break;
				case 'docreate' :
					$SawannaCustomCode->create();
					break;
				case 'edit' :
					$SawannaCustomCode->build_edit_form();
					break;
				case 'doedit' :
					$SawannaCustomCode->edit();
					break;
				case 'del' :
					$SawannaCustomCode->build_delete_form();
					break;
				case 'dodel' :
					$SawannaCustomCode->delete();
					break;
			}
		}
		
		$SawannaCustomCode->show();
		
		echo '</div>';
	}
	
	return array($SawannaCustomCode->message,$SawannaCustomCode->error,'');
}

function code_clear()
{
	global $SawannaCustomCode;
	
	unset(
		$SawannaCustomCode->db,
		$SawannaCustomCode->session,
		$SawannaCustomCode->language,
		$SawannaCustomCode->tpl,
		$SawannaCustomCode->message,
		$SawannaCustomCode->error,
		$SawannaCustomCode->limit,
		$SawannaCustomCode->get
		);
}
?>