<?php
defined("SAWANNA") or die();

class CSawannaCumulus extends CSawanna
{
	var $session;
	var $language;
	var $db;
	var $user;
	var $tpl;
	var $limit;
	var $max_size;
	var $min_size;
	
	function CSawannaCumulus()
	{
		$this->session=null;
		$this->language=null;
		$this->db=null;
		$this->tpl=null;
		$this->user=null;
		$this->limit=50;
		$this->max_size=18;
		$this->min_size=10;
	}
	
	function build()
	{
		$html='';
		$tags=array();
		
		switch ($this->user->group)
		{
			case 2 :
				$condition=' and ';
				$condition.="access <> '0'";
				break;
			default:
				$condition=' and ';
				$condition.="access = '1'";
				break;
		}
		
		$this->db->query("select keywords from ".DB_PREFIX."_nodes where language='".$this->db->escape_string($this->language->current)."'".$condition);
		while ($node=$this->db->fetch_array())
		{
			$keywords=explode(',',$node['keywords']);
			if (!empty($node['keywords']) && !empty($keywords))
			{
				foreach ($keywords as $keyword)
				{
					if (array_key_exists($keyword,$tags))
					{
						$tags[$keyword]++;
					} else 
					{
						$tags[$keyword]=0;
					}
				}
			}
		}
		
		if (!empty($tags))
		{
			arsort($tags); 
			$max_value=current($tags);
			if ($max_value!=0)
			{
				$pref=($this->max_size-$this->min_size)/$max_value;
				$count=count($tags);
				$cloud=array_rand($tags,$count>$this->limit ? $this->limit : $count);
	
				foreach ($cloud as $tag)
				{
					$size=floor($tags[$tag]*$pref)+$this->min_size;
					$html.='<a style="font-size:'.$size.'pt" href="javascript:getTag(\''.$tag.'\')">'.$tag.'</a> ';
				}
			} else 
			{
				foreach ($tags as $tag=>$count_val)
				{
					$html.='<a style="font-size:'.$this->min_size.'pt" href="javascript:getTag(\''.$tag.'\')">'.$tag.'</a> ';
				}
			}
		}
		
		if (!empty($html))
		{
			if (!isset($this->tpl->javascript['swfobject']) || !$this->tpl->javascript['swfobject'])
			{
				echo '<script language="JavaScript" src="'.HOME.'/addons/cumulus/swfobject.js"></script>';
				$this->tpl->javascript['swfobject']=true;
			}
		
			echo '<div class="field_caption">[string]tags_cloud[/string]</div>';
			echo '<div class="field_body">';
			echo $this->createflashcode($html);
			echo '<div style="height:1px;overflow:hidden"><form style="height:1px;visibility:hidden" name="tags_form" id="tags_form" action="'.parent::build_url('search').'" method="POST"><input type="text" name="search" id="tags_search" style="width:100px;margin-right:5px" /></form></div>';
			echo '<script language="JavaScript">function getTag(tag){ document.getElementById(\'tags_search\').value=tag;document.getElementById(\'tags_form\').submit(); };</script>';
			echo '</div>';
			echo '<div style="width:100%" class="shadow_1"></div>';
		}
	}
	
	function createflashcode(&$tags){
		global $options;
		
		$tags=urlencode("<tags>$tags</tags>");
		
			$flash=<<<HTML
			<div id="cumulus" style="width:170px;overflow:hidden"></div>
			<script type="text/javascript">
			var rnumber = Math.floor(Math.random()*9999999);
			var widget_so = new SWFObject("/addons/cumulus/tagcloud.swf?r="+rnumber, "tagcloudflash", "180", "135", "9", "#ffffff");
			widget_so.addParam("wmode", "transparent");
			widget_so.addParam("allowScriptAccess", "always");
			widget_so.addVariable("tcolor", "0x000000");
			widget_so.addVariable("tspeed", "90");
			widget_so.addVariable("distr", "true");
			widget_so.addVariable("mode", "tags");
			widget_so.addVariable("tagcloud","{$tags}");
			widget_so.write("cumulus");
			</script>
HTML;

	return $flash;
	}
}

function cumulus_init($env)
{
	global $SawannaCumulus;
	
	$SawannaCumulus=new CSawannaCumulus();
	$SawannaCumulus->session=&$env['session'];
	$SawannaCumulus->language=&$env['language'];
	$SawannaCumulus->db=&$env['db'];
	$SawannaCumulus->tpl=&$env['tpl'];
	$SawannaCumulus->user=&$env['user'];
}

function cumulus_exec()
{
	global $SawannaCumulus;

	$SawannaCumulus->build();
}

function cumulus_clear()
{
	global $SawannaCumulus;
	
	unset(
		$SawannaCumulus->session,
		$SawannaCumulus->language,
		$SawannaCumulus->db,
		$SawannaCumulus->user,
		$SawannaCumulus->tpl,
		$SawannaCumulus->limit,
		$SawannaCumulus->max_size,
		$SawannaCumulus->min_size
		);
}
?>