<?php
defined("SAWANNA") or die();

class CCustomFormAdmin extends CSawanna
{
	var $db;
	var $session;
	var $language;
	var $message;
	var $error;
	var $get;
	var $limit;
	var $_workspace;
	
	function CCustomFormAdmin()
	{
		$this->db=null;
		$this->session=null;
		$this->language=null;
		$this->message='';
		$this->error='';
		$this->_workspace='public';
		$this->limit=10;
		$this->get=(isset($_GET['get']) && !empty($_GET['get']) && is_numeric($_GET['get']) && $_GET['get']>0 ) ? $_GET['get'] : 1;
	}
	
	function show()
	{
		$html='<div align="left" style="padding:10px">';
		
		if (!isset($_GET['act']))
		{
			$html.='&nbsp;&nbsp;&nbsp;'.parent::build_anchor(ADMIN_WORKSPACE.'/&component=form&act=create','<img src="'.HOME.'/sawanna/images/create.png" width="20" height="20" border="0" align="absmiddle" hspace="5" /><b>[string]create_custom_form[/string]</b>');
		}
		$html.='<div style="border-bottom:1px solid #000000">&nbsp;</div><br />';
		
		$current=(intval($this->get)-1)*$this->limit+1;
		$co=0;
		$this->db->query("select value from ".DB_PREFIX."_global where name='custom_feedback_forms_".$this->db->escape_string($this->language->current)."' and mark='form'");
		$forms=$this->db->fetch_array();
		if (!empty($forms))
		{
			$forms=unserialize($forms['value']);
			
			foreach ($forms as $id=>$form) {
				$co++;
				if ($co<$current) continue;
				
				$html.='<div style="height:20px">'.parent::build_anchor(ADMIN_WORKSPACE.'/&component=form&act=edit&id='.$id,'<img src="'.HOME.'/sawanna/images/edit.png" width="20" height="20" title="[string]edit[/string]" border="0" align="absmiddle" />').'&nbsp;&nbsp;'.parent::build_anchor(ADMIN_WORKSPACE.'/&component=form&act=del&id='.$id,'<img src="'.HOME.'/sawanna/images/delete.png" width="20" height="20" title="[string]delete[/string]" border="0" align="absmiddle" />').'&nbsp;&nbsp;'.$form['name'].' ( '.(strlen($form['description'])>50 ? substr($form['description'],0,50) : $form['description']).' )</div>';
				if ($co>=$this->limit+$current-1) break;
			}
		}
		$count=count($forms);
		if ($count > $this->limit)
		{
			$html.='<br /><br />';
			$html.=parent::build_limiter($count,$this->limit,ADMIN_WORKSPACE.'/&component=form',$this->get,true);
		}
		
		$html.='</div>';
		
		echo $html;
	}
	
	function build_create_form()
	{
		$html='';
		
		$name=(isset($_POST['name']) && !empty($_POST['name'])) ? $_POST['name'] : '';
		$description=(isset($_POST['description']) && !empty($_POST['description'])) ? $_POST['description'] : '';
		$url=(isset($_POST['url']) && !empty($_POST['url'])) ? $_POST['url'] : '';
		$elements=array();
		foreach ($_POST as $var=>$val)
		{
			if (strpos($var,'element_name_')===0 && isset($_POST['element_type_'.substr($var,13)]))
			{
				$elements[substr($var,13)]['name']=$val;
				$elements[substr($var,13)]['type']=$_POST['element_type_'.substr($var,13)];
			}
		}
		$_access=isset($_POST['access']) ? $_POST['access'] : 1;
		$form_message=(isset($_POST['form_message']) && !empty($_POST['form_message'])) ? $_POST['form_message'] : '[string]message_example[/string]';
		
		$html='';
			
		
		$elems=array(
					'text',
					'custom',
					'text',
					'custom',
					'custom',
					'custom',
					'submit'
					);
					
		$desc=array(
					'[string]form_name[/string]*',
					'[string]form_description[/string]',
					'[string]form_url[/string]: '.$this->_workspace.'/',
					'[string]form_access[/string]',
					'[string]message[/string]',
					'',
					' '
					);
		
		$attr=array(
					'name="name" style="width:250px" value="'.$name.'"',
					'',
					'name="url" style="width:250px" value="'.$url.'"',
					'',
					'',
					'',
					'value="[string]send[/string]"'
					);
					
		$access='<select name="access" style="width:200px">';
		for ($i=0;$i<3;$i++)
		{
			switch ($i)
			{
				case 0:
					if ($_access == 1)
						$access.='<option value="1" selected>[string]full_access[/string]</option>';
					else
						$access.='<option value="1">[string]full_access[/string]</option>';
					break;
				case 1:
					if ($_access == 2)
						$access.='<option value="2" selected>[string]user_access[/string]</option>';
					else
						$access.='<option value="2">[string]user_access[/string]</option>';
					break;
				case 2:
					if ($_access == 0)
						$access.='<option value="0" selected>[string]no_access[/string]</option>';
					else
						$access.='<option value="0">[string]no_access[/string]</option>';
					break;
			}
			
		}
		$access.='</select>';

		$form_elements='<br /><div id="form_elements" style="border-top:1px solid #dddddd;border-bottom:1px solid #dddddd;padding:5px;font-size:11px">';
		$co=0;
		if (!empty($elements))
		{	
			foreach ($elements as $id=>$element)
			{	
				$form_elements.='<div id="element_'.$id.'" align="left" style="margin:10px;padding:5px 10px;background-color:#EEEEEE;border-top:1px solid DDDDDD"><div align="right"><img src="'.HOME.'/sawanna/images/delete.png" width="20" height="20" title="[string]delete[/string]" border="0" align="absmiddle" onclick="deleteElement('.$id.')" style="cursor:pointer" /></div>[string]element_name[/string]:&nbsp;&nbsp;&nbsp;<input type="text" name="element_name_'.$id.'" value="'.$element['name'].'" style="width:70%" /><br /><br /><div align="center">';
				
				switch ($element['type'])
				{	
					case 'text' :
						$form_elements.='[string]element_type[/string]:&nbsp;&nbsp;&nbsp;&nbsp;<input style="border:none" type="radio" name="element_type_'.$id.'" value="text" checked />text&nbsp;&nbsp;&nbsp;<input type="radio" style="border:none" name="element_type_'.$id.'" value="textarea" />textarea&nbsp;&nbsp;&nbsp;<input type="radio" style="border:none" name="element_type_'.$id.'" value="checkbox" />checkbox&nbsp;<br /><br />';
						break;
					case 'textarea' :
						$form_elements.='[string]element_type[/string]:&nbsp;&nbsp;&nbsp;&nbsp;<input style="border:none" type="radio" name="element_type_'.$id.'" value="text" />text&nbsp;&nbsp;&nbsp;<input type="radio" style="border:none" name="element_type_'.$id.'" value="textarea" checked />textarea&nbsp;&nbsp;&nbsp;<input type="radio" style="border:none" name="element_type_'.$id.'" value="checkbox" />checkbox&nbsp;<br /><br />';
						break;
					case 'checkbox' :
						$form_elements.='[string]element_type[/string]:&nbsp;&nbsp;&nbsp;&nbsp;<input style="border:none" type="radio" name="element_type_'.$id.'" value="text" />text&nbsp;&nbsp;&nbsp;<input type="radio" style="border:none" name="element_type_'.$id.'" value="textarea" />textarea&nbsp;&nbsp;&nbsp;<input type="radio" style="border:none" name="element_type_'.$id.'" value="checkbox" checked />checkbox&nbsp;<br /><br />';
						break;	
				}
				$required=(isset($_POST['required_'.$id]) && $_POST['required_'.$id]=='on') ? true : false;
				$form_elements.='[string]required_field[/string]:&nbsp;&nbsp;&nbsp;&nbsp;<input type="checkbox" name="required_'.$id.'"'.($required ? 'checked' : '').' /></div><br /><br /></div>';
			}
			$co=max(array_keys($elements))+1;
		}
		
		$form_elements.='</div><br /><div style="float:right"><a href="javascript:add_element()">[string]add_element[/string]</a>';
		$form_elements.='<script language="JavaScript">co='.$co.';function add_element(){ document.getElementById("form_elements").innerHTML+=\'<div id="element_\'+co+\'" align="left" style="margin:10px;padding:5px 10px;background-color:#EEEEEE;border-top:1px solid DDDDDD"><div align="right"><img src="'.HOME.'/sawanna/images/delete.png" width="20" height="20" title="[string]delete[/string]" border="0" align="absmiddle" onclick="deleteElement(\'+co+\')" style="cursor:pointer" /></div>[string]element_name[/string]:&nbsp;&nbsp;&nbsp;<input type="text" name="element_name_\'+co+\'" style="width:70%" /><br /><br /><div align="center">[string]element_type[/string]:&nbsp;&nbsp;&nbsp;&nbsp;<input type="radio" style="border:none" name="element_type_\'+co+\'" value="text" checked />text&nbsp;&nbsp;&nbsp;<input type="radio" style="border:none" name="element_type_\'+co+\'" value="textarea" />textarea&nbsp;&nbsp;&nbsp;<input type="radio" style="border:none" name="element_type_\'+co+\'" value="checkbox" />checkbox&nbsp;<br /><br />[string]required_field[/string]:&nbsp;&nbsp;&nbsp;&nbsp;<input type="checkbox" name="required_\'+co+\'" /></div><br /><br /></div>\';co++; }; function deleteElement(id){ elem_str=\'element_\'+id;document.getElementById(elem_str).innerHTML="";document.getElementById(elem_str).style.display="none"; };</script>';

		
		$custom=array(
					'',
					'<textarea name="description" cols="40" rows="5" style="width:100%">'.$description.'</textarea>',
					'',
					$access,
					'<textarea name="form_message" cols="40" rows="5" style="width:100%">'.$form_message.'</textarea>',
					$form_elements
					);
		
		$html.='<p align="left" style="padding:0px 10px">[string]create_form_str[/string]</p><br />';
		$html.=parent::build_form(ADMIN_WORKSPACE.'/&component=form&act=docreate',$elems,500,$desc,$attr,$custom);
		
		echo $html; 
	}
	
	function create()
	{
		if (empty($_POST['name'])) {
			$this->error='[string]form_name_is_required[/string]';
			$this->build_create_form();
			return;
		}
		$description=(isset($_POST['description']) && !empty($_POST['description'])) ? $_POST['description'] : '';
		$url=(isset($_POST['url']) && !empty($_POST['url'])) ? $_POST['url'] : '';
		$elements=array();
		foreach ($_POST as $var=>$val)
		{
			if (strpos($var,'element_name_')===0 && isset($_POST['element_type_'.substr($var,13)]))
			{
				$elements[substr($var,13)]['name']=$val;
				$elements[substr($var,13)]['type']=$_POST['element_type_'.substr($var,13)];
				$elements[substr($var,13)]['required']=(isset($_POST['required_'.substr($var,13)]) && $_POST['required_'.substr($var,13)]=='on') ? true : false;
			}
		}
		if (empty($elements))
		{
			$this->error='[string]form_element_is_required[/string]';
			$this->build_create_form();
			return;
		}
		$access=isset($_POST['access']) ? $_POST['access'] : 1;
		$form_message=(isset($_POST['form_message']) && !empty($_POST['form_message'])) ? $_POST['form_message'] : '[string]message_example[/string]';
		
		$forms=array();
		$exist=false;
		$co=0;
		$this->db->query("select value from ".DB_PREFIX."_global where name='custom_feedback_forms_".$this->db->escape_string($this->language->current)."' and mark='form'");
		$_forms=$this->db->fetch_array();
		if (!empty($_forms))
		{
			$forms=unserialize($_forms['value']);
			if (!empty($forms))
			{
				$co=max(array_keys($forms))+1;
			}
			$exist=true;
		}
		
		$forms[$co]['name']=htmlspecialchars($_POST['name']);
		$forms[$co]['description']=htmlspecialchars($description);
		$forms[$co]['url']=strip_tags($url);
		$forms[$co]['access']=$access;
		$forms[$co]['message']=htmlspecialchars($form_message);
		
		foreach ($elements as $id=>$element)
		{
			$forms[$co]['elements'][$id]['name']=$element['name'];
			$forms[$co]['elements'][$id]['type']=$element['type'];
			$forms[$co]['elements'][$id]['required']=$element['required'];
		}
		
		if (!$exist)
		{
			if (!$this->db->query("insert into ".DB_PREFIX."_global (name,value,mark) values ('custom_feedback_forms_".$this->db->escape_string($this->language->current)."','".$this->db->escape_string(serialize($forms))."','form')"))
			{
				$this->error='[string]database_error[/string]';
				return;
			}
		} else {
			if (!$this->db->query("update ".DB_PREFIX."_global set value='".$this->db->escape_string(serialize($forms))."' where name='custom_feedback_forms_".$this->db->escape_string($this->language->current)."' and mark='form'"))
			{
				$this->error='[string]database_error[/string]';
				return;
			}
		}
		
		$this->message='[string]form_created[/string]';
		
	}
	
	function build_edit_form()
	{
		if (!isset($_GET['id']) || !is_numeric($_GET['id'])) return;
		
		$html='';
		
		$forms=array();
		$this->db->query("select value from ".DB_PREFIX."_global where name='custom_feedback_forms_".$this->db->escape_string($this->language->current)."' and mark='form'");
		$_forms=$this->db->fetch_array();
		if (empty($_forms)) return ;
		
		$forms=unserialize($_forms['value']);
		
		if (!array_key_exists($_GET['id'],$forms)) return;
		
		$name=$forms[$_GET['id']]['name'];
		$description=$forms[$_GET['id']]['description'];
		$url=$forms[$_GET['id']]['url'];
		$elements=array();
		foreach ($forms[$_GET['id']]['elements'] as $var=>$val)
		{
			$elements[$var]['name']=$val['name'];
			$elements[$var]['type']=$val['type'];
			$elements[$var]['required']=$val['required'];
		}
		$_access=$forms[$_GET['id']]['access'];
		$form_message=$forms[$_GET['id']]['message'];
		
		$html='';
			
		
		$elems=array(
					'text',
					'custom',
					'text',
					'custom',
					'custom',
					'custom',
					'submit'
					);
					
		$desc=array(
					'[string]form_name[/string]*',
					'[string]form_description[/string]',
					'[string]form_url[/string]: '.$this->_workspace.'/',
					'[string]form_access[/string]',
					'[string]message[/string]',
					'',
					' '
					);
		
		$attr=array(
					'name="name" style="width:250px" value="'.$name.'"',
					'',
					'name="url" style="width:250px" value="'.$url.'"',
					'',
					'',
					'',
					'value="[string]send[/string]"'
					);
					
		$access='<select name="access" style="width:200px">';
		for ($i=0;$i<3;$i++)
		{
			switch ($i)
			{
				case 0:
					if ($_access == 1)
						$access.='<option value="1" selected>[string]full_access[/string]</option>';
					else
						$access.='<option value="1">[string]full_access[/string]</option>';
					break;
				case 1:
					if ($_access == 2)
						$access.='<option value="2" selected>[string]user_access[/string]</option>';
					else
						$access.='<option value="2">[string]user_access[/string]</option>';
					break;
				case 2:
					if ($_access == 0)
						$access.='<option value="0" selected>[string]no_access[/string]</option>';
					else
						$access.='<option value="0">[string]no_access[/string]</option>';
					break;
			}
			
		}
		$access.='</select>';

		$form_elements='<br /><div id="form_elements" style="border-top:1px solid #dddddd;border-bottom:1px solid #dddddd;padding:5px;font-size:11px">';
		$co=0;
		if (!empty($elements))
		{	
			foreach ($elements as $id=>$element)
			{	
				$form_elements.='<div id="element_'.$id.'" align="left" style="margin:10px;padding:5px 10px;background-color:#EEEEEE;border-top:1px solid DDDDDD"><div align="right"><img src="'.HOME.'/sawanna/images/delete.png" width="20" height="20" title="[string]delete[/string]" border="0" align="absmiddle" onclick="deleteElement('.$id.')" style="cursor:pointer" /></div>[string]element_name[/string]:&nbsp;&nbsp;&nbsp;<input type="text" name="element_name_'.$id.'" value="'.$element['name'].'" style="width:70%" /><br /><br /><div align="center">';
				
				switch ($element['type'])
				{	
					case 'text' :
						$form_elements.='[string]element_type[/string]:&nbsp;&nbsp;&nbsp;&nbsp;<input style="border:none" type="radio" name="element_type_'.$id.'" value="text" checked />text&nbsp;&nbsp;&nbsp;<input type="radio" style="border:none" name="element_type_'.$id.'" value="textarea" />textarea&nbsp;&nbsp;&nbsp;<input type="radio" style="border:none" name="element_type_'.$id.'" value="checkbox" />checkbox&nbsp;<br /><br />';
						break;
					case 'textarea' :
						$form_elements.='[string]element_type[/string]:&nbsp;&nbsp;&nbsp;&nbsp;<input style="border:none" type="radio" name="element_type_'.$id.'" value="text" />text&nbsp;&nbsp;&nbsp;<input type="radio" style="border:none" name="element_type_'.$id.'" value="textarea" checked />textarea&nbsp;&nbsp;&nbsp;<input type="radio" style="border:none" name="element_type_'.$id.'" value="checkbox" />checkbox&nbsp;<br /><br />';
						break;
					case 'checkbox' :
						$form_elements.='[string]element_type[/string]:&nbsp;&nbsp;&nbsp;&nbsp;<input style="border:none" type="radio" name="element_type_'.$id.'" value="text" />text&nbsp;&nbsp;&nbsp;<input type="radio" style="border:none" name="element_type_'.$id.'" value="textarea" />textarea&nbsp;&nbsp;&nbsp;<input type="radio" style="border:none" name="element_type_'.$id.'" value="checkbox" checked />checkbox&nbsp;<br /><br />';
						break;	
				}
				$form_elements.='[string]required_field[/string]:&nbsp;&nbsp;&nbsp;&nbsp;<input type="checkbox" name="required_'.$id.'"'.($element['required'] ? 'checked' : '').' /></div><br /><br /></div>';
			}
			$co=max(array_keys($elements))+1;
		}
		
		$form_elements.='</div><br /><div style="float:right"><a href="javascript:add_element()">[string]add_element[/string]</a>';
		$form_elements.='<script language="JavaScript">co='.$co.';function add_element(){ document.getElementById("form_elements").innerHTML+=\'<div id="element_\'+co+\'" align="left" style="margin:10px;padding:5px 10px;background-color:#EEEEEE;border-top:1px solid DDDDDD"><div align="right"><img src="'.HOME.'/sawanna/images/delete.png" width="20" height="20" title="[string]delete[/string]" border="0" align="absmiddle" onclick="deleteElement(\'+co+\')" style="cursor:pointer" /></div>[string]element_name[/string]:&nbsp;&nbsp;&nbsp;<input type="text" name="element_name_\'+co+\'" style="width:70%" /><br /><br /><div align="center">[string]element_type[/string]:&nbsp;&nbsp;&nbsp;&nbsp;<input type="radio" style="border:none" name="element_type_\'+co+\'" value="text" checked />text&nbsp;&nbsp;&nbsp;<input type="radio" style="border:none" name="element_type_\'+co+\'" value="textarea" />textarea&nbsp;&nbsp;&nbsp;<input type="radio" style="border:none" name="element_type_\'+co+\'" value="checkbox" />checkbox&nbsp;<br /><br />[string]required_field[/string]:&nbsp;&nbsp;&nbsp;&nbsp;<input type="checkbox" name="required_\'+co+\'" /></div><br /><br /></div>\';co++; }; function deleteElement(id){ elem_str=\'element_\'+id;document.getElementById(elem_str).innerHTML="";document.getElementById(elem_str).style.display="none"; };</script>';
		
		$custom=array(
					'',
					'<textarea name="description" cols="40" rows="5" style="width:100%">'.$description.'</textarea>',
					'',
					$access,
					'<textarea name="form_message" cols="40" rows="5" style="width:100%">'.$form_message.'</textarea>',
					$form_elements
					);
		
		$html.='<p align="left" style="padding:0px 10px">[string]create_form_str[/string]</p><br />';
		$html.=parent::build_form(ADMIN_WORKSPACE.'/&component=form&act=doedit&id='.$_GET['id'],$elems,500,$desc,$attr,$custom);
		
		echo $html; 
	}
	
	function edit()
	{
		
		if (!isset($_GET['id']) || !is_numeric($_GET['id'])) return;
		
		if (empty($_POST['name'])) {
			$this->error='[string]form_name_is_required[/string]';
			$this->build_edit_form();
			return;
		}
		$description=(isset($_POST['description']) && !empty($_POST['description'])) ? $_POST['description'] : '';
		$url=(isset($_POST['url']) && !empty($_POST['url'])) ? $_POST['url'] : '';
		$elements=array();
		foreach ($_POST as $var=>$val)
		{
			if (strpos($var,'element_name_')===0 && isset($_POST['element_type_'.substr($var,13)]))
			{
				$elements[substr($var,13)]['name']=$val;
				$elements[substr($var,13)]['type']=$_POST['element_type_'.substr($var,13)];
				$elements[substr($var,13)]['required']=(isset($_POST['required_'.substr($var,13)]) && $_POST['required_'.substr($var,13)]=='on') ? true : false;
			}
		}
		if (empty($elements))
		{
			$this->error='[string]form_element_is_required[/string]';
			$this->build_edit_form();
			return;
		}
		$access=isset($_POST['access']) ? $_POST['access'] : 1;
		$form_message=(isset($_POST['form_message']) && !empty($_POST['form_message'])) ? $_POST['form_message'] : '[string]message_example[/string]';
		
		$forms=array();
		$this->db->query("select value from ".DB_PREFIX."_global where name='custom_feedback_forms_".$this->db->escape_string($this->language->current)."' and mark='form'");
		$_forms=$this->db->fetch_array();
		if (empty($_forms)) return ;

		$forms=unserialize($_forms['value']);
		
		unset($forms[$_GET['id']]);
		
		$forms[$_GET['id']]['name']=htmlspecialchars($_POST['name']);
		$forms[$_GET['id']]['description']=htmlspecialchars($description);
		$forms[$_GET['id']]['url']=strip_tags($url);
		$forms[$_GET['id']]['access']=$access;
		$forms[$_GET['id']]['message']=$form_message;
		foreach ($elements as $id=>$element)
		{
			$forms[$_GET['id']]['elements'][$id]['name']=$element['name'];
			$forms[$_GET['id']]['elements'][$id]['type']=$element['type'];
			$forms[$_GET['id']]['elements'][$id]['required']=$element['required'];
		}
		
		
		if (!$this->db->query("update ".DB_PREFIX."_global set value='".$this->db->escape_string(serialize($forms))."' where name='custom_feedback_forms_".$this->db->escape_string($this->language->current)."' and mark='form'"))
		{
			$this->error='[string]database_error[/string]';
			return;
		}

		$this->message='[string]form_edited[/string]';
		
	}
	
	function build_delete_form()
	{
		if (!isset($_GET['id']) || !is_numeric($_GET['id'])) return;
		
		$this->db->query("select value from ".DB_PREFIX."_global where name='custom_feedback_forms_".$this->db->escape_string($this->language->current)."' and mark='form'");
		$_forms=$this->db->fetch_array();
		if (empty($_forms)) return ;

		$forms=unserialize($_forms['value']);
		
		$html='';
		
		$html.='<div align="left" style="padding:10px">';
		$html.='<b><em>'.htmlspecialchars($forms[$_GET['id']]['name']).'</em></b>';
		$html.='<br /><br /><span>'.htmlspecialchars($forms[$_GET['id']]['description']).'</span>';
		$html.='<p style="color:red">[string]form_delete_confirm[/string]</p>';
		$html.=parent::build_anchor(ADMIN_WORKSPACE.'/&component=form&act=dodel&id='.$_GET['id'],'<b>[string]delete[/string]</b>');
		$html.='</div>';
		
		echo $html;
	}
	
	function delete()
	{
		if (!isset($_GET['id']) || !is_numeric($_GET['id'])) return;
		
		$this->db->query("select value from ".DB_PREFIX."_global where name='custom_feedback_forms_".$this->db->escape_string($this->language->current)."' and mark='form'");
		$_forms=$this->db->fetch_array();
		if (empty($_forms)) return ;

		$forms=unserialize($_forms['value']);
		
		unset($forms[$_GET['id']]);
		
		if (!$this->db->query("update ".DB_PREFIX."_global set value='".$this->db->escape_string(serialize($forms))."' where name='custom_feedback_forms_".$this->db->escape_string($this->language->current)."' and mark='form'"))
		{
			$this->error='[string]database_error[/string]';
			return;
		}
		
		$this->message='[string]form_deleted[/string]';
	}
}

function formAdmin_init($env)
{
	global $SawannaCustomFormAdmin;
	
	$SawannaCustomFormAdmin=new CCustomFormAdmin();
	$SawannaCustomFormAdmin->db=&$env['db'];
	$SawannaCustomFormAdmin->session=&$env['session'];
	$SawannaCustomFormAdmin->language=&$env['language'];
}

function formAdmin_exec()
{
	global $SawannaCustomFormAdmin;
	
	if (isset($_GET['component']) && $_GET['component']=='form')
	{
		echo '<h2 class="header_caption"><img src="'.HOME.'/sawanna/images/wpalm.png" width="40" height="40" align="absmiddle">&nbsp;[string]custom_feedback_form[/string] :</h2>';
		echo '<p style="padding:10px 10px 0px 10px">[string]custom_feedback_form_str[/string]</p>';
		echo '<div align="center" style="padding-top:10px;padding-bottom:10px">';
		
		if (isset($_GET['act']))
		{
			switch ($_GET['act'])
			{
				case 'create' :
					$SawannaCustomFormAdmin->build_create_form();
					break;
				case 'docreate' :
					$SawannaCustomFormAdmin->create();
					break;
				case 'edit' :
					$SawannaCustomFormAdmin->build_edit_form();
					break;
				case 'doedit' :
					$SawannaCustomFormAdmin->edit();
					break;
				case 'del' :
					$SawannaCustomFormAdmin->build_delete_form();
					break;
				case 'dodel' :
					$SawannaCustomFormAdmin->delete();
					break;
			}
		}
		
		$SawannaCustomFormAdmin->show();
		
		echo '</div>';
	}
	
	return array($SawannaCustomFormAdmin->message,$SawannaCustomFormAdmin->error,'');
}

function formAdmin_clear()
{
	global $SawannaCustomFormAdmin;
	
	unset(
		$SawannaCustomFormAdmin->db,
		$SawannaCustomFormAdmin->session,
		$SawannaCustomFormAdmin->language,
		$SawannaCustomFormAdmin->message,
		$SawannaCustomFormAdmin->error,
		$SawannaCustomFormAdmin->_workspace,
		$SawannaCustomFormAdmin->get,
		$SawannaCustomFormAdmin->limit
		);
}
?>