<?php
defined("SAWANNA") or die();

class CCustomForm extends CSawanna
{
	var $db;
	var $session;
	var $language;
	var $user;
	var $message;
	var $error;
	var $workspace;
	var $query;
	var $_workspace;
	var $captcha;
	var $mail;
	
	function CCustomForm()
	{
		$this->db=null;
		$this->session=null;
		$this->language=null;
		$this->user=null;
		$this->message='';
		$this->error='';
		$this->workspace='';
		$this->query='';
		$this->_workspace='public';
		$this->captcha=null;
		$this->mail=null;
	}
	
	function build()
	{
		$html='';
		
		$this->db->query("select value from ".DB_PREFIX."_global where name='custom_feedback_forms_".$this->db->escape_string($this->language->current)."' and mark='form'");
		$forms=$this->db->fetch_array();
		if (!empty($forms))
		{
			$forms=unserialize($forms['value']);
			
			foreach ($forms as $id=>$form) {
				
				if (empty($form['url']) || $form['url']==$this->query)
				{
					$elems=array();
					$desc=array();
					$attr=array();
					$custom=array();
			
					if ($form['access']==0) continue;
					if ($form['access']==2 && $this->user->group!=2 && $this->user->group!=1) continue;
					
					if (!empty($form['description']))
					$html.='<span style="padding: 0px 10px;font-size:11px">'.$form['description'].'</span>';
					
					foreach ($form['elements'] as $var=>$val)
					{
						$elems[]='custom';
						$desc[]=$val['name'].($val['required'] ? '<font color="red">*</font>' : '');
						$attr[]='';
						
						switch ($val['type'])
						{
							case 'text' :
								$custom[]='<input type="text" style="width:100%" value="'.(isset($_POST['custom_form_element_'.$id.'_'.$var]) ? htmlspecialchars($_POST['custom_form_element_'.$id.'_'.$var]) : '').'" name="custom_form_element_'.$id.'_'.$var.'" />';
								break;
							case 'textarea' :
								$custom[]='<textarea style="width:100%" cols="50" rows="10" name="custom_form_element_'.$id.'_'.$var.'" >'.(isset($_POST['custom_form_element_'.$id.'_'.$var]) ? htmlspecialchars($_POST['custom_form_element_'.$id.'_'.$var]) : '').'</textarea>';
								break;
							case 'checkbox' :
								$custom[]='<input type="checkbox" name="custom_form_element_'.$id.'_'.$var.'" '.((isset($_POST['custom_form_element_'.$id.'_'.$var]) && $_POST['custom_form_element_'.$id.'_'.$var]=='on') ? 'checked' : '').' />';
								break;
							default :
								$custom[]='';
								break;
						}
					}
					
					$elems[]='custom';
					$elems[]='text';
					$elems[]='hidden';
					$elems[]='submit';
					
					$desc[]=' ';
					$desc[]='[string]enter_code[/string]';
					$desc[]='';
					$desc[]=' ';
					
					$attr[]='';
					$attr[]='name="captcha" style="width:100px"';
					$attr[]='name="custom_form" value="'.$id.'"';
					$attr[]='value="[string]send[/string]"';
					
					$custom[]='<img src="'.parent::build_url('captcha').'" width="100" height="30" border="1" />';
					
					$html.='<div style="padding:20px" align="center">';
					$html.=parent::build_form($this->workspace.'/'.$this->query,$elems,'500',$desc,$attr,$custom,'form');
					$html.='</div>';
					
					unset(
						$elems,
						$desc,
						$attr,
						$custom
						);
				}
			}
		}
		
		echo $html;
	}
	
	function save()
	{
		$message='';
		
		if (!isset($_POST['custom_form'])) return;
		
		if (!isset($_POST['captcha']) || empty($_POST['captcha']))
		{
			$this->error="[string]captcha_not_match[/string]";
			return;
		}
		
		if (!$this->captcha->check($_POST['captcha']))
		{
			$this->error="[string]captcha_not_match[/string]";
			return;
		}
		
		$this->db->query("select value from ".DB_PREFIX."_global where name='custom_feedback_forms_".$this->db->escape_string($this->language->current)."' and mark='form'");
		$forms=$this->db->fetch_array();
		if (!empty($forms))
		{
			$forms=unserialize($forms['value']);
			
			if (!isset($forms[$_POST['custom_form']])) return;
			
			$message.='<h1>'.$forms[$_POST['custom_form']]['name'].'</h1><hr /><br />';
			
			foreach ($forms[$_POST['custom_form']]['elements'] as $var=>$val)
			{
				if ($val['required'] && (!isset($_POST['custom_form_element_'.$_POST['custom_form'].'_'.$var]) || empty($_POST['custom_form_element_'.$_POST['custom_form'].'_'.$var])))
				{
					$this->error='[string]marked_fields_are_required[/string]';
					return;
				}
				
				$message.='<b>'.$val['name'].':</b> '.((isset($_POST['custom_form_element_'.$_POST['custom_form'].'_'.$var]) && !empty($_POST['custom_form_element_'.$_POST['custom_form'].'_'.$var])) ? nl2br(strip_tags($_POST['custom_form_element_'.$_POST['custom_form'].'_'.$var])) : '-').'<br /><br />';
			}
			
			if ($this->user->group!=0)
			{
				$username=(!empty($this->user->name)) ? $this->user->name : '--';
				$message.='<br /><hr /><br />';
				$message.="From : ".$username." (Login : ".$this->user->login.")<br />";
				$message.="E-Mail : ".$this->user->mail."<br />";
			}
			
			if (!$this->mail->sendMail(ADMIN_MAIL,SEND_MAIL_FROM,SEND_MAIL_FROM_NAME,SITE_HOST.': '.$forms[$_POST['custom_form']]['name'],$message))
			{
				$this->error="[string]mail_send_failed_str[/string]";
				return;
			}
		
			if (empty($this->error))
			{
				$this->message=$forms[$_POST['custom_form']]['message'];
				
				foreach ($_POST as $var=>$val)
				{
					unset ($_POST[$var]);
				}
			}
		}
	}
}

function form_init($env)
{
	global $SawannaCustomForm;
	
	$SawannaCustomForm=new CCustomForm();
	$SawannaCustomForm->db=&$env['db'];
	$SawannaCustomForm->session=&$env['session'];
	$SawannaCustomForm->language=&$env['language'];
	$SawannaCustomForm->user=&$env['user'];
	$SawannaCustomForm->workspace=$env['workspace'];
	$SawannaCustomForm->query=$env['query'];
	$SawannaCustomForm->captcha=&$env['captcha'];
	$SawannaCustomForm->mail=&$env['mail'];
}

function form_exec()
{
	global $SawannaCustomForm;
	
	if ($SawannaCustomForm->workspace == $SawannaCustomForm->_workspace)
	{
		if (isset($_POST['custom_form']) && is_numeric($_POST['custom_form']))
		$SawannaCustomForm->save();
		
		$SawannaCustomForm->build();
		
		return array($SawannaCustomForm->message,$SawannaCustomForm->error,'');
	}
}

function form_clear()
{
	global $SawannaCustomForm;
	
	unset(
		$SawannaCustomForm->db,
		$SawannaCustomForm->session,
		$SawannaCustomForm->language,
		$SawannaCustomForm->user,
		$SawannaCustomForm->message,
		$SawannaCustomForm->error,
		$SawannaCustomForm->_workspace,
		$SawannaCustomForm->workspace,
		$SawannaCustomForm->query,
		$SawannaCustomForm->captcha,
		$SawannaCustomForm->mail
		);
}
?>