<?php
defined("SAWANNA") or die();

class CSawannaOnline extends CSawanna
{
	var $db;
	var $session;
	var $language;
	var $user;
	var $delta;
	
	function CSawannaOnline()
	{
		$this->db=null;
		$this->session=null;
		$this->language=null;
		$this->user=null;
		$this->delta=300; // time in seconds
	}
	
	function build()
	{
		$html='';
		
		$this->db->query("select value from ".DB_PREFIX."_global where name='sawanna_online' and mark='online'");
		$sawanna_global=$this->db->fetch_array();
		
		if (empty($sawanna_global)) return;
		
		$sawanna_online=unserialize($sawanna_global['value']);
		if (empty($sawanna_online) || !is_array($sawanna_online)) return;
		
		if(!array_key_exists('ulogin',$sawanna_online) || !is_array($sawanna_online['ulogin'])) return ;
		if(!array_key_exists('ugroup',$sawanna_online) || !is_array($sawanna_online['ugroup'])) return ;
		if(!array_key_exists('ugender',$sawanna_online) || !is_array($sawanna_online['ugender'])) return ;
		if(!array_key_exists('ulogtime',$sawanna_online) || !is_array($sawanna_online['ulogtime'])) return ;
		
		$sawanna_online['ulogin'][$this->session->sid]=$this->user->login;
		$sawanna_online['ugroup'][$this->session->sid]=$this->user->group;
		$sawanna_online['ugender'][$this->session->sid]=$this->user->gender;
		$sawanna_online['ulogtime'][$this->session->sid]=time();
	
		$now=time();
		$expired=array();
		$users=array();
		$guests=array();
		foreach ($sawanna_online['ulogtime'] as $sid=>$time)
		{
			if ($time < $now-$this->delta)
			{
				$expired[]=$sid;
			} else 
			{
				if (empty($sawanna_online['ulogin'][$sid]) || empty($sawanna_online['ugroup'][$sid]))
				{
					$guests[]=$sid;
				} else 
				{
					$users[]=$sid;
				}
			}
		}
		
		if (!empty($expired))
		{
			foreach($expired as $exp)
			{
				unset($sawanna_online['ulogin'][$exp]);
				unset($sawanna_online['ugroup'][$exp]);
				unset($sawanna_online['ugender'][$exp]);
				unset($sawanna_online['ulogtime'][$exp]);
			}
		}
		
		$this->db->query("update ".DB_PREFIX."_global set value='".$this->db->escape_string(serialize($sawanna_online))."' where name='sawanna_online' and mark='online'");
		
		if (!empty($users))
		{
			
			$html.='<div style="float:normal"><b>[string]users_online[/string]:</b><br />';
			foreach ($users as $usid)
			{
				if (empty($sawanna_online['ugroup'])) continue;
				
				$gender='';
				if (!empty($sawanna_online['ugender'][$usid]))
				{
					switch ($sawanna_online['ugender'][$usid])
					{
						case 'M' :
							$gender.='<img src="'.HOME.'/sawanna/images/male.gif" width="15" height="15" align="bottom" border="0" />&nbsp;';
							break;
						case 'F' :
							$gender.='<img src="'.HOME.'/sawanna/images/female.gif" width="15" height="15" align="bottom" border="0" />&nbsp;';
							break;
					}
				}
				
				if ($this->user->group != 0)
				{
					if ($sawanna_online['ugroup'][$usid]==1)
					{
						$html.='<div>'.$gender.parent::build_anchor('user/view/'.$sawanna_online['ulogin'][$usid],'<span style="font-size:12px;font-weight:bold;color:#ed273e">'.$sawanna_online['ulogin'][$usid].'</span>').'</div>';
					} else 
					{
						$html.='<div>'.$gender.parent::build_anchor('user/view/'.$sawanna_online['ulogin'][$usid],'<span style="font-weight:bold;color:#333333;font-size:12px">'.$sawanna_online['ulogin'][$usid].'</span>').'</div>';
					}
				} else 
				{
					if ($sawanna_online['ugroup'][$usid]==1)
					{
						$html.='<div style="width:80px;height:20px;font-size:12px;font-weight:bold;color:#ed273e">'.$gender.$sawanna_online['ulogin'][$usid].'</div>';
					} else 
					{
						$html.='<div style="width:80px;height:20px;font-weight:bold;color:#333333;font-size:12px">'.$gender.$sawanna_online['ulogin'][$usid].'</div>';
					}
				}
			}
			$html.='</div><br clear="all" />';
		}
		
		if (!empty($guests))
		{
			$html.='<div style="float:normal"><b>[string]guests_online[/string]: '.count($guests).'</b></div><br />';
		}
		
		if (!empty($html))
		{
			echo '<div class="field_caption">[string]online[/string]</div>';
			echo '<div class="field_body"><div style="float:normal;padding:5px">'.$html.'</div></div>';
			echo '<div style="width:100%" class="shadow_1"></div>';
		}
	}
}

function online_init($env)
{
	global $SawannaOnline;
	
	$SawannaOnline=new CSawannaOnline();
	$SawannaOnline->db=&$env['db'];
	$SawannaOnline->session=&$env['session'];
	$SawannaOnline->language=&$env['language'];
	$SawannaOnline->user=&$env['user'];
}

function online_exec()
{
	global $SawannaOnline;
	
	$SawannaOnline->build();
}

function online_clear()
{
	global $SawannaOnline;
	
	unset(
		$SawannaOnline->db,
		$SawannaOnline->session,
		$SawannaOnline->language,
		$SawannaOnline->user,
		$SawannaOnline->delta
		);
}
?>