<?php
defined("SAWANNA") or die();

class CPollFormAdmin extends CSawanna
{
	var $db;
	var $session;
	var $language;
	var $message;
	var $error;
	var $get;
	var $limit;
	var $_workspace;
	
	function CPollFormAdmin()
	{
		$this->db=null;
		$this->session=null;
		$this->language=null;
		$this->message='';
		$this->error='';
		$this->_workspace='public';
		$this->limit=10;
		$this->get=(isset($_GET['get']) && !empty($_GET['get']) && is_numeric($_GET['get']) && $_GET['get']>0 ) ? $_GET['get'] : 1;
	}
	
	function show()
	{
		$html='<div align="left" style="padding:10px">';
		
		if (!isset($_GET['act']))
		{
			$html.='&nbsp;&nbsp;&nbsp;'.parent::build_anchor(ADMIN_WORKSPACE.'/&component=poll&act=create','<img src="'.HOME.'/sawanna/images/create.png" width="20" height="20" border="0" align="absmiddle" hspace="5" /><b>[string]create_poll_form[/string]</b>');
		}
		$html.='<div style="border-bottom:1px solid #000000">&nbsp;</div><br />';
		
		$current=(intval($this->get)-1)*$this->limit+1;
		$co=0;
		$this->db->query("select value from ".DB_PREFIX."_global where name='poll_forms_".$this->db->escape_string($this->language->current)."' and mark='poll'");
		$forms=$this->db->fetch_array();
		if (!empty($forms))
		{
			$forms=unserialize($forms['value']);
			
			foreach ($forms as $id=>$form) {
				$co++;
				if ($co<$current) continue;
				
				$html.='<div style="height:20px">'.parent::build_anchor(ADMIN_WORKSPACE.'/&component=poll&act=edit&id='.$id,'<img src="'.HOME.'/sawanna/images/edit.png" width="20" height="20" title="[string]edit[/string]" border="0" align="absmiddle" />').'&nbsp;&nbsp;'.parent::build_anchor(ADMIN_WORKSPACE.'/&component=poll&act=del&id='.$id,'<img src="'.HOME.'/sawanna/images/delete.png" width="20" height="20" title="[string]delete[/string]" border="0" align="absmiddle" />').'&nbsp;&nbsp;'.$form['subject'].'</div>';
				if ($co>=$this->limit+$current-1) break;
			}
		}
		$count=count($forms);
		if ($count > $this->limit)
		{
			$html.='<br /><br />';
			$html.=parent::build_limiter($count,$this->limit,ADMIN_WORKSPACE.'/&component=poll',$this->get,true);
		}
		
		$html.='</div>';
		
		echo $html;
	}
	
	function build_create_form()
	{
		$html='';
		
		$name=(isset($_POST['subject']) && !empty($_POST['subject'])) ? $_POST['subject'] : '';
		$url=(isset($_POST['url']) && !empty($_POST['url'])) ? $_POST['url'] : '';
		$elements=array();
		foreach ($_POST as $var=>$val)
		{
			if (strpos($var,'element_name_')===0)
			{
				$elements[substr($var,13)]=$val;
			}
		}
		$_access=isset($_POST['access']) ? $_POST['access'] : 1;
		
		$html='';
			
		
		$elems=array(
					'text',
					'text',
					'custom',
					'custom',
					'submit'
					);
					
		$desc=array(
					'[string]poll_subject[/string]*',
					'[string]poll_url[/string]: '.$this->_workspace.'/',
					'[string]poll_access[/string]',
					'',
					' '
					);
		
		$attr=array(
					'name="subject" style="width:250px" value="'.$name.'"',
					'name="url" style="width:250px" value="'.$url.'"',
					'',
					'',
					'value="[string]send[/string]"'
					);
					
		$access='<select name="access" style="width:200px">';
		for ($i=0;$i<3;$i++)
		{
			switch ($i)
			{
				case 0:
					if ($_access == 1)
						$access.='<option value="1" selected>[string]full_access[/string]</option>';
					else
						$access.='<option value="1">[string]full_access[/string]</option>';
					break;
				case 1:
					if ($_access == 2)
						$access.='<option value="2" selected>[string]user_access[/string]</option>';
					else
						$access.='<option value="2">[string]user_access[/string]</option>';
					break;
				case 2:
					if ($_access == 0)
						$access.='<option value="0" selected>[string]no_access[/string]</option>';
					else
						$access.='<option value="0">[string]no_access[/string]</option>';
					break;
			}
			
		}
		$access.='</select>';

		$form_elements='<br /><div id="form_elements" style="border-top:1px solid #dddddd;border-bottom:1px solid #dddddd;padding:5px;font-size:11px">';
		$co=0;
		if (!empty($elements))
		{	
			foreach ($elements as $id=>$element)
			{	
				$form_elements.='<div id="element_'.$id.'" align="left" style="margin:10px;padding:5px 10px;background-color:#EEEEEE;border-top:1px solid DDDDDD"><div align="right"><img src="'.HOME.'/sawanna/images/delete.png" width="20" height="20" title="[string]delete[/string]" border="0" align="absmiddle" onclick="deleteElement('.$id.')" style="cursor:pointer" /></div>[string]poll_element_name[/string]:&nbsp;&nbsp;&nbsp;<input type="text" name="element_name_'.$id.'" value="'.$element.'" style="width:70%" /><br /><br /></div>';
			}
			$co=max(array_keys($elements))+1;
		}
		
		$form_elements.='</div><br /><div style="float:right"><a href="javascript:add_element()">[string]add_poll_element[/string]</a>';
		$form_elements.='<script language="JavaScript">co='.$co.';function add_element(){ document.getElementById("form_elements").innerHTML+=\'<div id="element_\'+co+\'" align="left" style="margin:10px;padding:5px 10px;background-color:#EEEEEE;border-top:1px solid DDDDDD"><div align="right"><img src="'.HOME.'/sawanna/images/delete.png" width="20" height="20" title="[string]delete[/string]" border="0" align="absmiddle" onclick="deleteElement(\'+co+\')" style="cursor:pointer" /></div>[string]poll_element_name[/string]:&nbsp;&nbsp;&nbsp;<input type="text" name="element_name_\'+co+\'" style="width:70%" /><br /><br /></div>\';co++; }; function deleteElement(id){ elem_str=\'element_\'+id;document.getElementById(elem_str).innerHTML="";document.getElementById(elem_str).style.display="none"; };</script>';

		
		$custom=array(
					'',
					'',
					$access,
					$form_elements
					);
		
		$html.='<p align="left" style="padding:0px 10px">[string]create_poll_str[/string]</p><br />';
		$html.=parent::build_form(ADMIN_WORKSPACE.'/&component=poll&act=docreate',$elems,500,$desc,$attr,$custom);
		
		echo $html; 
	}
	
	function create()
	{
		if (empty($_POST['subject'])) {
			$this->error='[string]poll_subject_is_required[/string]';
			$this->build_create_form();
			return;
		}
		$url=(isset($_POST['url']) && !empty($_POST['url'])) ? $_POST['url'] : '';
		$elements=array();
		foreach ($_POST as $var=>$val)
		{
			if (strpos($var,'element_name_')===0 && !empty($val))
			{
				$elements[substr($var,13)]=$val;
			}
		}
		if (empty($elements) || count($elements)<2)
		{
			$this->error='[string]poll_element_is_required[/string]';
			$this->build_create_form();
			return;
		}
		$access=isset($_POST['access']) ? $_POST['access'] : 1;
		
		$forms=array();
		$exist=false;
		$co=0;
		$this->db->query("select value from ".DB_PREFIX."_global where name='poll_forms_".$this->db->escape_string($this->language->current)."' and mark='poll'");
		$_forms=$this->db->fetch_array();
		if (!empty($_forms))
		{
			$forms=unserialize($_forms['value']);
			if (!empty($forms))
			{
				$co=max(array_keys($forms))+1;
			}
			$exist=true;
		}
		
		$forms[$co]['subject']=htmlspecialchars($_POST['subject']);
		$forms[$co]['url']=strip_tags($url);
		$forms[$co]['access']=$access;
		
		foreach ($elements as $id=>$element)
		{
			$forms[$co]['elements'][$id]=$element;
			$forms[$co]['results'][$id]=0;
		}
		
		$forms[$co]['users']=array();
		
		if (!$exist)
		{
			if (!$this->db->query("insert into ".DB_PREFIX."_global (name,value,mark) values ('poll_forms_".$this->db->escape_string($this->language->current)."','".$this->db->escape_string(serialize($forms))."','poll')"))
			{
				$this->error='[string]database_error[/string]';
				return;
			}
		} else {
			if (!$this->db->query("update ".DB_PREFIX."_global set value='".$this->db->escape_string(serialize($forms))."' where name='poll_forms_".$this->db->escape_string($this->language->current)."' and mark='poll'"))
			{
				$this->error='[string]database_error[/string]';
				return;
			}
		}
		
		$this->message='[string]poll_created[/string]';
		
	}
	
	function build_edit_form()
	{
		if (!isset($_GET['id']) || !is_numeric($_GET['id'])) return;
		
		$html='';
		
		$forms=array();
		$this->db->query("select value from ".DB_PREFIX."_global where name='poll_forms_".$this->db->escape_string($this->language->current)."' and mark='poll'");
		$_forms=$this->db->fetch_array();
		if (empty($_forms)) return ;
		
		$forms=unserialize($_forms['value']);
		
		if (!array_key_exists($_GET['id'],$forms)) return;
		
		$name=$forms[$_GET['id']]['subject'];
		$url=$forms[$_GET['id']]['url'];
		$elements=array();
		foreach ($forms[$_GET['id']]['elements'] as $var=>$val)
		{
			$elements[$var]=$val;
		}
		$_access=$forms[$_GET['id']]['access'];
		
		$html='';
			
		
		$elems=array(
					'text',
					'text',
					'custom',
					'custom',
					'submit'
					);
					
		$desc=array(
					'[string]poll_subject[/string]*',
					'[string]poll_url[/string]: '.$this->_workspace.'/',
					'[string]poll_access[/string]',
					'',
					' '
					);
		
		$attr=array(
					'name="subject" style="width:250px" value="'.$name.'"',
					'name="url" style="width:250px" value="'.$url.'"',
					'',
					'',
					'value="[string]send[/string]"'
					);
					
		$access='<select name="access" style="width:200px">';
		for ($i=0;$i<3;$i++)
		{
			switch ($i)
			{
				case 0:
					if ($_access == 1)
						$access.='<option value="1" selected>[string]full_access[/string]</option>';
					else
						$access.='<option value="1">[string]full_access[/string]</option>';
					break;
				case 1:
					if ($_access == 2)
						$access.='<option value="2" selected>[string]user_access[/string]</option>';
					else
						$access.='<option value="2">[string]user_access[/string]</option>';
					break;
				case 2:
					if ($_access == 0)
						$access.='<option value="0" selected>[string]no_access[/string]</option>';
					else
						$access.='<option value="0">[string]no_access[/string]</option>';
					break;
			}
			
		}
		$access.='</select>';

		$form_elements='<br /><div id="form_elements" style="border-top:1px solid #dddddd;border-bottom:1px solid #dddddd;padding:5px;font-size:11px">';
		$co=0;
		if (!empty($elements))
		{	
			foreach ($elements as $id=>$element)
			{	
				$form_elements.='<div id="element_'.$id.'" align="left" style="margin:10px;padding:5px 10px;background-color:#EEEEEE;border-top:1px solid DDDDDD"><div align="right"><img src="'.HOME.'/sawanna/images/delete.png" width="20" height="20" title="[string]delete[/string]" border="0" align="absmiddle" onclick="deleteElement('.$id.')" style="cursor:pointer" /></div>[string]poll_element_name[/string]:&nbsp;&nbsp;&nbsp;<input type="text" name="element_name_'.$id.'" value="'.$element.'" style="width:70%" /><br /><br /></div>';
			}
			$co=max(array_keys($elements))+1;
		}
		
		$form_elements.='</div><br /><div style="float:right"><a href="javascript:add_element()">[string]add_element[/string]</a>';
		$form_elements.='<script language="JavaScript">co='.$co.';function add_element(){ document.getElementById("form_elements").innerHTML+=\'<div id="element_\'+co+\'" align="left" style="margin:10px;padding:5px 10px;background-color:#EEEEEE;border-top:1px solid DDDDDD"><div align="right"><img src="'.HOME.'/sawanna/images/delete.png" width="20" height="20" title="[string]delete[/string]" border="0" align="absmiddle" onclick="deleteElement(\'+co+\')" style="cursor:pointer" /></div>[string]poll_element_name[/string]:&nbsp;&nbsp;&nbsp;<input type="text" name="element_name_\'+co+\'" style="width:70%" /><br /><br /></div>\';co++; }; function deleteElement(id){ elem_str=\'element_\'+id;document.getElementById(elem_str).innerHTML="";document.getElementById(elem_str).style.display="none"; };</script>';

		
		$custom=array(
					'',
					'',
					$access,
					$form_elements
					);
		
		$html.='<p align="left" style="padding:0px 10px">[string]poll_str[/string]</p><br />';
		$html.=parent::build_form(ADMIN_WORKSPACE.'/&component=poll&act=doedit&id='.$_GET['id'],$elems,500,$desc,$attr,$custom);
		
		echo $html; 
	}
	
	function edit()
	{
		
		if (!isset($_GET['id']) || !is_numeric($_GET['id'])) return;
		
		if (empty($_POST['subject'])) {
			$this->error='[string]poll_subject_is_required[/string]';
			$this->build_edit_form();
			return;
		}
		$url=(isset($_POST['url']) && !empty($_POST['url'])) ? $_POST['url'] : '';
		$elements=array();
		foreach ($_POST as $var=>$val)
		{
			if (strpos($var,'element_name_')===0 && !empty($val))
			{
				$elements[substr($var,13)]=$val;
			}
		}
		if (empty($elements) || count($elements)<2)
		{
			$this->error='[string]poll_element_is_required[/string]';
			$this->build_edit_form();
			return;
		}
		$access=isset($_POST['access']) ? $_POST['access'] : 1;
		
		$forms=array();
		$this->db->query("select value from ".DB_PREFIX."_global where name='poll_forms_".$this->db->escape_string($this->language->current)."' and mark='poll'");
		$_forms=$this->db->fetch_array();
		if (empty($_forms)) return ;

		$forms=unserialize($_forms['value']);
		
		unset($forms[$_GET['id']]);
		
		$forms[$_GET['id']]['subject']=htmlspecialchars($_POST['subject']);
		$forms[$_GET['id']]['url']=strip_tags($url);
		$forms[$_GET['id']]['access']=$access;
		foreach ($elements as $id=>$element)
		{
			$forms[$_GET['id']]['elements'][$id]=$element;
			$forms[$_GET['id']]['results'][$id]=0;
		}
		$forms[$_GET['id']]['users']=array();
		
		if (!$this->db->query("update ".DB_PREFIX."_global set value='".$this->db->escape_string(serialize($forms))."' where name='poll_forms_".$this->db->escape_string($this->language->current)."' and mark='poll'"))
		{
			$this->error='[string]database_error[/string]';
			return;
		}

		$this->message='[string]poll_edited[/string]';
		
	}
	
	function build_delete_form()
	{
		if (!isset($_GET['id']) || !is_numeric($_GET['id'])) return;
		
		$this->db->query("select value from ".DB_PREFIX."_global where name='poll_forms_".$this->db->escape_string($this->language->current)."' and mark='poll'");
		$_forms=$this->db->fetch_array();
		if (empty($_forms)) return ;

		$forms=unserialize($_forms['value']);
		
		$html='';
		
		$html.='<div align="left" style="padding:10px">';
		$html.='<b><em>'.htmlspecialchars($forms[$_GET['id']]['subject']).'</em></b>';
		$html.='<p style="color:red">[string]poll_delete_confirm[/string]</p>';
		$html.=parent::build_anchor(ADMIN_WORKSPACE.'/&component=poll&act=dodel&id='.$_GET['id'],'<b>[string]delete[/string]</b>');
		$html.='</div>';
		
		echo $html;
	}
	
	function delete()
	{
		if (!isset($_GET['id']) || !is_numeric($_GET['id'])) return;
		
		$this->db->query("select value from ".DB_PREFIX."_global where name='poll_forms_".$this->db->escape_string($this->language->current)."' and mark='poll'");
		$_forms=$this->db->fetch_array();
		if (empty($_forms)) return ;

		$forms=unserialize($_forms['value']);
		
		unset($forms[$_GET['id']]);
		
		if (!$this->db->query("update ".DB_PREFIX."_global set value='".$this->db->escape_string(serialize($forms))."' where name='poll_forms_".$this->db->escape_string($this->language->current)."' and mark='poll'"))
		{
			$this->error='[string]database_error[/string]';
			return;
		}
		
		$this->message='[string]poll_deleted[/string]';
	}
}

function pollAdmin_init($env)
{
	global $SawannaPollFormAdmin;
	
	$SawannaPollFormAdmin=new CPollFormAdmin();
	$SawannaPollFormAdmin->db=&$env['db'];
	$SawannaPollFormAdmin->session=&$env['session'];
	$SawannaPollFormAdmin->language=&$env['language'];
}

function pollAdmin_exec()
{
	global $SawannaPollFormAdmin;
	
	if (isset($_GET['component']) && $_GET['component']=='poll')
	{
		echo '<h2 class="header_caption"><img src="'.HOME.'/sawanna/images/wpalm.png" width="40" height="40" align="absmiddle">&nbsp;[string]poll[/string] :</h2>';
		echo '<p style="padding:10px 10px 0px 10px">[string]poll_str[/string]</p>';
		echo '<div align="center" style="padding-top:10px;padding-bottom:10px">';
		
		if (isset($_GET['act']))
		{
			switch ($_GET['act'])
			{
				case 'create' :
					$SawannaPollFormAdmin->build_create_form();
					break;
				case 'docreate' :
					$SawannaPollFormAdmin->create();
					break;
				case 'edit' :
					$SawannaPollFormAdmin->build_edit_form();
					break;
				case 'doedit' :
					$SawannaPollFormAdmin->edit();
					break;
				case 'del' :
					$SawannaPollFormAdmin->build_delete_form();
					break;
				case 'dodel' :
					$SawannaPollFormAdmin->delete();
					break;
			}
		}
		
		$SawannaPollFormAdmin->show();
		
		echo '</div>';
	}
	
	return array($SawannaPollFormAdmin->message,$SawannaPollFormAdmin->error,'');
}

function pollAdmin_clear()
{
	global $SawannaPollFormAdmin;
	
	unset(
		$SawannaPollFormAdmin->db,
		$SawannaPollFormAdmin->session,
		$SawannaPollFormAdmin->language,
		$SawannaPollFormAdmin->message,
		$SawannaPollFormAdmin->error,
		$SawannaPollFormAdmin->_workspace,
		$SawannaPollFormAdmin->get,
		$SawannaPollFormAdmin->limit
		);
}
?>