<?php
defined("SAWANNA") or die();

class CPollForm extends CSawanna
{
	var $db;
	var $session;
	var $language;
	var $user;
	var $navigator;
	var $node;
	var $workspace;
	var $query;
	var $_workspace;
	
	function CPollForm()
	{
		$this->db=null;
		$this->session=null;
		$this->language=null;
		$this->user=null;
		$this->navigator=null;
		$this->node=null;
		$this->workspace='';
		$this->query='';
		$this->_workspace='public';
	}
	
	function build()
	{
		if ($this->workspace==FRONT_PAGE_WORKSPACE)
		{
			$result=$this->navigator->get(array('parent'=>0));
			while ($menu=$this->db->fetch_array($result)) {
				if (($p=strpos($menu['link'],'/'))===false) continue;
				if (substr($menu['link'],0,$p) != $this->_workspace) continue;
				
				$node=array('workspace'=>$this->_workspace,'link'=>substr($menu['link'],$p+1),'mark'=>'');
				$result=$this->node->get($node);
				if (!empty($result))
				{
					$this->query=$node['link'];
					break;
				}
			}
		}

		$html='';
		
		$this->db->query("select value from ".DB_PREFIX."_global where name='poll_forms_".$this->db->escape_string($this->language->current)."' and mark='poll'");
		$forms=$this->db->fetch_array();
		if (!empty($forms))
		{
			$forms=unserialize($forms['value']);
			
			if (isset($this->session->var['poll']))
			{
				$polls=unserialize($this->session->var['poll']);
			}
				
			foreach ($forms as $id=>$form) {
				
				$already_polled=false;
		
				if (empty($form['url']) || $form['url']==$this->query)
				{
					$elems=array();
					$desc=array();
					$attr=array();
					$custom=array();
			
					if ($form['access']==0) continue;
					if ($form['access']==2 && $this->user->group!=2 && $this->user->group!=1) continue;
					
					if ($form['access']==1 && isset($polls) && in_array($id,$polls)) $already_polled=true;
					if ($form['access']==2 && in_array($this->user->id,$form['users'])) $already_polled=true;
					
					$html.='<div style="padding:10px"><span style="font-size:11px">'.$form['subject'].'</span></div>';
					
					$summ=array_sum($form['results']);
					
					foreach ($form['elements'] as $var=>$val)
					{
						if (!$already_polled)
						{
							$elems[]='radio';
							$desc[]='<div>'.$val.'</div>';
							$attr[]='name="poll_element_'.$id.'" value="poll_element_'.$var.'"';
							$custom[]='';
						} else 
						{
							$elems[]='custom';
							$desc[]='<div>'.$val.'</div>';
							$attr[]='';
							$custom[]='-&nbsp;<span style="color:#4567e7;font-weight:bold;font-size:12px;padding-left:5px">'.(!empty($form['results'][$var]) ? $form['results'][$var] : '<font color="#ec4b71">0</font>').'</span>';
							
							$percent=($summ!=0) ? round(($form['results'][$var]/$summ)*100) : 0;
							$elems[]='custom';
							$desc[]='';
							$attr[]='';
							$custom[]='<div style="color:black;font-weight:bold;font-size:10px;width:100px">'.$percent.'%</div><div style="background-color:#EEEEEE;width:100px;margin-bottom:20px" align="left"><img src="'.HOME.'/sawanna/images/window_middle.gif" width="'.$percent.'" height="10" /></div>';
							
						}
					}
					
					if (!$already_polled)
					{
						$elems[]='';
						$elems[]='hidden';
						$elems[]='submit';
						
						$desc[]='<div style="height:20px"></div>';
						$desc[]='';
						$desc[]='';
						
						$attr[]='';
						$attr[]='name="poll_form" value="'.$id.'"';
						$attr[]='value="[string]send[/string]"';
					}
					
					$html.='<div style="padding:10px" align="center">';
					
					if ($this->workspace != FRONT_PAGE_WORKSPACE) 
						$html.=parent::build_form($this->workspace.'/'.$this->query,$elems,'120',$desc,$attr,$custom);
					else 
						$html.=parent::build_form(FRONT_PAGE_WORKSPACE,$elems,'120',$desc,$attr,$custom);
						
					$html.='</div>';
					
					unset(
						$elems,
						$desc,
						$attr
						);
				}
			}
		}
		
		if (!empty($html))
		{
			echo '<div class="field_caption">[string]poll[/string]</div>';
			echo '<div class="field_body">'.$html.'</div>';
			echo '<div style="width:100%" class="shadow_1"></div>';
		}
	}
	
	function save()
	{
		if (isset($this->session->var['poll']))
		{
			$polls=unserialize($this->session->var['poll']);
			if (in_array($_POST['poll_form'],$polls)) return;
		}
		
		if (!isset($_POST['poll_form'])) return;
		if (!isset($_POST['poll_element_'.$_POST['poll_form']]) || empty($_POST['poll_element_'.$_POST['poll_form']])) return ;
		
		$this->db->query("select value from ".DB_PREFIX."_global where name='poll_forms_".$this->db->escape_string($this->language->current)."' and mark='poll'");
		$forms=$this->db->fetch_array();
		if (!empty($forms))
		{
			$forms=unserialize($forms['value']);
			
			if (!isset($forms[$_POST['poll_form']])) return;
			if (!isset($forms[$_POST['poll_form']]['elements'][substr($_POST['poll_element_'.$_POST['poll_form']],13)])) return;
			
			if ($forms[$_POST['poll_form']]['access']==0) return;
		}
		
		if ($forms[$_POST['poll_form']]['access']!=1)
		{
			if (!empty($this->user->id) && !in_array($this->user->id,$forms[$_POST['poll_form']]['users']))
			{
				$forms[$_POST['poll_form']]['users'][]=$this->user->id;
				$forms[$_POST['poll_form']]['results'][substr($_POST['poll_element_'.$_POST['poll_form']],13)]++;
			}
		} else 
		{
			if (!isset($this->session->var['poll']))
			{
				$this->session->register('poll',serialize(array($_POST['poll_form'])));
				setcookie('poll',serialize(array($_POST['poll_form'])),time()+2592000,'/','.'.SITE_HOST);
			} else 
			{
				$poll=unserialize($this->session->var['poll']);
				$poll[]=$_POST['poll_form'];
				$this->session->register('poll',serialize($poll));
				setcookie('poll',serialize($poll),time()+2592000,'/','.'.SITE_HOST);
			}
			
			$forms[$_POST['poll_form']]['results'][substr($_POST['poll_element_'.$_POST['poll_form']],13)]++;
		}
		
		$this->db->query("update ".DB_PREFIX."_global set value='".$this->db->escape_string(serialize($forms))."' where name='poll_forms_".$this->db->escape_string($this->language->current)."' and mark='poll'");
		
	}
}

function poll_init($env)
{
	global $SawannaPollForm;
	
	$SawannaPollForm=new CPollForm();
	$SawannaPollForm->db=&$env['db'];
	$SawannaPollForm->session=&$env['session'];
	$SawannaPollForm->language=&$env['language'];
	$SawannaPollForm->user=&$env['user'];
	$SawannaPollForm->navigator=&$env['navigator'];
	$SawannaPollForm->node=&$env['node'];
	$SawannaPollForm->workspace=$env['workspace'];
	$SawannaPollForm->query=$env['query'];
	
	if (!isset($SawannaPollForm->session->var['poll']) && isset($_COOKIE['poll']))
	{
		$polls=unserialize($_COOKIE['poll']);
		
		if (is_array($polls))
		{
			$sess=array();
			foreach ($polls as $num)
			{
				if (is_numeric($num)) $sess[]=$num;
			}
			$SawannaPollForm->session->register('poll',serialize($sess));
		}
	}
}

function poll_exec()
{
	global $SawannaPollForm;
	
	if ($SawannaPollForm->workspace == $SawannaPollForm->_workspace || $SawannaPollForm->workspace == FRONT_PAGE_WORKSPACE)
	{
		if (isset($_POST['poll_form']) && is_numeric($_POST['poll_form']))
		$SawannaPollForm->save();
		
		$SawannaPollForm->build();
	}
}

function poll_clear()
{
	global $SawannaPollForm;
	
	unset(
		$SawannaPollForm->db,
		$SawannaPollForm->session,
		$SawannaPollForm->language,
		$SawannaPollForm->user,
		$SawannaPollForm->navigator,
		$SawannaPollForm->node,
		$SawannaPollForm->_workspace,
		$SawannaPollForm->workspace,
		$SawannaPollForm->query
		);
}
?>