<?php
defined("SAWANNA") or die();

class CSawannaTags extends CSawanna
{
	var $session;
	var $language;
	var $db;
	var $user;
	var $limit;
	var $max_size;
	var $min_size;
	
	function CSawannaTags()
	{
		$this->session=null;
		$this->language=null;
		$this->db=null;
		$this->limit=100;
		$this->max_size=18;
		$this->min_size=10;
	}
	
	function build()
	{
		$html='';
		$tags=array();
		
		switch ($this->user->group)
		{
			case 2 :
				$condition=' and ';
				$condition.="access <> '0'";
				break;
			default:
				$condition=' and ';
				$condition.="access = '1'";
				break;
		}
		
		$this->db->query("select keywords from ".DB_PREFIX."_nodes where language='".$this->db->escape_string($this->language->current)."'".$condition);
		while ($node=$this->db->fetch_array())
		{
			$keywords=explode(',',$node['keywords']);
			if (!empty($node['keywords']) && !empty($keywords))
			{
				foreach ($keywords as $keyword)
				{
					if (array_key_exists($keyword,$tags))
					{
						$tags[$keyword]++;
					} else 
					{
						$tags[$keyword]=0;
					}
				}
			}
		}
		
		if (!empty($tags))
		{
			arsort($tags); 
			$max_value=current($tags);
			if ($max_value!=0)
			{
				$pref=($this->max_size-$this->min_size)/$max_value;
				$count=count($tags);
				$cloud=array_rand($tags,$count>$this->limit ? $this->limit : $count);
	
				foreach ($cloud as $tag)
				{
					$size=floor($tags[$tag]*$pref)+$this->min_size;
					$html.='<a style="text-decoration:none" href="javascript:getTag(\''.$tag.'\')"><b style="font-size:'.$size.'px;margin-left:2px;margin-right:2px" onmouseover="this.style.color=\'#888888\'" onmouseout="this.style.color=\'\'">'.$tag.'</b></a> ';
				}
			} else 
			{
				foreach ($tags as $tag=>$count_val)
				{
					$html.='<a style="text-decoration:none" href="javascript:getTag(\''.$tag.'\')"><b style="font-size:'.$this->min_size.'px;margin-left:2px;margin-right:2px" onmouseover="this.style.color=\'#888888\'" onmouseout="this.style.color=\'\'">'.$tag.'</b></a> ';
				}
			}
		}
		
		if (!empty($html))
		{
			echo '<div class="field_caption">[string]tags_cloud[/string]</div>';
			echo '<div class="field_body">'.$html;
			echo '<div style="height:1px;overflow:hidden"><form style="height:1px;visibility:hidden" name="tags_form" id="tags_form" action="'.parent::build_url('search').'" method="POST"><input type="text" name="search" id="tags_search" style="width:100px;margin-right:5px" /></form></div>';
			echo '<script language="JavaScript">function getTag(tag){ document.getElementById(\'tags_search\').value=tag;document.getElementById(\'tags_form\').submit(); };</script>';
			echo '</div>';
			echo '<div style="width:100%" class="shadow_1"></div>';
		}
	}
}

function tags_init($env)
{
	global $SawannaTags;
	
	$SawannaTags=new CSawannaTags();
	$SawannaTags->session=&$env['session'];
	$SawannaTags->language=&$env['language'];
	$SawannaTags->db=&$env['db'];
	$SawannaTags->user=&$env['user'];
}

function tags_exec()
{
	global $SawannaTags;
	
	$SawannaTags->build();
}

function tags_clear()
{
	global $SawannaTags;
	
	unset(
		$SawannaTags->session,
		$SawannaTags->language,
		$SawannaTags->db,
		$SawannaTags->user,
		$SawannaTags->limit,
		$SawannaTags->max_size,
		$SawannaTags->min_size
		);
}
?>