<?php
define("SAWANNA",1);

require_once('./settings.php');

if (!defined('ROOT_DIR') || !defined('SITE_HOST') || !defined('HOME') || !defined('DB_TYPE') || !defined('DB_HOST') || (DB_TYPE!='SQLite' && (!defined('DB_NAME') || !defined('DB_USER') || !defined('DB_PASS'))) || !defined('DB_PREFIX'))
{
	header("Location: install.php");
	die();
}

require_once("./sawanna/config.php");
require_once("./sawanna/sawanna.inc.php");

register_shutdown_function('sawanna_clear');

if (DEBUG_MODE && function_exists('microtime')) $started=microtime(true);

$Sawanna = new CSawanna();
$Sawanna->init();

require_once("./sawanna/gzip.php");

if (CHECK_IF_COOKIES_ENABLED && !isset($Sawanna->session->var['cookie_enabled'])) 
{
	header("Cache-Control: no-cache, must-revalidate");
	header("Expires: ".date('r',time()-3600)); 

	if (!empty($_SERVER['QUERY_STRING']))
	{
		$url=HOME.'/index.php'.$Sawanna->fix_url('?'.$_SERVER['QUERY_STRING']).'&first=true';
	} else 
	{
		$url=$Sawanna->build_url($Sawanna->query[1]).'&first=true';
	}

	echo $Sawanna->tpl->generate_redirect_page($url);
	
	$Sawanna->session->fix();
	$Sawanna->ok=true;
	$Sawanna->log->register(true);
	die();
}

if (CHECK_IF_COOKIES_ENABLED && isset($_GET['first']) && $_GET['first']=='true')
{
	if (isset($_SERVER['HTTP_REFERER']))
	{
		$Sawanna->redirect($_SERVER['HTTP_REFERER']);
	} else 
	{
		if (!empty($_SERVER['QUERY_STRING']))
		{
			$url=HOME.'/index.php'.$Sawanna->fix_url('?'.$_SERVER['QUERY_STRING']);
		} else 
		{
			$url=HOME;
		}
		$Sawanna->redirect($url);
	}
}

function sawanna_clear()
{
	global $Sawanna;
	if (isset($Sawanna) && !$Sawanna->ok)
	{
		if (isset($Sawanna->log))
		{
			$Sawanna->log->register(false);
		}
		if (!DEBUG_MODE) include_once(ROOT_DIR.'/error.php');
	}
	$Sawanna->clear();
}

if ($Sawanna->user->group == 1)
{
	header("Cache-Control: no-cache, must-revalidate");
	header("Expires: ".date('r',time()-3600)); 
}

$Sawanna->construct();
$Sawanna->log->register(true);

if (DEBUG_MODE && $Sawanna->query[1] != 'ajax')
{
	if (function_exists('memory_get_usage')) $memory=intval(memory_get_usage()/1024);
	if (isset($memory)) echo "\n<!--Memory usage ".$memory." kB-->";
	if (function_exists('memory_get_peak_usage')) $peak=intval(memory_get_peak_usage()/1024);
	if (isset($peak)) echo "\n<!--The peak of memory usage ".$peak." kB-->";
	if (function_exists('microtime')) $total=microtime(true)-$started;
	if (isset($total)) echo "\n<!--Generated in ".$total." sec.-->";
}
?>