<?php
defined("SAWANNA") or die();

class CArticle extends CSawanna 
{
	var $db;
	var $node;
	var $user;
	var $session;
	var $language;
	var $workspace;
	var $query;
	var $title;
	var $navigator;
	var $_workspace;
	var $error;
	var $new_limit;
	var $display_rss_link;
	var $get;
	
	function CArticle()
	{
		$this->db=null;
		$this->node=null;
		$this->user=null;
		$this->session=null;
		$this->language=null;
		$this->workspace=null;
		$this->query=null;
		$this->title='';
		$this->navigator=null;
		$this->_workspace='article';
		$this->error='';
		$this->new_limit=5;
		$this->display_rss_link=true;
		$this->get=(isset($_GET['get']) && !empty($_GET['get']) && is_numeric($_GET['get']) && $_GET['get']>0 ) ? $_GET['get'] : 1;
	}
	
	function build()
	{
		
		if ($this->workspace==FRONT_PAGE_WORKSPACE)
		{
			$_result=$this->navigator->get(array('parent'=>0));
			while ($menu=$this->db->fetch_array($_result)) {
				if (($p=strpos($menu['link'],'/'))===false) continue;
				if (substr($menu['link'],0,$p) != $this->_workspace) continue;
				
				$node=array('workspace'=>$this->_workspace,'link'=>substr($menu['link'],$p+1),'mark'=>'');
				$result=$this->node->get($node);
				if (!empty($result)) break;
			}
		} else
		{
			$node=array('workspace'=>$this->_workspace,'link'=>$this->query,'mark'=>'');
			$result=$this->node->get($node);
		}
		
		if (isset($result) && !empty($result)) $node=$this->db->fetch_array($result);
		
		if (isset($node) && !empty($node))
		{
			if (!empty($node['content']))
			{
				$_res=$this->db->sub_query("select name,login,gender from ".DB_PREFIX."_users where id = '".$this->db->escape_string($node['author_id'])."'");
				$user=$this->db->fetch_array($_res);
				$author=(!empty($user['name'])) ? $user['name'] : $user['login'];
				
				$gender='';
				if (!empty($user['gender']))
				{
					switch ($user['gender'])
					{
						case 'M' :
							$gender.='<img src="'.HOME.'/sawanna/images/male.gif" width="15" height="15" align="bottom" border="0" />&nbsp;';
							break;
						case 'F' :
							$gender.='<img src="'.HOME.'/sawanna/images/female.gif" width="15" height="15" align="bottom" border="0" />&nbsp;';
							break;
					}
				}
	
				echo  '<div class="date_published">[string]date[/string] : '.date('d.m.Y',$node['published']).'</div><br clear="all" />';
				echo '<div class="node" id="node">';
				$this->title=$node['name'];
				echo preg_replace('/\[break\]/','<!--[break]-->',$node['content'],1);
				echo '</div>';
				echo '<br clear="all" /><div class="author_name">[string]author[/string] : '.$gender.parent::build_anchor('user/view/'.$user['login'],'<span class="author_link">'.$author.'</span>').'</div><br clear="all" />';
			} else
			{ 
				$_res=$this->db->sub_query("select id from ".DB_PREFIX."_navigation where link='".$this->db->escape_string($this->workspace.'/'.$node['link'])."'");
				$menu=$this->db->fetch_array($_res);
				
				echo '<div class="map">'.$this->build_article_childs($menu['id']).'</div>';
			}
		} elseif ($this->workspace != FRONT_PAGE_WORKSPACE)
		{
			$this->db->query("select access from ".DB_PREFIX."_nodes where workspace='".$this->db->escape_string($this->_workspace)."' and link='".$this->db->escape_string($this->query)."' and language='".$this->db->escape_string($this->language->current)."'");
			$node=$this->db->fetch_array();
			if (!empty($node))
			{
				switch ($node['access'])
				{
					case 2 :
						$this->error='[string]please_login[/string]';
						break;
					case 0 :
						$this->error='[string]access_denied[/string]';
						break;
				}
			} elseif (!empty($this->query)) 
			{
				$this->error='[string]article_not_found[/string]';
				if (!defined('NO_COMMENTS')) define('NO_COMMENTS',1);
			}
		}
		
	}
	
	function show_new()
	{
		$html='';
		
	//	$node=array('workspace'=>$this->_workspace,'mark'=>'');
	//	$result=$this->node->get($node);
		
		$condition="language='".$this->db->escape_string($this->language->current)."'";
		
		$condition.=' and ';
		$condition.="workspace='".$this->db->escape_string($this->_workspace)."'";
		$condition.=' and ';
		$condition.="mark=''";
		$condition.=' and ';
		$condition.="content<>''";
		
		switch ($this->user->group)
		{
			case 1 :
				$condition.='';
				break;
			case 2 :
				$condition.=' and ';
				$condition.="access <> '0'";
				break;
			default:
				$condition.=' and ';
				$condition.="access = '1'";
				break;
		}
		
		$result=$this->db->sub_query("select * from ".DB_PREFIX."_nodes where ".$condition." order by published desc");
		
		if (isset($result) && !empty($result)) 
		{
			$current=(intval($this->get)-1)*$this->new_limit+1;
			$co=0;
			while ($node=$this->db->fetch_array($result))
			{
				$co++;
				if ($co<$current) continue;
				
				$thumb='';
				$link=str_replace('/','_',$node['link']);
				if (file_exists(ROOT_DIR.'/upload/thumbs/'.$this->_workspace.'_'.$link.'.jpg'))
				{
					$thumb_size=@getimagesize(ROOT_DIR.'/upload/thumbs/'.$this->_workspace.'_'.$link.'.jpg');
					$dimm=(array_key_exists(3,$thumb_size)) ? $thumb_size[3] : 'width="80" height="60"';
					$thumb='<img src="'.HOME.'/upload/thumbs/'.$this->_workspace.'_'.$link.'.jpg" '.$dimm.' class="thumbnail" align="left" style="margin-right:10px;margin-top:5px;margin-bottom:5px" />';
				}
				
				$this->title='';
				$html.= parent::build_anchor($this->_workspace.'/'.$node['link'],'<div class="article_title">'.$node['name'].'</div>');
				
				if (($teaser=strpos($node['content'],'[break]')) !== false)
				{
					$content=strip_tags(substr($node['content'],0,$teaser),'<p><P><br /><BR /><br><BR>');
				} elseif (function_exists('mb_substr'))
				{
					$content=mb_substr(strip_tags($node['content'],'<p><P><br /><BR /><br><BR>'),0,1000);
				} else 
				{
					$content=substr(strip_tags($node['content'],'<p><P><br /><BR /><br><BR>'),0,1000);
				}
				$html.= $thumb.$content.'<br clear="all" />';
				
				$comments=array('workspace'=>$this->_workspace,'link'=>$node['link'],'mark'=>'comment','access'=>'1');
				$res=$this->node->get($comments);
				$count=$this->db->num_rows($res);
				
				$_res=$this->db->sub_query("select name,login,gender from ".DB_PREFIX."_users where id = '".$this->db->escape_string($node['author_id'])."'");
				$user=$this->db->fetch_array($_res);
				$author=(!empty($user['name'])) ? $user['name'] : $user['login'];
				$gender='';
				if (!empty($user['gender']))
				{
					switch ($user['gender'])
					{
						case 'M' :
							$gender.='<img src="'.HOME.'/sawanna/images/male.gif" width="10" height="10" align="bottom" border="0" />&nbsp;';
							break;
						case 'F' :
							$gender.='<img src="'.HOME.'/sawanna/images/female.gif" width="10" height="10" align="bottom" border="0" />&nbsp;';
							break;
					}
				}
	
				$html.='<div class="article_read_more">'.parent::build_anchor($this->_workspace.'/'.$node['link'],'<span  class="read_more">[string]read_more[/string]</span>').'</div>';
				$html.= '<div class="article_author_name">[string]author[/string]:&nbsp;'.$gender.parent::build_anchor('user/view/'.$user['login'],'<span class="article_author_link">'.$author.'</span>').'</div><div class="article_meta_links"><span class="article_meta_date">[string]date[/string]: '.date('d.m.Y',$node['published']).'</span>&nbsp;&nbsp;&nbsp;<span class="article_meta_comments">[string]comments[/string]: '.((!empty($count)) ? $count : 0).'</span></div>';
				$html.= '<br /><br /><br />';
				
				if ($co>=$this->new_limit+$current-1) break;
			}
			
			$count=$this->db->num_rows($result);
			if ($count > $this->new_limit)
			{
				$html.='<br /><br />';
				$html.=parent::build_limiter($count,$this->new_limit,$this->workspace.'/'.$this->query,$this->get,true);
			}
		}
		
		if (!empty($html))
		{
			echo '<br clear="all" />';
			echo '<div style="padding:5px">';
			if ($this->workspace==FRONT_PAGE_WORKSPACE)
				echo '<div class="section"><div style="float:left">[string]new_articles[/string]</div>';
			else 
				echo '<div style="height:20px;margin-bottom:10px">';
			if ($this->display_rss_link)
			{
				echo '<div style="float:right">';
				echo parent::build_anchor('rss/article','<img src="'.HOME.'/sawanna/images/rss.png" width="80" height="15" border="0" hspace="10" />');	
				echo '</div>';
			}
			echo '</div>';
			echo '<div style="padding:5px">';
			echo $html;
			echo '</div>';
			echo '</div>';
		}
	}
	
	function build_rss() {
		
		$html='';
		
		$html.='<?xml version="1.0" encoding="utf-8"?>'."\n";
		$html.='<rss version="2.0">'."\n";
		$html.='<channel>'."\n";
		$html.='<title>'.SITE_NAME.' : [string]new_articles[/string]</title>'."\n";
		$html.='<link>'.parent::build_url($this->_workspace,false,true).'</link>'."\n";
		$html.='<description>'.SITE_HOST.' - RSS</description>'."\n";
		$html.='<generator>Sawanna CMS ver.'.VERSION.'</generator>'."\n";

		$co=0;
	//	$result=$this->node->get(array('workspace'=>$this->_workspace,'mark'=>''));
	
		$condition="language='".$this->db->escape_string($this->language->current)."'";
		
		$condition.=' and ';
		$condition.="workspace='".$this->db->escape_string($this->_workspace)."'";
		$condition.=' and ';
		$condition.="mark=''";
		$condition.=' and ';
		$condition.="content<>''";
		
		switch ($this->user->group)
		{
			case 1 :
				$condition.='';
				break;
			case 2 :
				$condition.=' and ';
				$condition.="access <> '0'";
				break;
			default:
				$condition.=' and ';
				$condition.="access = '1'";
				break;
		}
		
		$result=$this->db->sub_query("select * from ".DB_PREFIX."_nodes where ".$condition." order by published desc");
		
		while ($node=$this->db->fetch_array($result)) {
			$co++;
			if (function_exists('mb_substr'))
			{
				$content=mb_substr(strip_tags($node['content']),0,1000).'...';
			} else 
			{
				$content=substr(strip_tags($node['content']),0,1000).'...';
			}
			$html.='<item>'."\n";
			$html.='<title>'.$node['name'].'</title>'."\n";
			$html.='<link>'.parent::build_url($this->_workspace.'/'.$node['link'],false,true).'</link>'."\n";
			$html.='<description>'.$content.'</description>'."\n";
			$html.='<guid isPermaLink="true">'.parent::build_url($this->_workspace.'/'.$node['link'],false,true).'</guid>'."\n";
			$html.='<pubDate>'.date('r',$node['published']).'</pubDate>'."\n";
			$html.='</item>'."\n";
			if ($co >= $this->new_limit) break;
		}
		$html.='</channel>'."\n";
		$html.='</rss>';
		
		echo $html;
	}
	
	function build_article_childs($parent=0,$co=0)
	{
		static $childs;
		
		$offset=str_repeat("&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; ",$co);
		
		$result=$this->navigator->get(array('parent'=>$parent));
		while($menu=$this->db->fetch_array($result))
		{
			if ($menu['mark'] == 'ghost') continue;
			
			if ($co==0) $_offset='<br />&bull; '; else $_offset=$offset.' &rarr; ';
			
			$menu_link=(strpos($menu['link'],'http://')===0 || strpos($menu['link'],'https://')===0) ? '<a href="'.$menu['link'].'" target="_blank" class="map_link">'.$menu['name'].'</a>' : parent::build_anchor($menu['link'],$menu['name'],'map_link');
			
			$childs.=$_offset.$menu_link.'<br />';
			$this->build_article_childs($menu['id'],$co+1);
		}
		return $childs.'<br />';
	}
}

function article_init($env)
{
	global $SawannaArticle;
	
	$SawannaArticle=new CArticle();
	$SawannaArticle->db=&$env['db'];
	$SawannaArticle->node=&$env['node'];
	$SawannaArticle->user=&$env['user'];
	$SawannaArticle->language=&$env['language'];
	$SawannaArticle->session=&$env['session'];
	$SawannaArticle->workspace=&$env['workspace'];
	$SawannaArticle->query=&$env['query'];
	$SawannaArticle->navigator=&$env['navigator'];
}

function article_exec()
{
	global $SawannaArticle;

	if ($SawannaArticle->workspace == 'rss')
	{
		$SawannaArticle->build_rss();
	} elseif ($SawannaArticle->workspace == $SawannaArticle->_workspace || $SawannaArticle->workspace == FRONT_PAGE_WORKSPACE)
	{
		if (empty($SawannaArticle->query)) $SawannaArticle->show_new();
		if ($SawannaArticle->workspace!=FRONT_PAGE_WORKSPACE) $SawannaArticle->build();
		return array('',$SawannaArticle->error,$SawannaArticle->title);
	}
}

function article_clear()
{
	global $SawannaArticle;
	
	unset(
		$SawannaArticle->db,
		$SawannaArticle->node,
		$SawannaArticle->user,
		$SawannaArticle->language,
		$SawannaArticle->session,
		$SawannaArticle->workspace,
		$SawannaArticle->query,
		$SawannaArticle->title,
		$SawannaArticle->navigator,
		$SawannaArticle->error,
		$SawannaArticle->new_limit,
		$SawannaArticle->display_rss_link
		);
}
?>
