<?php
defined("SAWANNA") or die();

class CSawannaBreadCrumbs extends CSawanna
{
	var $db;
	var $session;
	var $language;
	var $navigator;
	var $workspace;
	var $query;
	
	function CSawannaBreadCrumbs()
	{
		$this->db=null;
		$this->session=null;
		$this->language=null;
		$this->navigator=null;
		$this->workspace='';
		$this->query='';
	}
	
	function build()
	{
		$html='';
		$crumbs=array();
		
		$crumbs[]=$this->workspace;
		
		if (!empty($this->query))
		{
			$_crumbs=explode('/',$this->query);
			$crumbs=array_merge($crumbs,$_crumbs);
		}
		
		$link='';
		$co=0;
		foreach ($crumbs as $crumb)
		{
			$link.=$crumb; 
			$result=$this->navigator->get(array('link'=>$link));
			$bread=$this->db->fetch_array($result);
			if (!empty($bread))
			{
				if (!empty($html)) $html.=' &rarr;&nbsp;';
				
				if (($link == $this->workspace.'/'.$this->query && $co==count($crumbs)-1) || ($link==$this->workspace && count($crumbs)==1))
					$html.='<span class="breadcrumbs_current">'.$bread['name'].'</span>';
				else 
					$html.=parent::build_anchor($link,$bread['name']);
				
			} elseif ($this->workspace=='map')
			{
				$html.='<span class="breadcrumbs_current">[string]sitemap[/string]</span>';
			} elseif ($this->workspace=='feedback')
			{
				$html.='<span class="breadcrumbs_current">[string]feedback[/string]</span>';
			}
			
			$co++;
			$link.='/';
		}
		
		if (!empty($html))
		{
			echo '<div class="breadcrumbs">';
			echo $html;
			echo '</div>';
		}
	}
}

function breadcrumbs_init($env)
{
	global $SawannaBreadCrumbs;
	
	$SawannaBreadCrumbs=new CSawannaBreadCrumbs();
	$SawannaBreadCrumbs->db=&$env['db'];
	$SawannaBreadCrumbs->session=&$env['session'];
	$SawannaBreadCrumbs->language=&$env['language'];
	$SawannaBreadCrumbs->navigator=&$env['navigator'];
	$SawannaBreadCrumbs->workspace=$env['workspace'];
	$SawannaBreadCrumbs->query=$env['query'];
}

function breadcrumbs_exec()
{
	global $SawannaBreadCrumbs;
	
	$SawannaBreadCrumbs->build();
}

function breadcrumbs_clear()
{
	global $SawannaBreadCrumbs;
	
	unset(
		$SawannaBreadCrumbs->db,
		$SawannaBreadCrumbs->session,
		$SawannaBreadCrumbs->language,
		$SawannaBreadCrumbs->navigator,
		$SawannaBreadCrumbs->workspace,
		$SawannaBreadCrumbs->query
		);
}
?>