<?php
defined("SAWANNA") or die();

class CSawannaCommentsAdmin extends CSawanna
{
	var $db;
	var $session;
	var $language;
	var $node;
	var $message;
	var $error;
	var $limit;
	var $get;
	
	function CSawannaCommentsAdmin()
	{
		$this->db=null;
		$this->session=null;
		$this->language=null;
		$this->node=null;
		$this->message='';
		$this->error='';
		$this->limit=5;
		$this->get=(isset($_GET['get']) && !empty($_GET['get']) && is_numeric($_GET['get']) && $_GET['get']>0 ) ? $_GET['get'] : 1;
	}
	
	
	function build_linker()
	{
		$html='<div align="left" style="border-top:1px solid #000000;padding:10px">';
		
		$current=(intval($this->get)-1)*$this->limit+1;
		$co=0;
		$this->db->query("select * from ".DB_PREFIX."_nodes where mark='comment' order by published desc");
		while ($comments=$this->db->fetch_array()) {
			$co++;
			if ($co<$current) continue;
			
			$res=$this->db->sub_query("select login from ".DB_PREFIX."_users where id='".$this->db->escape_string($comments['author_id'])."'");
			$user=$this->db->fetch_array($res);
			
			$activ_link=($comments['access']==0) ? parent::build_anchor(ADMIN_WORKSPACE.'/&component=commentsAdmin&act=activate&id='.$comments['id'],'<b>[string]activate[/string]</b>') : parent::build_anchor(ADMIN_WORKSPACE.'/&component=commentsAdmin&act=deactivate&id='.$comments['id'],'<b>[string]deactivate[/string]</b>');
			$border=($comments['access']==0) ? 'border:1px solid #FDBABA' : 'border:1px solid #DDDDDD';
			$html.='<div><b>[string]page[/string]:</b> '.$comments['workspace'].'/'.$comments['link'].'<br /><b>[string]date[/string]:</b> '.date('d.m.Y',$comments['published']).'&nbsp;&nbsp;&nbsp;<b>[string]language[/string]:</b> '.$comments['language'].'&nbsp;&nbsp;&nbsp;<b>[string]author[/string]:</b> '.$user['login'].'<div style="margin:2px 0px;padding:5px;'.$border.'">'.$comments['content'].'</div><div style="float:left">'.parent::build_anchor(ADMIN_WORKSPACE.'/&component=commentsAdmin&act=edit&id='.$comments['id'],'<img src="'.HOME.'/sawanna/images/edit.png" width="20" height="20" title="[string]edit[/string]" border="0" align="absmiddle" />').'&nbsp;&nbsp;'.parent::build_anchor(ADMIN_WORKSPACE.'/&component=commentsAdmin&act=del&id='.$comments['id'],'<img src="'.HOME.'/sawanna/images/delete.png" width="20" height="20" title="[string]delete[/string]" border="0" align="absmiddle" />').'</div><div style="float:right">'.$activ_link.'</div><br /><br /><br /></div>';
			if ($co>=$this->limit+$current-1) break;
		}
		
		$count=$this->db->num_rows();
		if ($count > $this->limit)
		{
			$html.='<br /><br />';
			$html.=parent::build_limiter($count,$this->limit,ADMIN_WORKSPACE.'/&component=commentsAdmin',$this->get,true);
		}
		
		$html.='</div>';
		
		echo $html;
	}
	
	function activate($id)
	{
		if ($this->db->query("update ".DB_PREFIX."_nodes set access='1' where id='".$this->db->escape_string($id)."'"))
		{
			$this->message='[string]comment_activated[/string]';
		} else 
		{
			$this->error='[string]database_error[/string]';
		}
	}
	
	function deactivate($id)
	{
		if ($this->db->query("update ".DB_PREFIX."_nodes set access='0' where id='".$this->db->escape_string($id)."'"))
		{
			$this->message='[string]comment_deactivated[/string]';
		} else 
		{
			$this->error='[string]database_error[/string]';
		}
	}
	
	function build_edit_form($id)
	{
		$this->db->query("select * from ".DB_PREFIX."_nodes where id='".$this->db->escape_string($id)."' and  mark='comment'");
		$comment=$this->db->fetch_array();
		
		if (empty($comment))
		{
			$this->error='[string]comment_not_found[/string]';
			return;
		}
		
		$res=$this->db->sub_query("select login from ".DB_PREFIX."_users where id='".$this->db->escape_string($comment['author_id'])."'");
		$user=$this->db->fetch_array($res);
			
		
		$html='<div align="left" style="width:500px;padding-left:10px"><b>[string]author[/string]: </b>'.$user['login'].'<br />';
		$html.='<b>[string]page[/string]: </b>'.$comment['workspace'].'/'.$comment['link'].'<br />';
		$html.='<b>[string]language[/string]: </b>'.$comment['language'].'<br />';	
		$html.='</div>';
		
		$elems=array(
					'custom',
					'submit'
					);
					
		$desc=array(
					'',
					' '
					);
		
		$attr=array(
					'',
					'value="[string]send[/string]"'
					);
					
		$custom=array(
					'<textarea name="comment" cols="50" rows="4" style="width:100%">'.str_replace('<br />',"",$comment['content']).'</textarea>',
					);
		
		$html.=parent::build_form(ADMIN_WORKSPACE.'/&component=commentsAdmin&act=doedit&id='.$id,$elems,500,$desc,$attr,$custom);
		
		echo $html; 
	}
	
	function edit($id)
	{
		if (!isset($_POST['comment']) || empty($_POST['comment']))
		{
			$this->error='[string]comment_required[/string]';
			$this->build_edit_form($id);
			return ;
		}
		
		$comment=nl2br(htmlspecialchars($_POST['comment']));
	
		if (!$this->db->query("update ".DB_PREFIX."_nodes set content='".$this->db->escape_string($comment)."' where id='".$this->db->escape_string($id)."' and mark='comment'"))
		{
			$this->error='[string]database_error[/string]';
			$this->build_edit_form($id);
			return ;
		}
		
		$this->message='[string]comment_edited[/string]';
	}
	
	function build_delete_form($id)
	{
		$html='';
		
		$this->db->query("select * from ".DB_PREFIX."_nodes where id='".$this->db->escape_string($id)."' and  mark='comment'");
		$node=$this->db->fetch_array();
		
		if (!empty($node))
		{
			$html.='<div align="left" style="padding:10px">';
			$html.='<b>[string]link_text[/string] : '.$node['link'].'</b>';
			$html.='<br /><b>[string]comment[/string] : </b><div style="border:1px solid #DDDDDD;padding:5px">'.$node['content'].'</div>';
			$html.='<p style="color:red">[string]comment_delete_confirm[/string]</p>';
			$html.=parent::build_anchor(ADMIN_WORKSPACE.'/&component=commentsAdmin&act=dodel&id='.$id,'<b>[string]delete[/string]</b>');
			$html.='</div>';
		} else 
		{
			$this->error='[string]comment_not_found[/string]';
		}
		
		echo $html; 
	}
	
	function build_delete_form_alt($workspace,$query,$id)
	{
		$html='';
		
		$result=$this->node->get(array('link'=>$query,'workspace'=>$workspace,'mark'=>'comment','id'=>$id));
		$node=$this->db->fetch_array($result);
		
		if (!empty($node))
		{
			$html.='<div align="left" style="padding:10px">';
			$html.='<b>[string]link_text[/string] : '.$node['link'].'</b>';
			$html.='<br /><b>[string]comment[/string] : </b><div style="border:1px solid #DDDDDD;padding:5px">'.$node['content'].'</div>';
			$html.='<p style="color:red">[string]comment_delete_confirm[/string]</p>';
			$html.=parent::build_anchor(ADMIN_WORKSPACE.'/&component=commentsAdmin&act=dodel_alt&workspace='.$workspace.'&query='.$query.'&id='.$id,'<b>[string]delete[/string]</b>');
			$html.='</div>';
		} else 
		{
			$this->error='[string]comment_not_found[/string]';
		}
		
		echo $html; 
	}
	
	function delete($id)
	{
		
		if (!$this->db->query("delete from ".DB_PREFIX."_nodes where mark='comment' and id='".$this->db->escape_string($id)."'"))
		{
			$this->error='[string]database_error[/string]';
			return;
		} else 
		{
			$this->message='[string]comment_deleted[/string]';
		}
	}
	
	function delete_alt($workspace,$query,$id)
	{
		
		if (!$this->node->delete(array('workspace'=>$workspace,'link'=>$query,'mark'=>'comment','id'=>$id)))
		{
			$this->error='[string]database_error[/string]';
			return;
		} else 
		{
			parent::redirect(parent::build_url($workspace.'/'.$query));
		}
	}
}

function commentsAdmin_init($env)
{
	global $SawannaCommentsAdmin;
	
	$SawannaCommentsAdmin=new CSawannaCommentsAdmin();
	$SawannaCommentsAdmin->db=&$env['db'];
	$SawannaCommentsAdmin->session=&$env['session'];
	$SawannaCommentsAdmin->language=&$env['language'];
	$SawannaCommentsAdmin->node=&$env['node'];
}

function commentsAdmin_exec()
{
	global $SawannaCommentsAdmin;
	
	if (isset($_GET['component']) && $_GET['component']=='commentsAdmin')
	{
		echo '<h2 class="header_caption"><img src="'.HOME.'/sawanna/images/wpalm.png" width="40" height="40" align="absmiddle">&nbsp;[string]comments[/string] :</h2>';
		echo '<p style="padding:10px">[string]comments_str[/string]</p>';
		echo '<div align="center" style="padding-top:10px;padding-bottom:10px">';
		
		if (isset($_GET['act']))
		{
			switch ($_GET['act'])
			{
				case 'edit' :
					if (isset($_GET['id']) && is_numeric($_GET['id']))
					$SawannaCommentsAdmin->build_edit_form($_GET['id']);
					break;
				case 'doedit' :
					if (isset($_GET['id']) && is_numeric($_GET['id']))
					$SawannaCommentsAdmin->edit($_GET['id']);
					break;
				case 'del' :
					if (isset($_GET['id']) && is_numeric($_GET['id']))
					$SawannaCommentsAdmin->build_delete_form($_GET['id']);
					break;
				case 'del_alt' :
					if (isset($_GET['workspace'],$_GET['query'],$_GET['id']))
						$SawannaCommentsAdmin->build_delete_form_alt($_GET['workspace'],$_GET['query'],$_GET['id']);
					break;
				case 'dodel' :
					if (isset($_GET['id']) && is_numeric($_GET['id']))
					$SawannaCommentsAdmin->delete($_GET['id']);
					break;
				case 'dodel_alt' :
					if (isset($_GET['workspace'],$_GET['query'],$_GET['id']))
						$SawannaCommentsAdmin->delete_alt($_GET['workspace'],$_GET['query'],$_GET['id']);
					break;
				case 'activate':
					if (isset($_GET['id']) && is_numeric($_GET['id']))
					$SawannaCommentsAdmin->activate($_GET['id']);
					break;
				case 'deactivate':
					if (isset($_GET['id']) && is_numeric($_GET['id']))
					$SawannaCommentsAdmin->deactivate($_GET['id']);
					break;
			}
		}
		
		$SawannaCommentsAdmin->build_linker();
		echo '</div>';
	}
	
	return array($SawannaCommentsAdmin->message,$SawannaCommentsAdmin->error,'');
}

function commentsAdmin_clear()
{
	global $SawannaCommentsAdmin;
	
	unset(
		$SawannaCommentsAdmin->db,
		$SawannaCommentsAdmin->session,
		$SawannaCommentsAdmin->language,
		$SawannaCommentsAdmin->node,
		$SawannaCommentsAdmin->message,
		$SawannaCommentsAdmin->error,
		$SawannaCommentsAdmin->limit,
		$SawannaCommentsAdmin->get
		);
}
?>