<?php
defined("SAWANNA") or die();

class CComments extends CSawanna 
{
	var $db;
	var $session;
	var $language;
	var $user;
	var $node;
	var $tpl;
	var $captcha;
	var $error;
	var $message;
	var $workspace;
	var $query;
	var $limit;
	var $get;
	var $content_limit;
	var $need_approve;
	
	function CComments()
	{
		$this->db=null;
		$this->session=null;
		$this->language=null;
		$this->user=null;
		$this->node=null;
		$this->tpl=null;
		$this->captcha=null;
		$this->error='';
		$this->message='';
		$this->workspace=FRONT_PAGE_WORKSPACE;
		$this->query='';
		$this->limit=5;
		$this->get=(isset($_GET['get']) && !empty($_GET['get']) && is_numeric($_GET['get']) && $_GET['get']>0) ? $_GET['get'] : 1;
		$this->content_limit=2000;
		$this->need_approve=COMMENTS_APPROVE;
	}
	
	function build()
	{
		if (empty($this->query)) return ;
		
		switch ($this->user->group)
		{
			case 1 :
				$access='';
				break;
			case 2 :
				$access=' and ';
				$access.="access <> '0'";
				break;
			default:
				$access=' and ';
				$access.="access = '1'";
				break;
		}
		$this->db->query("select id from ".DB_PREFIX."_nodes where workspace='".$this->db->escape_string($this->workspace)."' and link='".$this->db->escape_string($this->query)."' and mark<>'comment' and language='".$this->db->escape_string($this->language->current)."'".$access);
		if (!$this->db->num_rows()) return;
		
		$html='';
		
		$current=(intval($this->get)-1)*$this->limit+1;
		$co=0;
		$this->db->query("select * from ".DB_PREFIX."_nodes where workspace='".$this->db->escape_string($this->workspace)."' and link='".$this->db->escape_string($this->query)."' and mark='comment' and language='".$this->db->escape_string($this->language->current)."' and access<>'0' order by published");
		while($node=$this->db->fetch_array())
		{
			$co++;
			if ($co<$current) continue;
			
			$html.='<div class="comment">'.$this->build_comment_form($node['content'],$node['author_id']).'</div>';
			
			if ($this->user->group == 1)
			{
				$html.=parent::build_anchor(ADMIN_WORKSPACE.'/&component=commentsAdmin&workspace='.$this->workspace.'&query='.$this->query.'&act=del_alt&id='.$node['id'],'<img src="'.HOME.'/sawanna/images/delete.png" width="20" height="20" title="[string]delete[/string]" border="0" align="absmiddle" />&nbsp;<b>[string]delete[/string]</b>').'<br />';
			}
			
			$html.='<br />';

			if ($co>=$this->limit+$current-1) break;
		}
		
		$count=$this->db->num_rows();
		if ($count > $this->limit)
		{
			$html.='<br /><br />';
			$html.=parent::build_limiter($count,$this->limit,$this->workspace.'/'.$this->query.'/',$this->get,true);
		}
		
		if (!empty($html))
		{
			echo '<br clear="all" /><br /><h3>[string]comments[/string] : </h3><div align="left" style="padding:10px">';
			echo $html;
			echo '</div>';
		}
		
		if (isset($_POST['comment']) && empty($this->error))
		{
			unset($_POST['comment']);
		}
		
		$this->build_create_form();
		
		if ($this->user->group == 0 || $this->user->group == 3 || $this->user->active == 0) 
		{
			echo '<br /><br /><div align="center" style="border-top:1px solid #DDDDDD;"><br />[string]you_cant_post_comments[/string]</div><br />';
		}
	}
	
	function build_comment_form(&$comment,$author_id)
	{
		$html='';
		$result=$this->db->sub_query("select * from ".DB_PREFIX."_users where id='".$this->db->escape_string($author_id)."'");
		$user=$this->db->fetch_array($result);
		if (!empty($user))
		{
			$name=!empty($user['name']) ? $user['name'] : $user['login'];
			$user_link=!empty($user['login']) ? parent::build_anchor('user/view/'.$user['login'],$name) : $name;
			$gender='';
			if (!empty($user['gender']))
			{
				switch ($user['gender'])
				{
					case 'M' :
						$gender.='<img src="'.HOME.'/sawanna/images/male.gif" width="15" height="15" align="bottom" border="0" style="margin-top:2px" />&nbsp;';
						break;
					case 'F' :
						$gender.='<img src="'.HOME.'/sawanna/images/female.gif" width="15" height="15" align="bottom" border="0" style="margin-top:2px" />&nbsp;';
						break;
				}
			}
			$this->id=$user['id'];
			$group=($user['group_id']!=0) ? '[string]group[/string] : [string]group_'.$user['group_id'].'[/string]' : '[string]deleted[/string]';
			$joined=($user['group_id']!=0) ? '[string]joined[/string] : '.date('d.m.Y',$user['joined']) : '';
			$ava_path=ROOT_DIR.'/upload/user/'.md5($user['login']).'.ava';
			if (file_exists($ava_path))
			{
				$image=@getimagesize($ava_path);
				$image_size=!empty($image) ? $image[3] : '';
				$photo='<img src="'.PROTOCOL.'://'.SITE_HOST.'/upload/user/'.md5($user['login']).'.ava" '.$image_size.' />';
			} else 
			{
				$photo='<img src="'.PROTOCOL.'://'.SITE_HOST.'/sawanna/images/user.jpg" width="100" height="100" />';
			}
			
			$html.='<div class="comment_caption">'.$user_link.'</div>';
			$html.='<table cellspacing="5"><tr>';
			$html.='<td width="100">'.$photo.'<br />'.$gender.'<br /><b style="font-size:10px">'.$group.'</b><br /><span style="font-size:9px">'.$joined.'</span></td><td valign="top" style="border-left:1px solid #000000;padding-left:5px;font-size:12px">'.$comment.'</td>';
			$html.='</tr></table>';
		}
				
		return $html;
	}
	
	function build_create_form()
	{
		if (empty($this->query)) return ;
		
		if ($this->user->group == 0 || $this->user->group == 3 || $this->user->active == 0) return ;
		if (empty($this->query)) return ;
		
		$comment=isset($_POST['comment']) ? htmlspecialchars($_POST['comment']) : '';
		
		$html='';
		
		$elems=array(
					'custom',
					'custom',
					'text',
					'submit'
					);
					
		$desc=array(
					'',
					' ',
					'[string]enter_code[/string]',
					' '
					);
					
		$attr=array(
					'',
					'',
					'name="captcha" style="width:100px"',
					'value="[string]send[/string]"'
					);
					
		$custom=array(
					'<textarea name="comment" cols="70" rows="10" style="width:100%">'.$comment.'</textarea>',
					'<img src="'.parent::build_url('captcha').'" width="100" height="30" border="1" />'
					);
		
		$html.= '<div align="center"><p style="width:500px;font-weight:bold;text-align:left">[string]send_comment[/string]</p>'.parent::build_form($this->workspace.'/'.$this->query,$elems,'500px',$desc,$attr,$custom,'form',true).'</div>';
		
		echo $html;
	}
	
	function create()
	{
		if (empty($this->query)) return ;
		
		if ($this->user->group == 0 || $this->user->group == 3 || $this->user->active == 0) return ;
		
		if (!isset($_POST['comment']) || empty($_POST['comment']))
		{
			$this->error='[string]comment_required[/string]';
			return;
		}
		
		if (!isset($_POST['captcha']) || empty($_POST['captcha']))
		{
			$this->error="[string]captcha_not_match[/string]";
			return;
		}
		
		if (!$this->captcha->check($_POST['captcha']))
		{
			$this->error="[string]captcha_not_match[/string]";
			return;
		}
		
		if (strlen($_POST['comment']) > $this->content_limit) $_POST['comment']=substr($_POST['comment'],0,$this->content_limit).' ...';
		$comment=nl2br(htmlspecialchars($_POST['comment']));
		
		if (!$this->node->create('',$comment,'',$this->workspace,$this->query,'comment',$this->need_approve ? 0 : 1))
		{
			$this->error="[string]database_error[/string]";
			return;
		}
		
		if ($this->need_approve) $this->message='[string]comment_putted_to_moderation[/string]';
		else $this->message='[string]comment_created[/string]';
	}
	
	
}

function comments_init($env)
{
	global $SawannaComments;
	
	$SawannaComments=new CComments();
	$SawannaComments->db=&$env['db'];
	$SawannaComments->session=&$env['session'];
	$SawannaComments->language=&$env['language'];
	$SawannaComments->user=&$env['user'];
	$SawannaComments->tpl=&$env['tpl'];
	$SawannaComments->captcha=&$env['captcha'];
	$SawannaComments->node=&$env['node'];
	$SawannaComments->workspace=$env['workspace'];
	$SawannaComments->query=$env['query'];
	if ($SawannaComments->user->group == 1) $SawannaComments->need_approve=0;
}

function comments_exec()
{
	global $SawannaComments;
	
	if (defined('NO_COMMENTS') || !ALLOW_COMMENTS) return ;
	
	if (isset($_POST['comment'])) $SawannaComments->create();
	$SawannaComments->build();
	
	return array($SawannaComments->message,$SawannaComments->error,'');
}

function comments_clear()
{
	global $SawannaComments;
	
	unset(
		$SawannaComments->db,
		$SawannaComments->session,
		$SawannaComments->language,
		$SawannaComments->user,
		$SawannaComments->node,
		$SawannaComments->tpl,
		$SawannaComments->captcha,
		$SawannaComments->error,
		$SawannaComments->message,
		$SawannaComments->workspace,
		$SawannaComments->query,
		$SawannaComments->limit,
		$SawannaComments->get,
		$SawannaComments->content_limit
		);
}