<?php
defined("SAWANNA") or die();

class CNavigatorChild extends CSawanna 
{
	var $db;
	var $language;
	var $session;
	var $user;
	var $navigator;
	var $current_tree;
	var $parent_id;
	var $current_id;
	var $current_parent_id;
	var $workspace;
	var $_workspace;
	
	function CNavigatorChild()
	{
		$this->db=null;
		$this->language=null;
		$this->session=null;
		$this->user=null;
		$this->navigator=null;
		$this->current_tree=array();
		$this->parent_id=0;
		$this->current_id=0;
		$this->current_parent_id=0;
		$this->workspace=FRONT_PAGE_WORKSPACE;
		$this->_workspace='public';
	}
	
	function build()
	{
                    $current=$this->navigator->current;
	    
                    if (defined('SHOW_FRONT_PAGE_CHILD_MENU') && SHOW_FRONT_PAGE_CHILD_MENU)
                    {
                        if ($this->workspace==FRONT_PAGE_WORKSPACE)
                        {
                            $_result=$this->navigator->get(array('parent'=>0));
                            while ($menu=$this->db->fetch_array($_result)) {
                                if (($p=strpos($menu['link'],'/'))===false) continue;
                                if (substr($menu['link'],0,$p) != $this->_workspace) continue;
                                
                                $node=array('workspace'=>$this->_workspace,'link'=>substr($menu['link'],$p+1),'mark'=>'');
                                $result=$this->node->get($node);
                                if (!empty($result))
                                {
                                    $node=$this->db->fetch_array($result);
                                    $current=$node['workspace'].'/'.$node['link'];
                                    break;
                                }
                            }
                        } 
                    }
        
		$conditions=array('link' => $current);
		$result=$this->navigator->get($conditions);
		$current=$this->db->fetch_array($result);
		if (!empty($current))
		{
			$this->current_id=$current['id'];
			$this->current_parent_id=$current['parent'];
			if ($current['parent'] != 0) $this->get_parent($current['parent']);
			else $this->parent_id=$current['id'];
			
			$child='';
			$this->construct($child,$this->parent_id);
			$child=str_replace('<ul></ul>','',$child);
			if (!empty($child))
			{
				echo '<div class="child_menu">'.$child.'</div>';
			}
		}
	}
	
	function construct(&$html,$parent)
	{
		$conditions=array('parent' => $parent);
		
		$result=$this->navigator->get($conditions);
		
		$html.='<ul>';
		while($menu=$this->db->fetch_array($result))
		{
			if ($menu['mark'] == 'ghost') continue;
			
			if ($menu['parent']==$this->parent_id || in_array($menu['id'],$this->current_tree) || $menu['id']==$this->current_id || $menu['parent']==$this->current_parent_id || $menu['parent']==$this->current_id)
			{
				if ($menu['link'] == $this->navigator->current)
				{
				           $menu_link=(strpos($menu['link'],'http://')===0 || strpos($menu['link'],'https://')===0) ? '<a class="active" href="'.$menu['link'].'" target="_blank">'.$menu['name'].'</a>' : parent::build_anchor($menu['link'],$menu['name'],'active');
					$html.= '<li class="active">'.$menu_link;
				} else 
				{
				           $menu_link=(strpos($menu['link'],'http://')===0 || strpos($menu['link'],'https://')===0) ? '<a href="'.$menu['link'].'" target="_blank">'.$menu['name'].'</a>' : parent::build_anchor($menu['link'],$menu['name']);
					$html.= '<li>'.$menu_link;
				}
			}
			$this->construct($html,$menu['id']);
			
			if ($menu['parent']==$this->parent_id || in_array($menu['id'],$this->current_tree) || $menu['id']==$this->current_id || $menu['parent']==$this->current_parent_id || $menu['parent']==$this->current_id)
			{
			      $html.='</li>'; 
			}    
		}
		$html.='</ul>';
	}
	
	function get_parent($parent)
	{
		while (true) {	
			$this->current_tree[]=$parent;
			$conditions=array('id' => $parent);
			$result=$this->navigator->get($conditions);
			$menu=$this->db->fetch_array($result);
			if ($menu['parent'] != 0)
			{
				$parent=$menu['parent'];
			} else
			{
				$this->parent_id=$parent;
				break;
			}
		}
	}
}

function child_navigator_init($env)
{
	global $NavigatorChild;
	
	$NavigatorChild=new CNavigatorChild();
	$NavigatorChild->db=&$env['db'];
	$NavigatorChild->language=&$env['language'];
	$NavigatorChild->session=&$env['session'];
	$NavigatorChild->user=&$env['user'];
	$NavigatorChild->navigator=&$env['navigator'];
	$NavigatorChild->node=&$env['node'];
	$NavigatorChild->workspace=$env['workspace'];
}

function child_navigator_exec()
{
	global $NavigatorChild;
	
	$NavigatorChild->build();
}

function child_navigator_clear()
{
	global $NavigatorChild;
	
	unset(
		  $NavigatorChild->db,
		  $NavigatorChild->language,
		  $NavigatorChild->session,
		  $NavigatorChild->user,
		  $NavigatorChild->navigator,
		  $NavigatorChild->current_tree,
		  $NavigatorChild->parent_id,
		  $NavigatorChild->current_id,
		  $NavigatorChild->current_parent_id,
		  $NavigatorChild->node,
		  $NavigatorChild->workspace
		 );
}
?>