<?php
defined("SAWANNA") or die();

class CSawannaNewsAdmin extends CSawanna 
{
	var $db;
	var $session;
	var $language;
	var $node;
	var $utf8;
	var $message;
	var $error;
	var $_workspace;
	var $limit;
	var $get;
	
	function CSawannaNewsAdmin()
	{ 
		$this->db=null;
		$this->session=null;
		$this->language=null;
		$this->node=null;	
		$this->utf8=null;
		$this->message='';
		$this->error='';
		$this->_workspace='news';
		$this->limit=10;
		$this->get=(isset($_GET['get']) && !empty($_GET['get']) && is_numeric($_GET['get']) && $_GET['get']>0 ) ? $_GET['get'] : 1;
	}
	
	function build_linker()
	{
		$html='<div align="left" style="padding:10px">';
		
		if (!isset($_GET['act']))
		{
			$html.='&nbsp;&nbsp;&nbsp;'.parent::build_anchor(ADMIN_WORKSPACE.'/&component=news&act=create','<img src="'.HOME.'/sawanna/images/create.png" width="20" height="20" border="0" align="absmiddle" hspace="5" /><b>[string]create_news[/string]</b>');
		}
		$html.='<div style="border-bottom:1px solid #000000">&nbsp;</div><br />';
		
		$current=(intval($this->get)-1)*$this->limit+1;
		$co=0;
		$result=$this->node->get(array('workspace'=>$this->_workspace,'mark'=>'short'));
		while ($news=$this->db->fetch_array($result)) {
			$co++;
			if ($co<$current) continue;
			
			$html.='<div style="height:20px">'.parent::build_anchor(ADMIN_WORKSPACE.'/&component=news&act=edit&link='.$news['link'],'<img src="'.HOME.'/sawanna/images/edit.png" width="20" height="20" title="[string]edit[/string]" border="0" align="absmiddle" />').'&nbsp;&nbsp;'.parent::build_anchor(ADMIN_WORKSPACE.'/&component=news&act=del&link='.$news['link'],'<img src="'.HOME.'/sawanna/images/delete.png" width="20" height="20" title="[string]delete[/string]" border="0" align="absmiddle" />').'&nbsp;&nbsp;'.$news['link'].'&nbsp;&nbsp;'.$news['name'].'</div>';
			if ($co>=$this->limit+$current-1) break;
		}
		
		$count=$this->db->num_rows($result);
		if ($count > $this->limit)
		{
			$html.='<br /><br />';
			$html.=parent::build_limiter($count,$this->limit,ADMIN_WORKSPACE.'/&component=news',$this->get,true);
		}
		
		$html.='</div>';
		
		echo $html;
	}
	
	function build_create_form()
	{
		$title=(isset($_POST['title']) && !empty($_POST['title'])) ? $_POST['title'] : '';
		$short=(isset($_POST['short']) && !empty($_POST['short'])) ? $_POST['short'] : '';
		$content=(isset($_POST['content']) && !empty($_POST['content'])) ? $_POST['content'] : '';
		$keywords=(isset($_POST['keywords']) && !empty($_POST['keywords'])) ? $_POST['keywords'] : '';
		
		$html='';
			
		
		$elems=array(
					'text',
					'custom',
					'custom',
					'text',
					'submit'
					);
					
		$desc=array(
					'[string]title[/string]',
					'[string]short_description[/string]',
					'',
					'[string]keywords[/string]',
					' '
					);
		
		$attr=array(
					'name="title" style="width:250px" value="'.$title.'"',
					'',
					'',
					'name="keywords" style="width:200px" value="'.$keywords.'"',
					'value="[string]send[/string]"'
					);
					
		$custom=array(
					'',
					'<textarea name="short" cols="20" rows="4" style="width:250px">'.$short.'</textarea>',
					'<textarea name="content" id="newsfullEditor" cols="70" rows="20" style="width:100%">'.$content.'</textarea>'
					);
		
		$html.=parent::build_form(ADMIN_WORKSPACE.'/&component=news&act=docreate',$elems,500,$desc,$attr,$custom);
		$html.=parent::build_wysiwyg('newsfullEditor');
		
		echo $html; 
	}
	
	function create()
	{
		if (!isset($_POST['title']) || empty($_POST['title']))
		{
			$this->error='[string]news_title_required[/string]';
			$this->build_create_form();
			return ;
		}
		
		if (!isset($_POST['short']) || empty($_POST['short']))
		{
			$this->error='[string]news_short_required[/string]';
			$this->build_create_form();
			return ;
		}
		
		if (!isset($_POST['content']) || empty($_POST['content']))
		{
			$this->error='[string]news_content_required[/string]';
			$this->build_create_form();
			return ;
		}
		
		if (isset($_POST['keywords']) && !empty($_POST['keywords'])) {
			$keywords='';
			$_keywords=explode(',',$_POST['keywords']);
			$__keywords=array();
			
			foreach ($_keywords as $keyword)
			{
				$keyword=trim($keyword);
					
				$this->utf8->load_string($keyword);
				$this->utf8->to_lower();
				$keyword=$this->utf8->return_string();
				
				$__keywords[]=$keyword;
			} 
			$keywords=implode(',',$__keywords);
		} else 
		{
			$keywords='';
		}
		
		$link=date('d/m/Y-H/i/s',time());
		$title=strip_tags($_POST['title']);
		
		if (!$this->node->create($title,nl2br(strip_tags($_POST['short'])),'',$this->_workspace,$link,'short'))
		{
			$this->error='[string]database_error[/string]';
			$this->build_create_form();
			return ;
		}
		
		$content=$_POST['content'];
		
		$this->db->query("select value from ".DB_PREFIX."_global where mark='editor' and name='sawanna_wysiwyg'");
		$glob=$this->db->fetch_array();
		
		if (empty($glob))
		{
			$content=nl2br($content);
			$content=str_replace("\r",'',$content);
			$content=str_replace("\n",'',$content);
		}
		
		if (!$this->node->create($title,$content,$keywords,$this->_workspace,$link,'full'))
		{
			$this->error='[string]database_error[/string]';
			$this->build_create_form();
			return ;
		}
		
		$this->message='[string]news_created[/string]';
	}
	
	function build_edit_form($link)
	{
		$result=$this->node->get(array('link'=>$link,'mark'=>'short'));
		$news=$this->db->fetch_array($result);
		
		if (empty($news))
		{
			$this->error='[string]news_not_found[/string]';
			return;
		}
		
		$title=$news['name'];
		$short=$news['content'];
		
		$result=$this->node->get(array('link'=>$link,'mark'=>'full'));
		$news=$this->db->fetch_array($result);
		
		if (empty($news))
		{
			$this->error='[string]news_not_found[/string]';
			return;
		}
		
		$content=$news['content'];
		$keywords=$news['keywords'];
		
		$html='';
			
		
		$elems=array(
					'text',
					'custom',
					'custom',
					'text',
					'submit'
					);
					
		$desc=array(
					'[string]title[/string]',
					'[string]short_description[/string]',
					'',
					'[string]keywords[/string]',
					' '
					);
		
		$attr=array(
					'name="title" style="width:250px" value="'.$title.'"',
					'',
					'',
					'name="keywords" style="width:200px" value="'.$keywords.'"',
					'value="[string]send[/string]"'
					);
					
		$custom=array(
					'',
					'<textarea name="short" cols="20" rows="4" style="width:250px">'.str_replace('<br />',"",$short).'</textarea>',
					'<textarea name="content" id="newsfullEditor" cols="70" rows="20" style="width:100%">'.$content.'</textarea>'
					);
		
		$html.=parent::build_form(ADMIN_WORKSPACE.'/&component=news&act=doedit&link='.$link,$elems,500,$desc,$attr,$custom);
		$html.=parent::build_wysiwyg('newsfullEditor');
		
		echo $html; 
	}
	
	function edit($link)
	{
		if (!isset($_POST['title']) || empty($_POST['title']))
		{
			$this->error='[string]news_title_required[/string]';
			$this->build_edit_form($link);
			return ;
		}
		
		if (!isset($_POST['short']) || empty($_POST['short']))
		{
			$this->error='[string]news_short_required[/string]';
			$this->build_edit_form($link);
			return ;
		}
		
		if (!isset($_POST['content']) || empty($_POST['content']))
		{
			$this->error='[string]news_content_required[/string]';
			$this->build_edit_form($link);
			return ;
		}
		
		if (isset($_POST['keywords']) && !empty($_POST['keywords'])) {
			$keywords='';
			$_keywords=explode(',',$_POST['keywords']);
			$__keywords=array();
			
			foreach ($_keywords as $keyword)
			{
				$keyword=trim($keyword);
				
				$this->utf8->load_string($keyword);
				$this->utf8->to_lower();
				$keyword=$this->utf8->return_string();
				
				$__keywords[]=$keyword;
			} 
			$keywords=implode(',',$__keywords);
		} else 
		{
			$keywords='';
		}
		
		$title=strip_tags($_POST['title']);
		
		if (!$this->node->update(array('name'=>$title,'content'=>nl2br(strip_tags($_POST['short']))),array('workspace'=>$this->_workspace,'link'=>$link,'mark'=>'short')))
		{
			$this->error='[string]database_error[/string]';
			$this->build_edit_form($link);
			return ;
		}
		
		$content=$_POST['content'];
		
		$this->db->query("select value from ".DB_PREFIX."_global where mark='editor' and name='sawanna_wysiwyg'");
		$glob=$this->db->fetch_array();
		
		if (empty($glob))
		{
			$content=nl2br($content);
			$content=str_replace("\r",'',$content);
			$content=str_replace("\n",'',$content);
		}
		
		if (!$this->node->update(array('name'=>$title,'content'=>$content,'keywords'=>$keywords),array('link'=>$link,'mark'=>'full')))
		{
			$this->error='[string]database_error[/string]';
			$this->build_edit_form($link);
			return ;
		}
		
		$this->message='[string]news_edited[/string]';
	}
	
	function build_delete_form($link)
	{
		$html='';
		
		$result=$this->node->get(array('link'=>$link,'mark'=>'short'));
		$news=$this->db->fetch_array($result);
		
		if (empty($news))
		{
			$this->error='[string]news_not_found[/string]';
			return;
		}
		
		$title=$news['name'];
		$short=$news['content'];
		
		$html.='<div align="left" style="padding:10px">';
		$html.='<b style="text-decoration:underline">'.$title.'</b>';
		$html.='<br /><span>'.$short.'</span>';
		$html.='<p style="color:red">[string]news_delete_confirm[/string]</p>';
		$html.=parent::build_anchor(ADMIN_WORKSPACE.'/&component=news&act=dodel&link='.$link,'<b>[string]delete[/string]</b>');
		$html.='</div>';
		
		echo $html;
	}
	
	function delete($link)
	{
		if (!$this->node->delete(array('workspace'=>$this->_workspace,'link'=>$link)))
		{
			$this->error='[string]database_error[/string]';
			$this->build_delete_form($link);
			return ;
		}
		
		$this->message='[string]news_deleted[/string]';
	}
}

function newsAdmin_init($env)
{
	global $SawannaNewsAdmin;
	
	$SawannaNewsAdmin=new CSawannaNewsAdmin();
	$SawannaNewsAdmin->db=&$env['db'];
	$SawannaNewsAdmin->session=&$env['session'];
	$SawannaNewsAdmin->language=&$env['language'];
	$SawannaNewsAdmin->node=&$env['node'];
	$SawannaNewsAdmin->utf8=&$env['utf8'];
}

function newsAdmin_exec()
{
	global $SawannaNewsAdmin;
	
	if (isset($_GET['component']) && $_GET['component']=='news')
	{
		echo '<h2 class="header_caption"><img src="'.HOME.'/sawanna/images/wpalm.png" width="40" height="40" align="absmiddle">&nbsp;[string]news[/string] :</h2>';
		echo '<p style="padding:10px">[string]news_str[/string]</p>';
		echo '<div align="center" style="padding-top:10px;padding-bottom:10px">';
		
		if (isset($_GET['act']))
		{
			switch ($_GET['act'])
			{
				case 'create' :
					$SawannaNewsAdmin->build_create_form();
					break;
				case 'docreate' :
					$SawannaNewsAdmin->create();
					break;
				case 'edit' :
					if (isset($_GET['link']))
					$SawannaNewsAdmin->build_edit_form($_GET['link']);
					break;
				case 'doedit' :
					if (isset($_GET['link']))
					$SawannaNewsAdmin->edit($_GET['link']);
					break;
				case 'del' :
					if (isset($_GET['link']))
					$SawannaNewsAdmin->build_delete_form($_GET['link']);
					break;
				case 'dodel' :
					if (isset($_GET['link']))
					$SawannaNewsAdmin->delete($_GET['link']);
					break;
			}
		}
		
		$SawannaNewsAdmin->build_linker();
		
		echo '</div>';
	}
	
	return array($SawannaNewsAdmin->message,$SawannaNewsAdmin->error,'');
}

function newsAdmin_clear()
{
	global $SawannaNewsAdmin;
	
	unset(
		$SawannaNewsAdmin->db,
		$SawannaNewsAdmin->session,
		$SawannaNewsAdmin->language,
		$SawannaNewsAdmin->node,
		$SawannaNewsAdmin->utf8,
		$SawannaNewsAdmin->message,
		$SawannaNewsAdmin->error,
		$SawannaNewsAdmin->_workspace,
		$SawannaNewsAdmin->limit
		);
}
?>