<?php
defined("SAWANNA") or die();

class CSawannaNewsArchive extends CSawanna 
{
	var $session;
	var $language;
	var $node;
	var $db;
	var $workspace;
	var $_workspace;
	var $limit;
	var $delay;
	
	function CSawannaNewsArchive()
	{
		$this->session=null;
		$this->language=null;
		$this->node=null;
		$this->db=null;
		$this->workspace='';
		$this->_workspace='news';
		$this->limit=4;
		$this->delay=0;
	}
	
	function build()
	{
		$html='';
		$archive=array();
		
		$result=$this->node->get(array('workspace'=>$this->_workspace,'mark'=>'short'));
		
		$co=0;
		while ($news=$this->db->fetch_array($result))
		{
			$year=date('Y',$news['published']);
			$month=date('m',$news['published']);
			if (!isset($archive[$year]))
			{
				$archive[$year]=array();
				$co++;
			}
			if ($co > $this->limit) break;
			if (!array_key_exists($month,$archive[$year])) $archive[$year][$month]=parent::build_anchor($this->_workspace.'/archive/&year='.$year.'&month='.$month,$month);
		}
		
		if (!empty($archive) && count($archive)>$this->delay)
		{
			$html.='<div class="archive"><table cellspacing="2"><tr>';
			
			$archive=array_reverse($archive,true);
			
			foreach ($archive as $year=>$months)
			{
				$months=array_reverse($months,true);
				
				$html.='<td valign="top">';
				$html.='<span class="news_archive_year">'.$year.'</span>';
				foreach ($months as $month=>$link)
				{
					$html.='<span class="news_archive_month">&nbsp;'.$link.'</span>';
				}
				$html.='</td>';
			}
			
			$html.='</tr></table></div>';
		}
		
		echo $this->build_archive_field($html);
	}
	
	function build_archive_field($archive)
	{
		if (empty($archive)) return ;
		
		$html='<div class="field_caption">[string]archive[/string]</div>';
		$html.='<div class="field_body">'.$archive.'</div>';
		$html.='<div style="width:100%" class="shadow_1"></div>';
		
		return $html;
	}
}

function archive_init($env)
{
	global $SawannaNewsArchive;
	
	$SawannaNewsArchive=new CSawannaNewsArchive();
	$SawannaNewsArchive->session=&$env['session'];
	$SawannaNewsArchive->language=&$env['language'];
	$SawannaNewsArchive->node=&$env['node'];
	$SawannaNewsArchive->db=&$env['db'];
	$SawannaNewsArchive->workspace=$env['workspace'];
}

function archive_exec()
{
	global $SawannaNewsArchive;
	
	if ($SawannaNewsArchive->workspace == $SawannaNewsArchive->_workspace)
	{
		$SawannaNewsArchive->build();
	}
}

function archive_clear()
{
	global $SawannaNewsArchive;
	
	unset(
		$SawannaNewsArchive->session,
		$SawannaNewsArchive->language,
		$SawannaNewsArchive->node,
		$SawannaNewsArchive->db,
		$SawannaNewsArchive->workspace,
		$SawannaNewsArchive->_workspace,
		$SawannaNewsArchive->limit,
		$SawannaNewsArchive->delay
		);
}

?>