<?php
defined("SAWANNA") or die();

class CSawannaNews extends CSawanna 
{
	var $db;
	var $session;
	var $language;
	var $node;
	var $error;
	var $workspace;
	var $query;
	var $limit;
	var $get;
	var $_workspace;
	var $rss_limit;
	var $display_rss_link;
	var $archive_limit;
	
	function CSawannaNews()
	{
		$this->db=null;
		$this->session=null;
		$this->language=null;
		$this->node=null;
		$this->error='';
		$this->limit=5;
		$this->workspace=FRONT_PAGE_WORKSPACE;
		$this->query=1;
		$this->get=(isset($_GET['get']) && !empty($_GET['get']) && is_numeric($_GET['get']) && $_GET['get']>0 ) ? $_GET['get'] : 1;
		$this->_workspace='news';
		$this->rss_limit=10;
		$this->display_rss_link=true;
		$this->archive_limit=10;
	}
	
	function build_linker()
	{
		$html='<br clear="all" />';
		
		if ($this->display_rss_link)
		{
			$html.='<div style="float:right">';
			$html.=parent::build_anchor('rss/news','<img src="'.HOME.'/sawanna/images/rss.png" width="80" height="15" border="0" hspace="10" />');	
			$html.='</div>';
		}
		
		$html.='<div align="left" style="padding:10px">';
		$html.='<div style="width:100px;border-bottom:1px solid #000000">&nbsp;</div>';
		
		$html.='<br />';
		
		$current=(intval($this->get)-1)*$this->limit+1;
		$co=0;
		$result=$this->node->get(array('workspace'=>$this->_workspace,'mark'=>'short'));
		while ($news=$this->db->fetch_array($result)) {
			$co++;
			if ($co<$current) continue;
			
			$comments=array('workspace'=>$this->_workspace,'link'=>$news['link'],'mark'=>'comment','access'=>'1');
			$res=$this->node->get($comments);
			$count=$this->db->num_rows($res);
			
			$get=($this->get > 1) ? '&get='.$this->get : '';
			$html.='<div class="news_date">'.date('d.m.Y',$news['published']).'&nbsp;&nbsp;'.parent::build_anchor($this->_workspace.'/'.$news['link'].$get,'<span class="news_name">'.$news['name'].'</span>').'</div>';
			$html.='<span class="news_short">'.$news['content'].'</span>';
			$html.= '<br /><div class="news_comments">[string]comments[/string] : '.((!empty($count)) ? $count : 0).'</div>';
			$html.='<br /><br />';
			if ($co>=$this->limit+$current-1) break;
		}
		
		$count=$this->db->num_rows($result);
		if ($count > $this->limit)
		{
			$html.='<br /><br />';
			$html.=parent::build_limiter($count,$this->limit,$this->_workspace.'/',$this->get,true);
		}
		
		$html.='</div>';
		
		echo $html;
	}
	
	function display()
	{
		$html='<div align="left" style="padding:10px">';
		
		$result=0;
		if (!empty($this->query))
		{
			$result=$this->node->get(array('workspace'=>$this->_workspace,'link'=>$this->query,'mark'=>'full'));
		} else 
		{
			$result=$this->node->get(array('workspace'=>$this->_workspace,'mark'=>'full'));
		}
		
		$news=$this->db->fetch_array($result);
		
		if (!empty($news))
		{
			$html.='<div class="news_published_date">'.date('d.m.Y',$news['published']).'&nbsp;&nbsp;'.'<span class="news_cap">'.$news['name'].'</span></div>';
			$html.=$news['content'];
		} elseif (!empty($this->query)) 
		{
			$this->error='[string]news_not_found[/string]';
			if (!defined('NO_COMMENTS')) define('NO_COMMENTS',1);
			return ;
		}
		
		$html.='</div>';
		
		echo $html;
	}
	
	function display_archive($year,$month)
	{
		if (!defined('NO_COMMENTS')) define('NO_COMMENTS',1);
		
		if (!is_numeric($year) || !is_numeric($month)) return ;
		
		$html='';
		
		$published_start=mktime(0,0,0,$month,1,$year);
		$published_end=mktime(0,0,0,$month+1,1,$year);
		
		$html.='<div align="left" style="padding:10px">';
		$html.='<div style="width:100px;border-bottom:1px solid #000000">&nbsp;</div>';
		
		$html.='<br />';
		
		$current=(intval($this->get)-1)*$this->archive_limit+1;
		$co=0;
		$this->db->query("select * from ".DB_PREFIX."_nodes where workspace='".$this->db->escape_string($this->_workspace)."' and language='".$this->db->escape_string($this->language->current)."' and mark='short' and published >= '".$this->db->escape_string($published_start)."' and published < '".$this->db->escape_string($published_end)."' order by published");
		while ($news=$this->db->fetch_array()) {
			$co++;
			if ($co<$current) continue;
			
			$get=($this->get > 1) ? '&get='.$this->get : '';
			$html.='<div class="news_date">'.date('d.m.Y',$news['published']).'&nbsp;&nbsp;'.parent::build_anchor($this->_workspace.'/archive/&year='.$year.'&month='.$month.'&link='.$news['link'].$get,'<b style="fonr-size:11px">'.$news['name'].'</b>').'</div>';
			$html.='<span class="news_short">'.$news['content'].'</span>';
			$html.='<br /><br />';
			if ($co>=$this->archive_limit+$current-1) break;
		}
		
		$count=$this->db->num_rows();
		if ($count > $this->archive_limit)
		{
			$html.='<br /><br />';
			$html.=parent::build_limiter($count,$this->archive_limit,$this->_workspace.'/archive/&year='.$year.'&month='.$month,$this->get,true);
		}
		
		$html.='</div>';

		
		if (empty($count))
		{
			$this->error='[string]news_not_found[/string]';
			return ;
		}
		
		echo $html;
	}
	
	function build_rss() {
		
		$html='';
		
		$html.='<?xml version="1.0" encoding="utf-8"?>'."\n";
		$html.='<rss version="2.0">'."\n";
		$html.='<channel>'."\n";
		$html.='<title>'.SITE_NAME.' : [string]news[/string]</title>'."\n";
		$html.='<link>'.parent::build_url($this->_workspace,false,true).'</link>'."\n";
		$html.='<description>'.SITE_HOST.' - RSS</description>'."\n";
		$html.='<generator>Sawanna CMS ver.'.VERSION.'</generator>'."\n";

		$co=0;
		$result=$this->node->get(array('workspace'=>$this->_workspace,'mark'=>'short'));
		while ($news=$this->db->fetch_array($result)) {
			$co++;
			$html.='<item>'."\n";
			$html.='<title>'.$news['name'].'</title>'."\n";
			$html.='<link>'.parent::build_url($this->_workspace.'/'.$news['link'],false,true).'</link>'."\n";
			$html.='<description>'.strip_tags($news['content']).'</description>'."\n";
			$html.='<guid isPermaLink="true">'.parent::build_url($this->_workspace.'/'.$news['link'],false,true).'</guid>'."\n";
			$html.='<pubDate>'.date('r',$news['published']).'</pubDate>'."\n";
			$html.='</item>'."\n";
			if ($co >= $this->rss_limit) break;
		}
		$html.='</channel>'."\n";
		$html.='</rss>';
		
		echo $html;
	}
}

function news_init($env)
{
	global $SawannaNews;
	
	$SawannaNews=new CSawannaNews();
	$SawannaNews->db=&$env['db'];
	$SawannaNews->session=&$env['session'];
	$SawannaNews->language=&$env['language'];
	$SawannaNews->node=&$env['node'];
	$SawannaNews->workspace=$env['workspace'];
	$SawannaNews->query=$env['query'];
}

function news_exec()
{
	global $SawannaNews;
	
	if ($SawannaNews->workspace == 'rss')
	{
		$SawannaNews->build_rss();
	} elseif ($SawannaNews->workspace == $SawannaNews->_workspace)
	{
		if ($SawannaNews->query != 'archive')
		{
			$SawannaNews->display();
			if (empty($SawannaNews->query))
				$SawannaNews->build_linker();
		} elseif (isset($_GET['year'],$_GET['month'])) 
		{
			if (isset($_GET['link'])) 
			{
				$SawannaNews->query=$_GET['link'];
				$SawannaNews->display();
			}
			$SawannaNews->display_archive($_GET['year'],$_GET['month']);
		}
	}
	return array('',$SawannaNews->error,'[string]news[/string]');
}

function news_clear()
{
	global $SawannaNews;
	
	unset(
		$SawannaNews->db,
		$SawannaNews->session,
		$SawannaNews->language,
		$SawannaNews->node,
		$SawannaNews->error,
		$SawannaNews->workspace,
		$SawannaNews->query,
		$SawannaNews->limit,
		$SawannaNews->get,
		$SawannaNews->_workspace,
		$SawannaNews->rss_limit,
		$SawannaNews->display_rss_link,
		$SawannaNews->archive_limit
		);
}