<?php
defined("SAWANNA") or die();

class CPage extends CSawanna 
{
	var $db;
	var $node;
	var $user;
	var $language;
	var $session;
	var $workspace;
	var $query;
	var $title;
	var $navigator;
	var $_workspace;
	var $error;
	
	function CPage()
	{
		$this->db=null;
		$this->node=null;
		$this->user=null;
		$this->language=null;
		$this->session=null;
		$this->workspace=null;
		$this->query=null;
		$this->title='';
		$this->navigator=null;
		$this->_workspace='public';
		$this->error='';
	}
	
	function build()
	{
		echo '<div class="node" id="node">';
		
		if ($this->workspace==FRONT_PAGE_WORKSPACE)
		{
			$_result=$this->navigator->get(array('parent'=>0));
			while ($menu=$this->db->fetch_array($_result)) {
				if (($p=strpos($menu['link'],'/'))===false) continue;
				if (substr($menu['link'],0,$p) != $this->_workspace) continue;
				
				$node=array('workspace'=>$this->_workspace,'link'=>substr($menu['link'],$p+1),'mark'=>'');
				$result=$this->node->get($node);
				if (!empty($result)) break;
			}
		} else
		{
			$node=array('workspace'=>$this->_workspace,'link'=>$this->query,'mark'=>'');
			$result=$this->node->get($node);
		}
		
		if (isset($result) && !empty($result)) $node=$this->db->fetch_array($result);
		
		if (isset($node) && !empty($node))
		{
			$this->title=$node['name'];
			
			if (!empty($node['content']))
			{
				echo $node['content'];
			} else
			{
				$_res=$this->db->sub_query("select id from ".DB_PREFIX."_navigation where link='".$this->db->escape_string($this->workspace.'/'.$node['link'])."'");
				$menu=$this->db->fetch_array($_res);
				
				echo '<div class="map">'.$this->build_navigator_tree($menu['id']).'</div>';
			}
		} elseif ($this->workspace != FRONT_PAGE_WORKSPACE)
		{
			$this->db->query("select access from ".DB_PREFIX."_nodes where workspace='".$this->db->escape_string($this->_workspace)."' and link='".$this->db->escape_string($this->query)."' and language='".$this->db->escape_string($this->language->current)."'");
			$node=$this->db->fetch_array();
			if (!empty($node))
			{
				switch ($node['access'])
				{
					case 2 :
						$this->error='[string]please_login[/string]';
						break;
					case 0 :
						$this->error='[string]access_denied[/string]';
						break;
				}
			} elseif (!empty($this->query)) 
			{
				$this->error='[string]page_not_found[/string]';
			}
		}
		
		echo '</div>';
	}
	
	function show_links()
	{
		echo '<div class="map">';
		echo $this->build_navigator_tree();
		echo '</div>';
	}
	
	function build_navigator_tree($parent=0,$co=0)
	{
		static $map;
		
		$offset=str_repeat("&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; ",$co);
		
		$result=$this->navigator->get(array('parent'=>$parent));
		while($menu=$this->db->fetch_array($result))
		{
			if (strpos($menu['link'],$this->_workspace.'/')===false) continue;
			
			if ($co==0) $_offset='<br />&bull; '; else $_offset=$offset.' &rarr; ';
			$map.=$_offset.parent::build_anchor($menu['link'],$menu['name'],'map_link').'<br />';
			$this->build_navigator_tree($menu['id'],$co+1);
		}
		return $map;
	}
}

function node_init($env)
{
	global $SawannaPage;
	
	$SawannaPage=new CPage();
	$SawannaPage->db=&$env['db'];
	$SawannaPage->node=&$env['node'];
	$SawannaPage->user=&$env['user'];
	$SawannaPage->language=&$env['language'];
	$SawannaPage->session=&$env['session'];
	$SawannaPage->workspace=&$env['workspace'];
	$SawannaPage->query=&$env['query'];
	$SawannaPage->navigator=&$env['navigator'];
}

function node_exec()
{
	global $SawannaPage;
				
	if (empty($SawannaPage->query) && $SawannaPage->workspace!=FRONT_PAGE_WORKSPACE) $SawannaPage->show_links();
	$SawannaPage->build();
	return array('',$SawannaPage->error,$SawannaPage->title);
}

function node_clear()
{
	global $SawannaPage;
	
	unset(
		$SawannaPage->db,
		$SawannaPage->node,
		$SawannaPage->user,
		$SawannaPage->language,
		$SawannaPage->session,
		$SawannaPage->workspace,
		$SawannaPage->query,
		$SawannaPage->title,
		$SawannaPage->navigator,
		$SawannaPage->error
		);
}
?>