<?php
defined("SAWANNA") or die();

class CSawannaAddons extends CSawanna 
{
	var $language;
	var $session;
	var $db;
	var $error;
	var $message;
	
	function CSawannaAddons()
	{
		$this->language=null;
		$this->session=null;
		$this->db=null;
		$this->error='';
		$this->message='';
	}
	
	function build_form()
	{
		
		$html='';
			
		$elems=array();
		$desc=array();
		$attr=array();
		
		$addons=array();
		$this->db->query("select mark from ".DB_PREFIX."_global");
		while($glob=$this->db->fetch_array())
		{
			if (!empty($glob['mark']))
				$addons[]=$glob['mark'];
		}
		
		$addons_dir=opendir(ROOT_DIR.'/addons');
		
		while (($file=readdir($addons_dir))!==false) {
			if (is_dir(ROOT_DIR.'/addons/'.quotemeta($file)) && $file!='.' && $file!='..' && file_exists(ROOT_DIR.'/addons/'.quotemeta($file).'/global.php'))
			{
				$file=htmlspecialchars($file);
				
				require(ROOT_DIR.'/addons/'.quotemeta($file).'/global.php');
				$addon_name=$file.'_name';
				$addon_desc=$file.'_description';
				$addon_glob=$file.'_global';
				
				if (isset($$addon_name,$$addon_desc,$$addon_glob))
				{
					$elems[]='checkbox';
					$desc[]='<b>'.htmlspecialchars($$addon_name).'</b> ('.htmlspecialchars($$addon_desc).')';
					
					if (in_array($file,$addons))
						$attr[]='name="'.$file.'" checked';
					else 
						$attr[]='name="'.$file.'"';
				}
			}
		}
		
		closedir($addons_dir);
		
		$elems[]='hidden';
		$desc[]=' ';
		$attr[]='name="dosave" value="true"';
		
		$elems[]='submit';
		$desc[]=' ';
		$attr[]='value="[string]send[/string]"';
					
		$html.=parent::build_form(ADMIN_WORKSPACE.'/&component=addons&act=save',$elems,500,$desc,$attr);
		
		echo $html; 
	}
	
	function save()
	{
		$addons_ex=array();
		$this->db->query("select mark from ".DB_PREFIX."_global");
		while($glob=$this->db->fetch_array())
		{
			if (!empty($glob['mark']))
				$addons_ex[]=$this->db->escape_string($glob['mark']);
		}
		
		$addons=array();
		
		foreach ($_POST as $addon=>$status)
		{
			if ($status == 'on') $addons[]=$this->db->escape_string($addon);
			
			if ($status == 'on' && !in_array($addon,$addons_ex))
			{
				if (is_dir(ROOT_DIR.'/addons/'.quotemeta($addon)) && file_exists(ROOT_DIR.'/addons/'.quotemeta($addon).'/global.php'))
				{
					require(ROOT_DIR.'/addons/'.quotemeta($addon).'/global.php');
					$addon_name=$addon.'_name';
					$addon_desc=$addon.'_description';
					$addon_glob=$addon.'_global';
					
					if (isset($$addon_name,$$addon_desc,$$addon_glob))
					{
						foreach ($$addon_glob as $name=>$value)
						{
							if (is_array($value))
							{
								if (!$this->db->query("insert into ".DB_PREFIX."_global (name,value,mark) values ('".$this->db->escape_string($name)."','".$this->db->escape_string(serialize($value))."','".$this->db->escape_string($addon)."')"))
								{
									$this->error='[string]database_error[/string]';
								}
							} else 
							{
								$this->error='[string]changes_save_failed[/string]';
							}
						}
					} else 
					{
						$this->error='[string]changes_save_failed[/string]';
					}
					
					if (file_exists(ROOT_DIR.'/addons/'.$addon.'/language'))
					{
						foreach ($this->language->languages as $lang_file=>$lang_name)
						{
							$lang_file=quotemeta($lang_file);
							if (file_exists(ROOT_DIR.'/addons/'.$addon.'/language/'.$lang_file.".php"))
							{
								require(ROOT_DIR.'/addons/'.$addon.'/language/'.$lang_file.'.php');
								$addon_lng=$addon."_language_words_".$lang_file;
								if (isset($$addon_lng) && is_array($$addon_lng))
								{ 
									if (!$this->db->query("insert into ".DB_PREFIX."_global (name,value,mark) values ('".$this->db->escape_string('language_words_'.$lang_file)."','".$this->db->escape_string(serialize($$addon_lng))."','".$this->db->escape_string($addon)."')"))
									{
										$this->error='[string]database_error[/string]';
									}
								}
							} elseif (file_exists(ROOT_DIR.'/addons/'.$addon.'/language/'.DEFAULT_LANGUAGE.".php"))
							{
								require(ROOT_DIR.'/addons/'.$addon.'/language/'.DEFAULT_LANGUAGE.'.php');
								$addon_lng=$addon."_language_words_".DEFAULT_LANGUAGE;
								if (isset($$addon_lng) && is_array($$addon_lng))
								{ 
									if (!$this->db->query("insert into ".DB_PREFIX."_global (name,value,mark) values ('".$this->db->escape_string('language_words_'.$lang_file)."','".$this->db->escape_string(serialize($$addon_lng))."','".$this->db->escape_string($addon)."')"))
									{
										$this->error='[string]database_error[/string]';
									}
								}
							}
						}
					}
				} else 
				{
					$this->error='[string]changes_save_failed[/string]';
				}
			}
		}
		
		$diff=array_diff($addons_ex,$addons);
		
		if (!empty($diff))
		{
			if (!$this->db->query("delete from ".DB_PREFIX."_global where mark in ('".implode("','",$diff)."')"))
			{
				$this->error='[string]database_error[/string]';
			}
		}
		
		if (empty($this->error))
		{
			$this->message='[string]changes_save_success[/string]';
			$this->error='[string]refresh_page[/string]';
		}
	}
}

function addons_init($env)
{
	global $SawannaAddons;
	
	$SawannaAddons=new CSawannaAddons();
	$SawannaAddons->session=&$env['session'];
	$SawannaAddons->language=&$env['language'];
	$SawannaAddons->db=&$env['db'];
}

function addons_exec()
{
	global $SawannaAddons;
	
	if (isset($_GET['component']) && $_GET['component']=='addons')
	{
		echo '<h2 class="header_caption"><img src="'.HOME.'/sawanna/images/wpalm.png" width="40" height="40" align="absmiddle">&nbsp;[string]addons[/string] :</h2>';
		echo '<p style="padding:10px">[string]addons_str[/string]</p>';
		echo '<div align="center" style="padding-top:10px;padding-bottom:10px">';
		
		if (isset($_GET['act']) && $_GET['act'] == 'save' && isset($_POST['dosave']) && $_POST['dosave']=='true')
		{
			$SawannaAddons->save();
		}
		
		$SawannaAddons->build_form();
		
		echo '</div>';
	}
	
	return array($SawannaAddons->message,$SawannaAddons->error,'');
}

function addons_clear()
{
	global $SawannaAddons;
	
	unset(
		$SawannaAddons->session,
		$SawannaAddons->language,
		$SawannaAddons->db,
		$SawannaAddons->error,
		$SawannaAddons->message
		);
}
?>