<?php
defined("SAWANNA") or die();

class CSawannaAdminBar extends CSawanna 
{
	var $session;
	var $language;
	var $db;
	
	function CSawannaAdminBar()
	{
		$this->session=null;
		$this->language=null;
		$this->db=null;
	}
	
	function build()
	{
		$this->db->query("select * from ".DB_PREFIX."_users where login <> ''");
		$user_count=$this->db->num_rows();
		$this->db->query("select id from ".DB_PREFIX."_nodes where mark = 'comment' and access='0'");
		if ($comments_count=$this->db->num_rows())
		{
			$new_comments='&nbsp;('.$comments_count.')';
		} else 
		{
			$new_comments='';
		}
			
		$html='<div class="field_caption">Sawanna CMS</div>';
		$html.='<div class="adminBar">';
		$html.='<img src="'.HOME.'/sawanna/images/palm.png" width="20" height="20" align="absmiddle">&nbsp;&nbsp;'.parent::build_anchor(ADMIN_WORKSPACE.'/&component=phpinfo','[string]phpinfo[/string]').'<br />';
		$html.='<img src="'.HOME.'/sawanna/images/palm.png" width="20" height="20" align="absmiddle">&nbsp;&nbsp;'.parent::build_anchor(ADMIN_WORKSPACE.'/&component=config','[string]configuration[/string]').'<br />';
		$html.='<img src="'.HOME.'/sawanna/images/palm.png" width="20" height="20" align="absmiddle">&nbsp;&nbsp;'.parent::build_anchor(ADMIN_WORKSPACE.'/&component=stat','[string]statistics[/string]').'<br />';
		$html.='<br /><br />';
		$html.='<span style="height:20px;line-height:20px">&nbsp;&nbsp;&nbsp;&nbsp;<img src="'.HOME.'/sawanna/images/point.png" width="10" height="10" align="absmiddle">&nbsp;&nbsp;'.parent::build_anchor(ADMIN_WORKSPACE.'/&component=userAdmin','[string]users[/string]&nbsp;('.$user_count.')').'</span><br />';
		$html.='<span style="height:20px;line-height:20px">&nbsp;&nbsp;&nbsp;&nbsp;<img src="'.HOME.'/sawanna/images/point.png" width="10" height="10" align="absmiddle">&nbsp;&nbsp;'.parent::build_anchor(ADMIN_WORKSPACE.'/&component=files','[string]files[/string]').'</span><br />';
		$html.='<span style="height:20px;line-height:20px">&nbsp;&nbsp;&nbsp;&nbsp;<img src="'.HOME.'/sawanna/images/point.png" width="10" height="10" align="absmiddle">&nbsp;&nbsp;'.parent::build_anchor(ADMIN_WORKSPACE.'/&component=page&act=show','[string]page[/string]').'</span><br />';
		$html.='<span style="height:20px;line-height:20px">&nbsp;&nbsp;&nbsp;&nbsp;<img src="'.HOME.'/sawanna/images/point.png" width="10" height="10" align="absmiddle">&nbsp;&nbsp;'.parent::build_anchor(ADMIN_WORKSPACE.'/&component=article&act=show','[string]article[/string]').'</span><br />';
		$html.='<span style="height:20px;line-height:20px">&nbsp;&nbsp;&nbsp;&nbsp;<img src="'.HOME.'/sawanna/images/point.png" width="10" height="10" align="absmiddle">&nbsp;&nbsp;'.parent::build_anchor(ADMIN_WORKSPACE.'/&component=news','[string]news[/string]').'</span><br />';
		$html.='<span style="height:20px;line-height:20px">&nbsp;&nbsp;&nbsp;&nbsp;<img src="'.HOME.'/sawanna/images/point.png" width="10" height="10" align="absmiddle">&nbsp;&nbsp;'.parent::build_anchor(ADMIN_WORKSPACE.'/&component=commentsAdmin','[string]comments[/string]'.$new_comments).'</span><br />';
		$html.='<span style="height:20px;line-height:20px">&nbsp;&nbsp;&nbsp;&nbsp;<img src="'.HOME.'/sawanna/images/point.png" width="10" height="10" align="absmiddle">&nbsp;&nbsp;'.parent::build_anchor(ADMIN_WORKSPACE.'/&component=menu','[string]navigation[/string]').'</span><br />';
		
		$this->db->query("select value from ".DB_PREFIX."_global where name='sawanna_admin_bar'");
		while($bar=$this->db->fetch_array())
		{
			$adminbar=unserialize($bar['value']);
			$html.='<span style="height:20px;line-height:20px">&nbsp;&nbsp;&nbsp;&nbsp;<img src="'.HOME.'/sawanna/images/point.png" width="10" height="10" align="absmiddle">&nbsp;&nbsp;'.parent::build_anchor($adminbar['link'],$adminbar['name']).'</span><br />';
		}
		
		$html.='<br /><br />';
		$html.='<img src="'.HOME.'/sawanna/images/palm.png" width="20" height="20" align="absmiddle">&nbsp;&nbsp;'.parent::build_anchor(ADMIN_WORKSPACE.'/&component=addons','[string]addons[/string]').'<br />';
		$html.='<img src="'.HOME.'/sawanna/images/palm.png" width="20" height="20" align="absmiddle">&nbsp;&nbsp;'.parent::build_anchor(ADMIN_WORKSPACE.'/&component=langpack','[string]language_packs[/string]').'<br />';
		$html.='<img src="'.HOME.'/sawanna/images/palm.png" width="20" height="20" align="absmiddle">&nbsp;&nbsp;'.parent::build_anchor(ADMIN_WORKSPACE.'/&component=themes','[string]themes[/string]').'<br />';
		$html.='<img src="'.HOME.'/sawanna/images/palm.png" width="20" height="20" align="absmiddle">&nbsp;&nbsp;'.'<a href="http://sawanna.org">[string]support[/string]</a><br />';
		$html.='</div>';
		$html.='<div style="width:100%" class="shadow_1"></div>';
		
		echo $html;
	}
}

function adminBar_init($env)
{
	global $SawannaAdminBar;
	
	$SawannaAdminBar=new CSawannaAdminBar();
	$SawannaAdminBar->session=&$env['session'];
	$SawannaAdminBar->language=&$env['language'];
	$SawannaAdminBar->db=&$env['db'];
}

function adminBar_exec()
{
	global $SawannaAdminBar;
	
	$SawannaAdminBar->build();
}

function adminBar_clear()
{
	global $SawannaAdminBar;
	
	unset(
		$SawannaAdminBar->session,
		$SawannaAdminBar->language,
		$SawannaAdminBar->db
		);
}
?>