<?php
defined("SAWANNA") or die();

class CSawannaConf extends CSawanna 
{
	var $language;
	var $session;
	var $db;
	var $user;
	var $error;
	var $message;
	
	function CSawannaConf()
	{
		$this->language=null;
		$this->session=null;
		$this->db=null;
		$this->user;
		$this->error='';
		$this->message='';
	}
	
	function build_form()
	{
		
		$html='';
			
		$elems=array();
		$desc=array();
		$attr=array();
		$custom=array();
		
		$this->db->query("select id from ".DB_PREFIX."_configuration where name='SITE_SLOGAN' and mark='".$this->db->escape_string($this->language->current)."'");
		$slogan_ex=$this->db->num_rows();
		
		$this->db->query("select * from ".DB_PREFIX."_configuration");
		while($constant=$this->db->fetch_array())
		{
			
			switch ($constant['name'])
			{
				case 'THEME' :
					$elems[]='custom';
					$desc[]='[string]'.$constant['name'].'[/string]';
					if (!empty($constant['mark'])) $desc[count($desc)-1].=' ('.$constant['mark'].')';
					$attr[]='';
					$custom_elem='<select name="'.$constant['name'].'" style="width:100px">';
					
					$templates_dir=opendir(ROOT_DIR.'/theme');
					while (($file=readdir($templates_dir))!==false)
					{
						$file=htmlspecialchars($file);
						
						if (is_dir(ROOT_DIR.'/theme/'.$file) && $file !='.' && $file != '..')
						{
							if ($file==$constant['value'])
								$custom_elem.='<option value="'.$file.'" selected>'.$file.'</option>';
							else 
								$custom_elem.='<option value="'.$file.'">'.$file.'</option>';
						}
					}
					closedir($templates_dir);
					$custom_elem.='</select>';
					$custom[]=$custom_elem;
					break;
				case 'CHECK_IF_COOKIES_ENABLED' :
				case 'CLEAN_URL' :
				case 'ALLOW_USER_REGISTER' :
				case 'GZIP_OUT' :
				case 'SESSION_EMULATE' :
				case 'USER_E_MAIL_CHECK' :
				case 'ALLOW_COMMENTS' :
				case 'COMMENTS_APPROVE' :
					$elems[]='custom';
					$desc[]='[string]'.$constant['name'].'[/string]';
					if (!empty($constant['mark'])) $desc[count($desc)-1].=' ('.$constant['mark'].')';
					$attr[]='';
					$custom_elem='<select name="'.$constant['name'].'" style="width:100px">';
					if ($constant['value'] == 0)
					{
						$custom_elem.='<option value="0" selected>[string]no[/string]</option>';
						$custom_elem.='<option value="1">[string]yes[/string]</option>';
					} else 
					{
						$custom_elem.='<option value="0">[string]no[/string]</option>';
						$custom_elem.='<option value="1" selected>[string]yes[/string]</option>';
					}
					$custom_elem.='</select>';
					$custom[]=$custom_elem;
					break;
				case 'DEFAULT_LANGUAGE' :
					$elems[]='custom';
					$desc[]='[string]'.$constant['name'].'[/string]';
					if (!empty($constant['mark'])) $desc[count($desc)-1].=' ('.$constant['mark'].')';
					$attr[]='';
					$custom_elem='<select name="'.$constant['name'].'" style="width:100px">';
					foreach ($this->language->languages as $lang=>$lang_name)
					{
						if ($constant['value'] == $lang)
							$custom_elem.='<option value="'.$lang.'" selected>'.$lang_name.'</option>';
						else 
							$custom_elem.='<option value="'.$lang.'">'.$lang_name.'</option>';
					}
					$custom_elem.='</select>';
					$custom[]=$custom_elem;
					break;
				case 'SITE_SLOGAN' :
					if ($slogan_ex)
					{
						if ($constant['mark'] == $this->language->current)
						{
							$elems[]='text';
							$desc[]='[string]'.$constant['name'].'[/string]';
							if (!empty($constant['mark'])) $desc[count($desc)-1].=' ('.$constant['mark'].')';
							$attr[]='name="'.$constant['name'].'" style="width:250px" value="'.htmlspecialchars($constant['value']).'"';
							$custom[]='';
						}
					} else 
					{
						if ($constant['mark'] == DEFAULT_LANGUAGE)
						{
							$elems[]='text';
							$desc[]='[string]'.$constant['name'].'[/string]';
							if (!empty($constant['mark'])) $desc[count($desc)-1].=' ('.$constant['mark'].')';
							$attr[]='name="'.$constant['name'].'" style="width:250px" value="'.htmlspecialchars($constant['value']).'"';
							$custom[]='';
						}
					}
					break;
				default :
					$elems[]='text';
					$desc[]='[string]'.$constant['name'].'[/string]';
					if (!empty($constant['mark'])) $desc[count($desc)-1].=' ('.$constant['mark'].')';
					$attr[]='name="'.$constant['name'].'" style="width:250px" value="'.htmlspecialchars($constant['value']).'"';
					$custom[]='';
					break;
			}
		}
		
		$elems[]='submit';
		$desc[]=' ';
		$attr[]='value="[string]send[/string]"';
					
		$html.=parent::build_form(ADMIN_WORKSPACE.'/&component=config&act=save',$elems,500,$desc,$attr,$custom);
		
		echo $html; 
	}
	
	function save()
	{
		global $sawanna_templates;
		
		$this->db->query("select id from ".DB_PREFIX."_configuration where name='SITE_SLOGAN' and mark='".$this->db->escape_string($this->language->current)."'");
		$slogan_ex=$this->db->num_rows();
		
		foreach ($_POST as $key => $value)
		{
			switch ($key)
			{
				case 'THEME' :
					if (!empty($value))
					{
						$theme=quotemeta($value);
						if (file_exists(ROOT_DIR.'/theme/'.$theme.'/'.$sawanna_templates[ADMIN_WORKSPACE].'.tpl'))
						{
							if (!$this->db->query("update ".DB_PREFIX."_configuration set value='".$this->db->escape_string($theme)."' where name='THEME'"))
							{
								$this->error='[string]database_error[/string]';
								return;
							}
								
						} else 
						{
							$this->error='[string]cannot_assign_tpl[/string]';
						}
					}
					break;
				case 'CHECK_IF_COOKIES_ENABLED' :
				case 'CLEAN_URL' :
				case 'ALLOW_USER_REGISTER' :
				case 'GZIP_OUT' :
				case 'SESSION_EMULATE' :
				case 'SESSION_LIFE_TIME' :
				case 'USER_E_MAIL_CHECK' :
				case 'ALLOW_COMMENTS' :
				case 'COMMENTS_APPROVE' :
					if ((!empty($value)  || $value==0) && is_numeric($value) && $value>=0)
					{
						if (!$this->db->query("update ".DB_PREFIX."_configuration set value='".$this->db->escape_string($value)."' where name='".$this->db->escape_string($key)."'"))
						{
							$this->error='[string]database_error[/string]';
							return;
						}
					}
					break;
				case 'DEFAULT_LANGUAGE' :
					if (!empty($value))
					{
						if (array_key_exists($value,$this->language->languages))
						{
							if (!$this->db->query("update ".DB_PREFIX."_configuration set value='".$this->db->escape_string($value)."' where name='DEFAULT_LANGUAGE'"))
							{
								$this->error='[string]database_error[/string]';
								return;
							}
						} else 
						{
							$this->error='[string]cannot_assign_lng[/string]';
						}
					}
					break;
				case 'ADMIN_MAIL' :
				case 'SEND_MAIL_FROM' :
					if (!empty($value))
					{
						if ($this->user->validate_mail($value))
						{
							if (!$this->db->query("update ".DB_PREFIX."_configuration set value='".$this->db->escape_string($value)."' where name='".$this->db->escape_string($key)."'"))
							{
								$this->error='[string]database_error[/string]';
								return;
							}
						} else 
						{
							$this->error='[string]invalid_mail[/string]';
						}
					}
					break;
				case 'SITE_LOGO' :
					if (!empty($value) && strpos($value,'..')===false)
					{
						if (file_exists(ROOT_DIR.'/'.$value))
						{
							if (!$this->db->query("update ".DB_PREFIX."_configuration set value='".$this->db->escape_string($value)."' where name='SITE_LOGO'"))
							{
								$this->error='[string]database_error[/string]';
								return;
							}
						} else 
						{
							$this->error='[string]cannot_assign_logo[/string]';
						}
					}
					break;
				case 'SITE_SLOGAN' :
					if (!empty($value))
					{
						if ($slogan_ex)
						{
							if (!$this->db->query("update ".DB_PREFIX."_configuration set value='".$this->db->escape_string(strip_tags($value))."' where name='".$this->db->escape_string($key)."' and mark='".$this->db->escape_string($this->language->current)."'"))
							{
								$this->error='[string]database_error[/string]';
								return;
							}
						} else 
						{
							if (!$this->db->query("insert into ".DB_PREFIX."_configuration (id,name,value,mark) values (null,'SITE_SLOGAN','".$this->db->escape_string(strip_tags($value))."','".$this->db->escape_string($this->language->current)."')"))
							{
								$this->error='[string]database_error[/string]';
								return;
							}
						}
					}
					break;
				default :
					if (!empty($value))
					{
						if (!$this->db->query("update ".DB_PREFIX."_configuration set value='".$this->db->escape_string(strip_tags($value))."' where name='".$this->db->escape_string($key)."'"))
						{
							$this->error='[string]database_error[/string]';
							return;
						}
					}
					break;
			}
		}
		if (empty($this->error))
		{
			$this->message='[string]config_save_success[/string]';
		}
	}
}

function config_init($env)
{
	global $SawannaConf;
	
	$SawannaConf=new CSawannaConf();
	$SawannaConf->session=&$env['session'];
	$SawannaConf->language=&$env['language'];
	$SawannaConf->db=&$env['db'];
	$SawannaConf->user=&$env['user'];
}

function config_exec()
{
	global $SawannaConf;
	
	if (isset($_GET['component']) && $_GET['component']=='config')
	{
		echo '<h2 class="header_caption"><img src="'.HOME.'/sawanna/images/wpalm.png" width="40" height="40" align="absmiddle">&nbsp;[string]configuration[/string] :</h2>';
		echo '<p style="padding:10px">[string]configuration_str[/string]</p>';
		echo '<div align="center" style="padding-bottom:10px">';
		
		if (isset($_GET['act']) && $_GET['act'] == 'save')
		{
			$SawannaConf->save();
		}
		
		$SawannaConf->build_form();
		
		echo '</div>';
	}
	
	return array($SawannaConf->message,$SawannaConf->error,'');
}

function config_clear()
{
	global $SawannaConf;
	
	unset(
		$SawannaConf->session,
		$SawannaConf->language,
		$SawannaConf->db,
		$SawannaConf->user,
		$SawannaConf->error,
		$SawannaConf->message
		);
}
?>