<?php
defined("SAWANNA") or die();

class CSawannaFeedback extends CSawanna
{
	var $language;
	var $session;
	var $mail;
	var $user;
	var $captcha;
	var $message;
	var $error;
	
	function CSawannaFeedback()
	{
		$this->language=null;
		$this->session=null;
		$this->mail=null;
		$this->user=null;
		$this->captcha=null;
		$this->message='';
		$this->error='';
	}
	
	function send()
	{
		$message='';
		
		if (isset($this->session->var['feedback_sent']) && $this->session->var['feedback_sent']>time()-3600)
		{
			$this->error="[string]feedback_already_sent_str[/string]";
			return;
		}
		
		if (empty($_POST['message']))
		{
			$this->error="[string]feedback_send_failed_str[/string]";
			return;
		} else
		{
			$_POST['message']=strip_tags($_POST['message']);
		}
		if ($this->user->group == 0) {
			if (!isset($_POST['name']) || empty($_POST['name']))
			{
				$this->error="[string]feedback_send_failed_str[/string]";
				return;
			}
			if (!isset($_POST['mail']) || empty($_POST['mail']))
			{
				$this->error="[string]feedback_send_failed_str[/string]";
				return;
			}
			if (!$this->user->validate_word($_POST['name'],2,255,true))
			{
				$this->error="[string]feedback_send_failed_str[/string]";
				return;
			}
			if (!$this->user->validate_mail($_POST['mail']))
			{
				$this->error="[string]feedback_send_failed_str[/string]";
				return;
			}
			
			$message.="From : ".$_POST['name']."\n";
			$message.="E-Mail : ".$_POST['mail']."\n\n";
		} else
		{
			$name=(!empty($this->user->name)) ? $this->user->name : '--';
			$message.="From : ".$name." (Login : ".$this->user->login.")\n";
			$message.="E-Mail : ".$this->user->mail."\n\n";
		}
		
		if (!isset($_POST['captcha']) || empty($_POST['captcha']))
		{
			$this->error="[string]captcha_not_match[/string]";
			return;
		}
		
		if (!$this->captcha->check($_POST['captcha']))
		{
			$this->error="[string]captcha_not_match[/string]";
			return;
		}
		 
		$message.=$_POST['message'];
		if ($this->mail->sendText(ADMIN_MAIL,SEND_MAIL_FROM,SEND_MAIL_FROM_NAME,SITE_HOST.': Feedback',$message))
		{
			$this->message="[string]feedback_send_success_str[/string]";
			unset($_POST['name'],$_POST['mail'],$_POST['message']);
			$this->session->register('feedback_sent',time());
		} else 
		{
			$this->error="[string]mail_send_failed_str[/string]";
			return;
		}
	}
	
	
	function build_feedback_form()
	{
		$name=(isset($_POST['name'])) ? htmlspecialchars($_POST['name']) : '';
		$mail=(isset($_POST['mail'])) ? htmlspecialchars($_POST['mail']) : '';
		$text=(isset($_POST['message'])) ? htmlspecialchars($_POST['message']) : '';
		
		$elems=array();
		$desc=array();
		$attr=array();
		$custom=array();
		
		if ($this->user->group == 0)
		{
			$elems[]='text';
			$elems[]='text';
			
			$desc[]='[string]name[/string]';
			$desc[]='[string]mail[/string]';
			
			$attr[]='name="name" style="width:150px" value="'.$name.'"';
			$attr[]='name="mail" style="width:150px" value="'.$mail.'"';
			
			$custom[]='';
			$custom[]='';
		}
		
		$elems[]='custom';
		$elems[]='custom';
		$elems[]='text';
		$elems[]='submit';
		
		$desc[]='';
		$desc[]=' ';
		$desc[]='[string]enter_code[/string]';
		$desc[]=' ';
		
		$attr[]='';
		$attr[]='';
		$attr[]='name="captcha" style="width:100px"';
		$attr[]='value="[string]send[/string]"';
		
		$custom[]='<textarea name="message" cols="50" rows="10" style="width:100%">'.$text.'</textarea>';
		$custom[]='<img src="'.parent::build_url('captcha').'" width="100" height="30" border="1" />';
		
		echo '<div class="node"><p>[string]feedback_text[/string]</p><br /><div align="center">'.parent::build_form('feedback',$elems,'400px',$desc,$attr,$custom,'form',true).'</div></div>';
	}
}

function feedback_init($env) 
{
	global $SawannaFeedback;
	
	$SawannaFeedback=new CSawannaFeedback();
	$SawannaFeedback->language=&$env['language'];
	$SawannaFeedback->session=&$env['session'];
	$SawannaFeedback->mail=&$env['mail'];
	$SawannaFeedback->user=&$env['user'];
	$SawannaFeedback->captcha=&$env['captcha'];
}

function feedback_exec() 
{
	global $SawannaFeedback;
	
	if (isset($_POST['message'])) $SawannaFeedback->send();
	$SawannaFeedback->build_feedback_form();
	
	return array($SawannaFeedback->message,$SawannaFeedback->error,'[string]feedback[/string]');
}

function feedback_clear()
{
	global $SawannaFeedback;
	
	unset(
		$SawannaFeedback->language,
		$SawannaFeedback->session,
		$SawannaFeedback->mail,
		$SawannaFeedback->user,
		$SawannaFeedback->captcha,
		$SawannaFeedback->message,
		$SawannaFeedback->error
		);
}
?>