<?php
defined("SAWANNA") or die();

class CSawannaFiles extends CSawanna 
{
	var $session;
	var $language;
	var $message;
	var $error;
	
	function CSawannaFiles()
	{
		$this->session=null;
		$this->language=null;
		$this->message='';
		$this->error='';
	}
	
	function display()
	{
		echo '<div align="left">';
		if (!isset($_GET['act']))
		{
			echo '&nbsp;&nbsp;&nbsp;'.parent::build_anchor(ADMIN_WORKSPACE.'/&component=files&act=upload','<img src="'.HOME.'/sawanna/images/create.png" width="20" height="20" border="0" align="absmiddle" hspace="5" /><b>[string]upload_files[/string]</b>');
			echo '<br /><br />';
		}
		echo '<div style="border-top:1px solid #000000;padding:10px">';
		
		$co=0;
		echo '<div style="border-bottom:1px solid #000000"><b>/upload/images</b></div>';
		$dir=opendir(ROOT_DIR.'/upload/images');
		while (($file=readdir($dir)) !== false) {
			if ($file != '.' && $file != '..' && $file != 'index.html')
			{
				$co++;
				echo '<div style="height:20px;line-height:20px;border-bottom:1px solid #EFEFEF">'.parent::build_anchor(ADMIN_WORKSPACE.'/&component=files&act=del&dir=images&file='.$file,'<img src="'.HOME.'/sawanna/images/delete.png" width="20" height="20" title="[string]delete[/string]" border="0" align="absmiddle" />').'&nbsp;'.$file.'</div>';
			}
		}
		if ($co==0) echo '[string]no_files[/string]';
		
		echo '<br /><br />';
		
		$co=0;
		echo '<div style="border-bottom:1px solid #000000"><b>/upload/banners</b></div>';
		$dir=opendir(ROOT_DIR.'/upload/banners');
		while (($file=readdir($dir)) !== false) {
			if ($file != '.' && $file != '..' && $file != 'index.html')
			{
				$co++;
				echo '<div style="height:20px;line-height:20px;border-bottom:1px solid #EFEFEF">'.parent::build_anchor(ADMIN_WORKSPACE.'/&component=files&act=del&dir=banners&file='.$file,'<img src="'.HOME.'/sawanna/images/delete.png" width="20" height="20" title="[string]delete[/string]" border="0" align="absmiddle" />').'&nbsp;'.$file.'</div>';
			}
		}
		if ($co==0) echo '[string]no_files[/string]';
		
		echo '<br /><br />';
		
		$co=0;
		echo '<div style="border-bottom:1px solid #000000"><b>/upload/docs</b></div>';
		$dir=opendir(ROOT_DIR.'/upload/docs');
		while (($file=readdir($dir)) !== false) {
			if ($file != '.' && $file != '..' && $file != 'index.html')
			{
				$co++;
				echo '<div style="height:20px;line-height:20px;border-bottom:1px solid #EFEFEF">'.parent::build_anchor(ADMIN_WORKSPACE.'/&component=files&act=del&dir=docs&file='.$file,'<img src="'.HOME.'/sawanna/images/delete.png" width="20" height="20" title="[string]delete[/string]" border="0" align="absmiddle" />').'&nbsp;'.$file.'</div>';
			}
		}
		if ($co==0) echo '[string]no_files[/string]';
		
		echo '<div></div>';
	}
	
	function delete($dir,$file)
	{
		if (strpos($dir,'../') !== false) 
		{
			$this->error='[string]delete_file_failed[/string]';
			return ;
		}
		
		if (strpos($file,'../') !== false) 
		{
			$this->error='[string]delete_file_failed[/string]';
			return ;
		}
		
		$path=ROOT_DIR.'/upload/'.$dir.'/'.$file;
		
		if (!file_exists($path))
		{
			$this->error='[string]delete_file_failed[/string]';
			return ;
		}
		
		echo '<div align="left" style="padding:10px">';
		echo '<b>[string]file[/string] : /upload/'.$dir.'/'.$file.'</b>';
		echo '<p style="color:red">[string]file_delete_confirm[/string]</p>';
		echo parent::build_anchor(ADMIN_WORKSPACE.'/&component=files&act=dodel&dir='.$dir.'&file='.$file,'<b>[string]delete[/string]</b>');
		echo '</div>';
	}
	
	function dodelete($dir,$file)
	{
		if (strpos($dir,'../') !== false || strpos($dir,'..\\') !== false) 
		{
			$this->error='[string]delete_file_failed[/string]';
			return ;
		}
		
		if (strpos($file,'../') !== false || strpos($file,'..\\') !== false) 
		{
			$this->error='[string]delete_file_failed[/string]';
			return ;
		}
		
		$path=ROOT_DIR.'/upload/'.$dir.'/'.$file;
		
		if (!file_exists($path))
		{
			$this->error='[string]delete_file_failed[/string]';
			return ;
		}
		
		if (!unlink($path))
		{
			$this->error='[string]delete_file_failed[/string]';
			return ;
		}
		
		$this->message='[string]delete_file_success[/string]';
	}
	
	function build_upload_frame()
	{
		
		echo '<iframe width="462" height="250" src="'.parent::build_url('ajax/upload/&act=upload').'" style="border:0px"></iframe>';
		echo '<br /><br />';
	}
}

function files_init($env)
{
	global $SawannaFiles;
	
	$SawannaFiles=new CSawannaFiles();
	$SawannaFiles->session=&$env['session'];
	$SawannaFiles->language=&$env['language'];
}

function files_exec()
{
	global $SawannaFiles;
	
	if (isset($_GET['component']) && $_GET['component']=='files')
	{
		echo '<h2 class="header_caption"><img src="'.HOME.'/sawanna/images/wpalm.png" width="40" height="40" align="absmiddle">&nbsp;[string]files[/string] :</h2>';
		echo '<p style="padding:10px">[string]files_str[/string]</p>';
		
		echo '<div align="center" style="padding-top:10px;padding-bottom:10px">';
	
		if (isset($_GET['act']))
		{
			if ($_GET['act']=='del' && isset($_GET['dir']) && !empty($_GET['dir']) && isset($_GET['file']) && !empty($_GET['file']))
			{
				$SawannaFiles->delete($_GET['dir'],$_GET['file']);
			}
			
			if ($_GET['act']=='dodel' && isset($_GET['dir']) && !empty($_GET['dir']) && isset($_GET['file']) && !empty($_GET['file']))
			{
				$SawannaFiles->dodelete($_GET['dir'],$_GET['file']);
			}
			
			if ($_GET['act'] == 'upload')
			{
				$SawannaFiles->build_upload_frame();
			}
		}
		
		$SawannaFiles->display();
		
		echo '</div>';
	}
	
	return array($SawannaFiles->message,$SawannaFiles->error,'');
}

function files_clear()
{
	global $SawannaFiles;
	
	unset(
		$SawannaFiles->session,
		$SawannaFiles->language,
		$SawannaFiles->message,
		$SawannaFiles->error
		);
}