<?php
defined("SAWANNA") or die();

class CSawannaLangPack extends CSawanna 
{
	var $language;
	var $session;
	var $db;
	var $error;
	var $message;
	
	function CSawannaLangPack()
	{
		$this->language=null;
		$this->session=null;
		$this->db=null;
		$this->error='';
		$this->message='';
	}
	
	function build_form()
	{
		
		$html='';
			
		$elems=array();
		$desc=array();
		$attr=array();
		
		$langpack_dir=opendir(ROOT_DIR.'/language');
		
		while (($file=readdir($langpack_dir))!==false) {
			if (
			 is_dir(ROOT_DIR.'/language/'.quotemeta($file)) 
			 && $file!='.' 
			 && $file!='..' 
			 && file_exists(ROOT_DIR.'/language/'.quotemeta($file).'/lang.php')
			 && file_exists(ROOT_DIR.'/language/'.quotemeta($file).'/agreement.html')
			 && file_exists(ROOT_DIR.'/language/'.quotemeta($file).'/forgot_password.html')
			 && file_exists(ROOT_DIR.'/language/'.quotemeta($file).'/registration.html')
			 )
			 {
				$file=htmlspecialchars($file);
				if (isset($language_name,$language_words)) 
				{
					unset($language_name,$language_words);
				}
				require(ROOT_DIR.'/language/'.quotemeta($file).'/lang.php');
				
				if (isset($language_name,$language_words) && is_array($language_words))
				{
					$elems[]='checkbox';
					
					$ico='';
					if (file_exists(ROOT_DIR.'/language/'.quotemeta($file).'/lang.gif'))
					{
						$size=getimagesize(ROOT_DIR.'/language/'.quotemeta($file).'/lang.gif');
						$ico='<img src="'.HOME.'/language/'.quotemeta($file).'/lang.gif" '.$size[3].' align="absmiddle" />'; 

					}
					
					$desc[]=$ico.'&nbsp;&nbsp;'.htmlspecialchars($language_name).'<b> ('.$file.')</b>';
					
					if (array_key_exists($file,$this->language->languages))
						$attr[]='name="'.$file.'" checked';
					else 
						$attr[]='name="'.$file.'"';
				}
			}
		}
		
		closedir($langpack_dir);
		
		$elems[]='hidden';
		$desc[]=' ';
		$attr[]='name="dosave" value="true"';
		
		$elems[]='submit';
		$desc[]=' ';
		$attr[]='value="[string]send[/string]"';
					
		$html.=parent::build_form(ADMIN_WORKSPACE.'/&component=langpack&act=save',$elems,500,$desc,$attr);
		
		echo $html; 
	}
	
	function save()
	{
		$langpack_ex=array();
		
		$this->db->query("select value from ".DB_PREFIX."_global where name='sawanna_languages'");
		while($glob=$this->db->fetch_array())
		{
			$langpack_ex=array_merge($langpack_ex,unserialize($glob['value']));
		}
		
		if (!$this->db->query("delete from ".DB_PREFIX."_global where name='sawanna_languages'"))
		{
			$this->error='[string]database_error[/string]';
		}
		
		$langpacks=array();
		$values=array();
		
		foreach ($_POST as $langpack=>$status)
		{
			if ($status == 'on') $langpacks[]=$langpack;
			
			if ($status == 'on' && !array_key_exists($langpack,$this->language->languages))
			{
				if (
				 is_dir(ROOT_DIR.'/language/'.quotemeta($langpack)) 
				 && file_exists(ROOT_DIR.'/language/'.quotemeta($langpack).'/lang.php')
				 && file_exists(ROOT_DIR.'/language/'.quotemeta($langpack).'/agreement.html')
				 && file_exists(ROOT_DIR.'/language/'.quotemeta($langpack).'/forgot_password.html')
				 && file_exists(ROOT_DIR.'/language/'.quotemeta($langpack).'/registration.html')
				)
				{
					$langpack=htmlspecialchars($langpack);
					
					if (isset($language_name,$language_words)) 
					{
						unset($language_name,$language_words);
					}
					require(ROOT_DIR.'/language/'.quotemeta($langpack).'/lang.php');
					
					if (isset($language_name,$language_words) && is_array($language_words))
					{
						$values[$langpack]=$language_name;
					} else 
					{
						$this->error='[string]changes_save_failed[/string]';
					}
				} else 
				{
					$this->error='[string]changes_save_failed[/string]';
				}
			}
		}
		
		
		foreach ($langpacks as $key=>$code)
		{
			if (array_key_exists($code,$langpack_ex))
				$values=array_merge($values,array($code=>$langpack_ex[$code]));
		}
		
		if (!array_key_exists(DEFAULT_LANGUAGE,$values))
		{
			$values=array_merge($values,array(DEFAULT_LANGUAGE=>$langpack_ex[DEFAULT_LANGUAGE]));
			$this->error='[string]changes_save_failed[/string]';
		}
		
		ksort($values);
		
		if (!$this->db->query("insert into ".DB_PREFIX."_global (name,value,mark) values ('sawanna_languages','".$this->db->escape_string(serialize($values))."','')"))
		{
			$this->error='[string]database_error[/string]';
		}
		
		if (empty($this->error))
		{
			$this->message='[string]changes_save_success[/string]';
			$this->error='[string]refresh_page[/string]';
		}
		
		if (count($langpack_ex)==1 && count($values)>1)
		{
			$this->message='[string]links_need_update[/string]';
			echo '<script language="JavaScript">window.setTimeout(\'window.location.href="'.parent::build_url($this->language->current.'/'.ADMIN_WORKSPACE).'"\',1000);</script>';
		}
		
		if (count($values)==1 && count($langpack_ex)>1)
		{
			$this->message='[string]links_need_update[/string]';
			
			$url=parent::build_url(ADMIN_WORKSPACE);
			if (!isset($this->session->var['clean_url']) || $this->session->var['clean_url']=='false')
			{
				$url=str_replace(HOME.'/index.php?'.$this->language->current.'/','',$url);
				$url=HOME.'/index.php?'.$url;
			} else 
			{
				$url=str_replace(HOME.'/'.$this->language->current.'/','',$url);
				$url=HOME.'/'.$url;
			}
			
			echo '<script language="JavaScript">window.setTimeout(\'window.location.href="'.$url.'"\',1000);</script>';
		} else if (!array_key_exists($this->language->current,$values))
		{
			$this->message='[string]links_need_update[/string]';
			
			$url=parent::build_url(ADMIN_WORKSPACE);
			if (!isset($this->session->var['clean_url']) || $this->session->var['clean_url']=='false')
			{
				$url=str_replace(HOME.'/index.php?'.$this->language->current.'/','',$url);
				$url=HOME.'/index.php?'.DEFAULT_LANGUAGE.'/'.$url;
			} else 
			{
				$url=str_replace(HOME.'/'.$this->language->current.'/','',$url);
				$url=HOME.'/'.DEFAULT_LANGUAGE.'/'.$url;
			}
			
			echo '<script language="JavaScript">window.setTimeout(\'window.location.href="'.$url.'"\',1000);</script>';
		}
	}
}

function langpack_init($env)
{
	global $SawannaLangPack;
	
	$SawannaLangPack=new CSawannaLangPack();
	$SawannaLangPack->session=&$env['session'];
	$SawannaLangPack->language=&$env['language'];
	$SawannaLangPack->db=&$env['db'];
}

function langpack_exec()
{
	global $SawannaLangPack;
	
	if (isset($_GET['component']) && $_GET['component']=='langpack')
	{
		echo '<h2 class="header_caption"><img src="'.HOME.'/sawanna/images/wpalm.png" width="40" height="40" align="absmiddle">&nbsp;[string]language_packs[/string] :</h2>';
		echo '<p style="padding:10px">[string]languages_str[/string]</p>';
		echo '<div align="center" style="padding-top:10px;padding-bottom:10px">';
		
		if (isset($_GET['act']) && $_GET['act'] == 'save' && isset($_POST['dosave']) && $_POST['dosave']=='true')
		{
			$SawannaLangPack->save();
			$SawannaLangPack->db->query("select value from ".DB_PREFIX."_global where name='sawanna_languages'");
			$lang_updated=$SawannaLangPack->db->fetch_array();
			$SawannaLangPack->language->languages=unserialize($lang_updated['value']);
		}
		
		$SawannaLangPack->build_form();
		
		echo '</div>';
	}
	
	return array($SawannaLangPack->message,$SawannaLangPack->error,'');
}

function langpack_clear()
{
	global $SawannaLangPack;
	
	unset(
		$SawannaLangPack->session,
		$SawannaLangPack->language,
		$SawannaLangPack->db,
		$SawannaLangPack->error,
		$SawannaLangPack->message
		);
}
?>