<?php
defined("SAWANNA") or die();

class CSawannaLanguagesPanel extends CSawanna 
{
	var $language;
	var $session;
	var $workspace;
	var $query;
	
	function CSawannaLanguagesPanel()
	{
		$this->language=null;
		$this->session=null;
		$this->workspace=FRONT_PAGE_WORKSPACE;
		$this->query='';
	}
	
	function build()
	{
		$html='';
		$html.='<div class="header_panel_language"><div class="languages_panel">';
		
		if (count($this->language->languages) > 1)
		{
			if (file_exists(ROOT_DIR.'/language/'.DEFAULT_LANGUAGE.'/lang.gif'))
			{
				$size=getimagesize(ROOT_DIR.'/language/'.DEFAULT_LANGUAGE.'/lang.gif');
				
				$desc='<img src="'.HOME.'/language/'.DEFAULT_LANGUAGE.'/lang.gif" '.$size[3].' border="0" style="margin-right:5px" />'.'&nbsp;'.$this->language->languages[DEFAULT_LANGUAGE];
			}
			$html.='<a href="'.$this->build_url($this->workspace.'/'.$this->query,DEFAULT_LANGUAGE).'" class="languages_link">'.$desc.'</a>'.'&nbsp;&nbsp;&nbsp;';
			
			foreach ($this->language->languages as $name=>$desc)
			{
				if ($name==DEFAULT_LANGUAGE) continue;
				
				$name=quotemeta($name);
				if (file_exists(ROOT_DIR.'/language/'.$name.'/lang.gif'))
				{
					$size=getimagesize(ROOT_DIR.'/language/'.$name.'/lang.gif');
					
					$desc='<img src="'.HOME.'/language/'.$name.'/lang.gif" '.$size[3].' border="0" style="margin-right:5px" />'.'&nbsp;'.$desc;
				}
				$html.='<a href="'.$this->build_url($this->workspace.'/'.$this->query,$name).'" class="languages_link">'.$desc.'</a>'.'&nbsp;&nbsp;&nbsp;';
			}
		}
		
		$html.='</div></div>';
		
		echo $html;
	}
	
	function build_url($url,$language)
	{
		if (!isset($this->session->var['clean_url']) || $this->session->var['clean_url']=='false')
		{
			$url=HOME.'/index.php?'.$language.'/'.$url;
			
			$url=parent::fix_url($url);
		} else 
		{
			$url=HOME.'/'.$language.'/'.$url;
		}
		
		return $url;
	}
}

function languages_init($env)
{
	global $SawannaLanguagesPanel;
	
	$SawannaLanguagesPanel=new CSawannaLanguagesPanel();
	$SawannaLanguagesPanel->language=&$env['language'];
	$SawannaLanguagesPanel->session=&$env['session'];
	$SawannaLanguagesPanel->workspace=$env['workspace'];
	$SawannaLanguagesPanel->query=$env['query'];
}

function languages_exec()
{
	global $SawannaLanguagesPanel;
	
	$SawannaLanguagesPanel->build();
}

function languages_clear()
{
	global $SawannaLanguagesPanel;
	
	unset(
		$SawannaLanguagesPanel->language,
		$SawannaLanguagesPanel->session,
		$SawannaLanguagesPanel->workspace,
		$SawannaLanguagesPanel->query
		);
}
?>