<?php
defined("SAWANNA") or die();

class CSawannaMap extends CSawanna 
{
	var $session;
	var $language;
	var $navigator;
	var $db;
	
	function CSawannaMap()
	{
		$this->session=null;
		$this->language=null;
		$this->navigator=null;
		$this->db=null;
	}
	
	function build()
	{
		echo '<div class="node">';
		echo '<div class="map">';
		echo $this->build_navigator_tree();
		echo '</div>';
		echo '</div>';
	}
	
	function build_navigator_tree($parent=0,$co=0)
	{
		static $map;
		
		$offset=str_repeat("&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; ",$co);
		
		$result=$this->navigator->get(array('parent'=>$parent));
		while($menu=$this->db->fetch_array($result))
		{
			if ($menu['mark'] == 'ghost') continue;
			
			if ($co==0) $_offset='<br />&bull; '; else $_offset=$offset.' &rarr; ';
			
			$menu_link=(strpos($menu['link'],'http://')===0 || strpos($menu['link'],'https://')===0) ? '<a href="'.$menu['link'].'" target="_blank" class="map_link">'.$menu['name'].'</a>' : parent::build_anchor($menu['link'],$menu['name'],'map_link');
			
			$map.=$_offset.$menu_link.'<br />';
			$this->build_navigator_tree($menu['id'],$co+1);
		}
		return $map.'<br />';
	}
}

function map_init($env)
{
	global $SawannaMap;
	
	$SawannaMap=new CSawannaMap();
	$SawannaMap->session=&$env['session'];
	$SawannaMap->language=&$env['language'];
	$SawannaMap->navigator=&$env['navigator'];
	$SawannaMap->db=&$env['db'];
}

function map_exec()
{
	global $SawannaMap;
	
	$SawannaMap->build();
	
	return array('','','[string]sitemap[/string]');
}

function map_clear()
{
	global $SawannaMap;
	
	unset(
		$SawannaMap->session,
		$SawannaMap->language,
		$SawannaMap->navigator,
		$SawannaMap->db
		);
}
?>