<?php
defined("SAWANNA") or die();

class CSawannaSearch extends CSawanna 
{
	var $language;
	var $user;
	var $session;
	var $db;
	var $error;
	var $limit;
	var $query;
	
	function CSawannaSearch()
	{
		$this->language=null;
		$this->user=null;
		$this->session=null;
		$this->db=null;
		$this->error='';
		$this->limit=10;
		$this->query=1;
	}
	
	function build_search_form()
	{
		if (isset($_POST['search']) && !empty($_POST['search']))
		{
			$text=$_POST['search'];
		} elseif (isset($this->session->var['search_text']))
		{
			$text=$this->session->var['search_text'];
		} else 
		{
			$text='';
		}
		
		$html='<div align="center"><div align="center" class="search_bar_long"><div style="width:445px;height:30px">';
		$html.='<div style="width:30px;height:30px;float:left;margin-right:5px"><img src="'.HOME.'/sawanna/images/search.gif" width="30" height="30" /></div>';
		$html.='<div style="width:405px;display:inline"><form action="'.parent::build_url('search').'" method="POST">';
		$html.='<input type="text" name="search" style="width:300px;margin-top:4px;margin-right:5px" value="'.htmlspecialchars($text).'" />';
		$html.='<input type="submit" value="[string]search[/string]" style="width:100px;margin-top:4px" />';
		$html.='</form></div>';
		$html.='</div></div>';
		$html.='<div style="width:445px" class="shadow_1"></div>';
		$html.='</div>';
		
		echo $html;
	}
	
	function search()
	{
		if (isset($_POST['search']) && !empty($_POST['search']))
		{
			$text=$_POST['search'];
		} elseif (isset($this->session->var['search_text']))
		{
			$text=$this->session->var['search_text'];
		} else 
		{
			return;
		}
		
		switch ($this->user->group)
		{
			case 1 :
				$access='';
				break;
			case 2 :
				$access=' and ';
				$access.="access <> '0'";
				break;
			default:
				$access=' and ';
				$access.="access = '1'";
				break;
		}
		
		while (true)
		{
			if (strpos($text,'  ') !== false)
			{
				$text=str_replace('  ',' ',$text);
			} else 
			{
				break;
			}
		}
		
		$words=explode(' ',$text);
		$matches=array();
		$links=array();
		
		if (!empty($words))
		{
			$this->db->query("select id,name,workspace,link,keywords from ".DB_PREFIX."_nodes where language='".$this->db->escape_string($this->language->current)."'".$access." order by published desc");
			while ($node=$this->db->fetch_array()) 
			{
				if (!empty($node['keywords']))
				{
					$keywords=explode(',',$node['keywords']);
					foreach ($words as $word)
					{
						if (!empty($word) && preg_match('/\b'.$word.'\b/i',$node['keywords']))
						{
							if (!isset($matches[$node['id']]))
							{
								$matches[$node['id']]=0;
								$links[$node['id']]=parent::build_anchor($node['workspace'].'/'.$node['link'],$node['name']);
							}
							$matches[$node['id']]++;
						}
					}
				}
			}
			if (!empty($matches) && !empty($links))
			{
				$this->session->register('search_text',$text);
				
				arsort($matches);
				
				echo '<div class="search_field">';
				
				$current=(intval($this->query)-1)*$this->limit+1;
				$co=0;
				foreach ($matches as $id=>$match)
				{
					$co++;
					if ($co<$current) continue;
					
					echo '<b>'.$co.'.</b>&nbsp;&nbsp;'.$links[$id].'<br />';
					$this->db->query("select content,keywords from ".DB_PREFIX."_nodes where id='".$this->db->escape_string($id)."'");
					$node=$this->db->fetch_array(); 
					if (!empty($node))
					{
						echo '<div class="search_preview">';
						if (function_exists('mb_substr'))
						{
							echo mb_substr(strip_tags($node['content']),0,200,'utf-8');
						} else 
						{
							echo substr(strip_tags($node['content']),0,400);
						}
						echo '</div>';
					}
					echo '<span class="search_keywords">[string]keywords[/string] : '.$node['keywords'].'</span>';
					echo '<br /><br /><br />';
					if ($co>=$this->limit+$current-1) break;
				}
				
				if (count($matches)>$this->limit)
				{
					echo '<br />';
					echo parent::build_limiter(count($matches),$this->limit,'search',$this->query);
				}
				
				echo '</div>';
			} else 
			{
				$this->error='[string]search_not_found[/string]';
			}
		}
	}
}

function search_init($env)
{
	global $SawannaSearch;
	
	$SawannaSearch=new CSawannaSearch();
	$SawannaSearch->language=&$env['language'];
	$SawannaSearch->user=&$env['user'];
	$SawannaSearch->session=&$env['session'];
	$SawannaSearch->db=&$env['db'];
	if (isset($env['query']) && !empty($env['query']) && is_numeric($env['query']) && $env['query']>0)
	{
		$SawannaSearch->query=$env['query'];
	} elseif (isset($SawannaSearch->session->var['search_text'])) 
	{
		$SawannaSearch->session->clear('search_text');
	}
}

function search_exec()
{
	global $SawannaSearch;
	
	$SawannaSearch->build_search_form();
	
	$SawannaSearch->search();
	
	return array('',$SawannaSearch->error,'[string]search[/string]');
}

function search_clear()
{
	global $SawannaSearch;
	
	unset(
		$SawannaSearch->language,
		$SawannaSearch->user,
		$SawannaSearch->session,
		$SawannaSearch->db,
		$SawannaSearch->error,
		$SawannaSearch->limit,
		$SawannaSearch->query
		);
}
?>