<?php
defined("SAWANNA") or die();

class CSawannaStat extends CSawanna 
{
	var $language;
	var $session;
	var $db;
	var $limit;
	var $get;
	var $ok;
	
	function CSawannaStat()
	{
		$this->language=null;
		$this->session=null;
		$this->db=null;
		$this->limit=10;
		$this->get=(isset($_GET['get']) && !empty($_GET['get']) && is_numeric($_GET['get']) && $_GET['get']>0) ? $_GET['get'] : 1;
	}
	
	function build()
	{
		$html='';
		if (!isset($_GET['act']))
		{
			$html.='&nbsp;&nbsp;&nbsp;'.parent::build_anchor(ADMIN_WORKSPACE.'/&component=stat&act=show_graph','<b>[string]build_graphs[/string]</b>');
		}
		$html.='<div style="border-bottom:1px solid #000000">&nbsp;</div><br />';
		
		$current=(intval($this->get)-1)*$this->limit+1;
		
		if (!isset($_GET['clear']) && !isset($_GET['doclear']))
		{
			$html.='<div style="padding-right:20px" align="right">'.parent::build_anchor(ADMIN_WORKSPACE.'/&component=stat&clear=true','[string]clear_database[/string]').'</div>';
		} elseif (isset($_GET['clear']) && $_GET['clear'] == 'true')
		{
			$html.='<div align="center" style="margin-top:20px;margin-bottom:20px"><b style="color:red">[string]clear_database_confirm[/string]</b><br /><br />'.parent::build_anchor(ADMIN_WORKSPACE.'/&component=stat&doclear=true','<b>[string]delete[/string]</b>').'</div>';
		} elseif (isset($_GET['doclear']) && $_GET['doclear'] == 'true')
		{
			$time_offset=time()-5184000;
			if ($this->db->query('delete from '.DB_PREFIX.'_log where access_time < '.$time_offset))
			{
				$html.='<div align="center" style="margin-top:20px;margin-bottom:20px"><b style="color:red">[string]records_deleted[/string]</b><br /></div>';
			} else 
			{
				$html.='<div align="center" style="margin-top:20px;margin-bottom:20px"><b style="color:red">[string]database_error[/string]</b><br /></div>';
			}
		}
		
		$this->db->query("select count(id) as records from ".DB_PREFIX."_log");
		$count=$this->db->fetch_array();
		$html.='<div style="padding-right:20px" align="right"><b>[string]records[/string] : '.$count['records'].'</b></div>';
		
		$html.='<div style="padding-top:10px;padding-bottom:10px">';
		$this->db->query("select * from ".DB_PREFIX."_log order by access_time desc");
		$co=0;
		while ($log=$this->db->fetch_array()) {
			$co++;
			if ($co<$current) continue;
			
			$html.='<b>[string]date[/string] : '.date('d.m.Y H:i:s',$log['access_time']).'</b><br />[string]ip[/string] : '.$log['ip'].'<br />[string]query[/string] : '.$log['query'].'<br />[string]referer[/string] : '.$log['referer'].'<br />[string]user_agent[/string] : '.$log['user_agent'].'<br />[string]status[/string] : '.$log['status'].'<br /><hr /><br />';
			
			if ($co>=$this->limit+$current-1) break;
		}
		$html.='</div>';
		
		$count=$this->db->num_rows();
		if ($count > $this->limit)
		{
			$html.='<br /><br />';
			$html.=parent::build_limiter($count,$this->limit,ADMIN_WORKSPACE.'/&component=stat',$this->get,true);
			$html.='<br /><br />';
		}
		
		echo $html;
	}
	
	function show_graphics()
	{
		$html='<div align="center">';
		
		$html.='<br /><b>[string]hourly_graph[/string]:</b><br /><br />';
		$html.='<a href="'.parent::build_url(ADMIN_WORKSPACE.'/&component=stat&graph=hour').'" target="_blank"><img src="'.parent::build_url(ADMIN_WORKSPACE.'/&component=stat&graph=hour').'" width="400" class="thumbnail" title="[string]click_to_zoom[/string]" alt="[string]click_to_zoom[/string]" /></a>';
		$html.='<br /><br />';
		$html.='<br /><b>[string]daily_graph[/string]:</b><br /><br />';
		$html.='<a href="'.parent::build_url(ADMIN_WORKSPACE.'/&component=stat&graph=day').'" target="_blank"><img src="'.parent::build_url(ADMIN_WORKSPACE.'/&component=stat&graph=day').'" width="400" class="thumbnail" title="[string]click_to_zoom[/string]" alt="[string]click_to_zoom[/string]" /></a>';
		
		$html.='</div><br />';
		
		echo $html;
	}
	
	function build_graphic($type='hour')
	{
		$graph=imagecreate(800,380);
		$green = imagecolorallocate($graph, 0, 255, 0);
		$white = imagecolorallocate($graph, 255, 255, 255);
		$blue = imagecolorallocate($graph, 0, 0, 255);
		$black = imagecolorallocate($graph, 0, 0, 0);
		imagefill($graph, 0, 0, $white);
				
		switch ($type) {
			case 'hour' :
				$now=time();
				$this->db->query("select id from ".DB_PREFIX."_log where access_time > '".mktime(0,0,0,date('m',$now),date('d',$now),date('Y',$now))."'");
				$stat_com=$this->db->num_rows();
				
				for($hour=0;$hour<24;$hour++) {
					$this->db->query("select id from ".DB_PREFIX."_log where access_time > '".mktime($hour,0,0,date('m',$now),date('d',$now),date('Y',$now))."' and access_time < '".mktime($hour+1,0,0,date('m',$now),date('d',$now),date('Y',$now))."'");
					$stat_hours[$hour]=$this->db->num_rows();
				}
				
				$style = array ($blue,$white,$white);
				imagesetstyle ($graph, $style);
				for ($i=50;$i<350;$i+=30) {
					imageline($graph,40,$i,760,$i,IMG_COLOR_STYLED);
				}
				for ($i=70;$i<790;$i+=30) {
					imageline($graph,$i,50,$i,350,IMG_COLOR_STYLED);
				}
				$pos_x=40;
				foreach ($stat_hours as $key=>$val) {
					if ($stat_com==0) break;
					$pos_y=350-round($val*100/$stat_com)*3;
					if ($pos_y<350) {
						imagefilledrectangle($graph,$pos_x,$pos_y,$pos_x+30,350,$green);
						imagerectangle($graph,$pos_x,$pos_y,$pos_x+30,350,$black);
						imagestring($graph,1,$pos_x+1,$pos_y-8,$val,$black);
					}
					$pos_x+=30;
				}
				imagestring($graph,3,100,10,date('d.m.Y',$now),$black);
				imagestring($graph,3,100,25,HOME,$black);
				imagestring($graph,4,50,10,"(%)",$black);
				imageline($graph,40,30,40,350,$black);
				imageline($graph,40,350,770,350,$black);
				imagefilledpolygon($graph,array('35','30','40','10','45','30'),3,$black);
				imagefilledpolygon($graph,array('770','345','790','350','770','355'),3,$black);
				for ($i=50;$i<350;$i+=30) {
					imageline($graph,35,$i,45,$i,$black);
					if ($i==50)
						imagestring($graph,4,7,$i-8,(350-$i)/3,$black);
					else 
						imagestring($graph,4,15,$i-8,(350-$i)/3,$black);
				}
				$xxx=true;
				for ($i=70;$i<790;$i+=30) {
					imageline($graph,$i,345,$i,355,$black);
					$h_str=(($i-40)/30)-1;
					if (strlen($h_str)<2) $h_str="0".$h_str;
					if ($xxx==true) {
						imagestring($graph,4,$i-22,355,$h_str,$black);
						$xxx=false;
					} else {
						imagestring($graph,4,$i-22,332,$h_str,$black);
						$xxx=true;
					}
				}
				break;
			case 'day' :
				$now=time();
				$this->db->query("select id from ".DB_PREFIX."_log where access_time > '".mktime(0,0,0,date('m',$now),1,date('Y',$now))."'");
				$stat_com=$this->db->num_rows();
				for($day=1;$day<=date('d',$now);$day++) {
					$this->db->query("select id from ".DB_PREFIX."_log where access_time > '".mktime(0,0,0,date('m',$now),$day,date('Y',$now))."' and access_time < '".mktime(0,0,0,date('m',$now),$day+1,date('Y',$now))."'");
					$stat_months[$day]=$this->db->num_rows();
				}
				
				$style = array ($blue,$white,$white);
				imagesetstyle ($graph, $style);
				for ($i=50;$i<350;$i+=30) {
					imageline($graph,40,$i,753,$i,IMG_COLOR_STYLED);
				}
				for ($i=40;$i<753;$i+=23) {
					imageline($graph,$i,50,$i,350,IMG_COLOR_STYLED);
				}
				$pos_x=40;
				foreach ($stat_months as $key=>$val) {
					if ($stat_com==0) break;
					$pos_y=350-round($val*100/$stat_com)*3;
					if ($pos_y<350) {
						imagefilledrectangle($graph,$pos_x,$pos_y,$pos_x+23,350,$green);
						imagerectangle($graph,$pos_x,$pos_y,$pos_x+23,350,$black);
						imagestring($graph,1,$pos_x+1,$pos_y-8,$val,$black);
					}
					$pos_x+=23;
				}
				imagestring($graph,3,100,10,date('d.m.Y',mktime(0,0,0,date('m',$now),1,date('Y',$now))).' - '.date('d.m.Y',mktime(0,0,0,date('m',$now)+1,0,date('Y',$now))),$black);
				imagestring($graph,3,100,25,HOME,$black);
				imagestring($graph,4,50,10,"(%)",$black);
				imageline($graph,40,30,40,350,$black);
				imageline($graph,40,350,770,350,$black);
				imagefilledpolygon($graph,array('35','30','40','10','45','30'),3,$black);
				imagefilledpolygon($graph,array('770','345','790','350','770','355'),3,$black);
				for ($i=50;$i<350;$i+=30) {
					imageline($graph,35,$i,45,$i,$black);
					if ($i==50)
						imagestring($graph,4,7,$i-8,(350-$i)/3,$black);
					else 
						imagestring($graph,4,15,$i-8,(350-$i)/3,$black);
				}
				$max=date('d',mktime(0,0,0,date('m',$now)+1,0,date('Y',$now)));
				for ($i=40;$i<753;$i+=23) {
					imageline($graph,$i,345,$i,355,$black);
					$h_str=(($i-40)/23)+1;
					if ($h_str<=$max)
					{
						if (strlen($h_str)<2) $h_str="0".$h_str;
						imagestring($graph,4,$i+4,355,$h_str,$black);
					}
				}
				break;
		}
		
		imagestring($graph,4,580,15,'Powered by Sawanna CMS',$black);
		header("Content-Type: image/jpeg");
		imagejpeg($graph);
		imagedestroy($graph);
		$this->ok=true;
		exit;
	}
}

function stat_init($env)
{
	global $SawannaStat;
	
	$SawannaStat=new CSawannaStat();
	$SawannaStat->session=&$env['session'];
	$SawannaStat->language=&$env['language'];
	$SawannaStat->db=&$env['db'];
	$SawannaStat->ok=&$env['ok'];
}

function stat_exec()
{
	global $SawannaStat;
	if (isset($_GET['component']) && $_GET['component']=='stat')
	{
		if (isset($_GET['graph']))
		{
			switch ($_GET['graph'])
			{
				case 'hour' :
					$SawannaStat->build_graphic('hour');
					break;
				case 'day' :
					$SawannaStat->build_graphic('day');
					break;
			}
		}
		
		echo '<h2 class="header_caption"><img src="'.HOME.'/sawanna/images/wpalm.png" width="40" height="40" align="absmiddle">&nbsp;[string]statistics[/string] :</h2>';
		echo '<p>[string]statistics_str[/string]</p><br />';
		
		if (isset($_GET['act']) && $_GET['act']=='show_graph')
		{
			$SawannaStat->show_graphics();
		} else 
		{
			$SawannaStat->build();
		}
	}
}

function stat_clear()
{
	global $SawannaStat;
	
	unset(
		$SawannaStat->session,
		$SawannaStat->language,
		$SawannaStat->db,
		$SawannaStat->limit,
		$SawannaStat->get,
		$SawannaStat->ok
		);
}
?>