<?php
defined("SAWANNA") or die();

class CSawannaThemes extends CSawanna 
{
	var $language;
	var $session;
	var $db;
	var $error;
	var $message;
	
	function CSawannaThemes()
	{
		$this->language=null;
		$this->session=null;
		$this->db=null;
		$this->error='';
		$this->message='';
	}
	
	function build_form()
	{
		global $sawanna_templates;
		
		$html='';
			
		$elems=array();
		$desc=array();
		$attr=array();
		
		$themes_dir=opendir(ROOT_DIR.'/theme');
		
		while (($file=readdir($themes_dir))!==false) {
			if (
			 is_dir(ROOT_DIR.'/theme/'.quotemeta($file)) 
			 && $file!='.' 
			 && $file!='..' 
			 && file_exists(ROOT_DIR.'/theme/'.quotemeta($file).'/'.$sawanna_templates[ADMIN_WORKSPACE].'.tpl')
			 )
			 {
				$file=htmlspecialchars($file);
				
				$elems[]='radio';
				
				$ico='';
				if (file_exists(ROOT_DIR.'/theme/'.quotemeta($file).'/thumbnail.gif'))
				{
					$ico='<img src="'.HOME.'/theme/'.quotemeta($file).'/thumbnail.gif" width="150" height="150" align="absmiddle" border="1" />'; 

				}
				
				$desc[]='<span>'.$file.'</span>&nbsp;&nbsp;&nbsp;&nbsp;'.$ico.'&nbsp;&nbsp;';
				
				if ($file == THEME)
					$attr[]='name="theme" value="'.$file.'" checked';
				else 
					$attr[]='name="theme" value="'.$file.'"';
			}
		}
		
		closedir($themes_dir);
		
		$elems[]='hidden';
		$desc[]='';
		$attr[]='name="dosave" value="true"';
		
		$elems[]='submit';
		$desc[]=' ';
		$attr[]='value="[string]send[/string]"';
					
		$html.=parent::build_form(ADMIN_WORKSPACE.'/&component=themes&act=save',$elems,500,$desc,$attr);
		
		echo $html; 
	}
	
	function save()
	{
		global $sawanna_templates;
		
		if (isset($_POST['theme']) && !empty($_POST['theme']))
		{
			if (
			 is_dir(ROOT_DIR.'/theme/'.quotemeta($_POST['theme'])) 
			 && file_exists(ROOT_DIR.'/theme/'.quotemeta($_POST['theme']).'/'.$sawanna_templates[ADMIN_WORKSPACE].'.tpl')
			 )
			 {
				$theme=htmlspecialchars($_POST['theme']);
				
				if (!$this->db->query("update ".DB_PREFIX."_configuration set value='".$this->db->escape_string($theme)."' where name='THEME'"))
				{
					$this->error='[string]database_error[/string]';
				}
			} else 
			{
				$this->error='[string]changes_save_failed[/string]';
			}
		}	
		
		if (empty($this->error))
		{
			$this->message='[string]changes_save_success[/string]';
			$this->error='[string]refresh_page[/string]';
			echo '<script language="JavaScript">window.setTimeout(\'window.location.href="'.parent::build_url(ADMIN_WORKSPACE).'"\',1000);</script>';
		}
	}
}

function themes_init($env)
{
	global $SawannaThemes;
	
	$SawannaThemes=new CSawannaThemes();
	$SawannaThemes->session=&$env['session'];
	$SawannaThemes->language=&$env['language'];
	$SawannaThemes->db=&$env['db'];
}

function themes_exec()
{
	global $SawannaThemes;
	
	if (isset($_GET['component']) && $_GET['component']=='themes')
	{
		echo '<h2 class="header_caption"><img src="'.HOME.'/sawanna/images/wpalm.png" width="40" height="40" align="absmiddle">&nbsp;[string]themes[/string] :</h2>';
		echo '<p style="padding:10px">[string]themes_str[/string]</p>';
		echo '<div align="center" style="padding-top:10px;padding-bottom:10px">';
		
		if (isset($_GET['act']) && $_GET['act'] == 'save' && isset($_POST['dosave']) && $_POST['dosave']=='true')
		{
			$SawannaThemes->save();
		}
		
		$SawannaThemes->build_form();
		
		echo '</div>';
	}
	
	return array($SawannaThemes->message,$SawannaThemes->error,'');
}

function themes_clear()
{
	global $SawannaThemes;
	
	unset(
		$SawannaThemes->session,
		$SawannaThemes->language,
		$SawannaThemes->db,
		$SawannaThemes->error,
		$SawannaThemes->message
		);
}
?>