<?php
defined("SAWANNA") or die();

class CUserInterface extends CSawanna 
{
	var $db;
	var $user;
	var $query;
	var $session;
	var $captcha;
	var $mail;
	var $language;
	var $tpl;
	var $message;
	var $error;
	var $ok;
	
	function CUserInterface($user)
	{
		$this->db=null;
		$this->user=$user;
		$this->query='';
		$this->session=null;
		$this->captcha=null;
		$this->language=null;
		$this->tpl=null;
		$this->mail=null;
		$this->message='';
		$this->error='';
		$this->ok=false;
	}
	
	function register($login,$pass,$mail)
	{
		if (isset($this->session->var['user_id'],$this->session->var['user_pass']) && $this->user->group != 1)
		{
			parent::redirect(parent::build_url('home'));
		}
		
		if (!isset($_POST['captcha']) || empty($_POST['captcha']))
		{
			$this->error="[string]captcha_not_match[/string]";
			return;
		}
		
		if (!$this->captcha->check($_POST['captcha']))
		{
			$this->error="[string]captcha_not_match[/string]";
			return;
		}
		
		if ($this->user->register($login,$pass,$mail))
		{
			$this->message='[string]register_success[/string]';
			
			$this->authorize($login,$pass,false);
			
			$this->build_information_form();
			
			if (USER_E_MAIL_CHECK)
			{
				$this->send_mail_confirmation();
			}
			return true;
		} else 
		{
			$this->error=$this->user->error;
			return false;
		}
	}
	
	function build_register_form()
	{
		if (isset($this->session->var['user_id'],$this->session->var['user_pass']) && $this->user->group != 1)
		{
			parent::redirect(parent::build_url('home'));
		}
		
		$elems=array(
				'text',
				'password',
				'password',
				'text',
				'checkbox',
				'custom',
				'text',
				'submit'
				);
		$desc=array(
				'[string]login[/string]',
				'[string]password[/string]',
				'[string]password_re[/string]',
				'[string]mail[/string]',
				'[string]i_accept_agreement[/string]',
				' ',
				'[string]enter_code[/string]',
				' '
				);
		$attr=array(
				'name="login" style="width:100%"',
				'name="password" style="width:100%"',
				'name="password_re" style="width:100%"',
				'name="mail" style="width:100%"',
				'name="agree"',
				'',
				'name="captcha" style="width:100px"',
				'value="[string]send[/string]" style="width:100px"'
				);
		
		$custom=array(
					'',
					'',
					'',
					'',
					'',
					'<img src="'.parent::build_url('captcha').'" width="100" height="30" border="1" />'
					);
				
		if (isset($_POST['login'])) $attr[0].=' value="'.htmlspecialchars($_POST['login']).'"';
		if (isset($_POST['mail'])) $attr[3].=' value="'.htmlspecialchars($_POST['mail']).'"';
				
		echo '<h3>[string]registration[/string] :</h3>';
		echo '<p>[string]registration_note_1[/string]<br />[string]registration_note_2[/string]</p><br />';
		echo '<div align="center">';
		echo '<div class="agreement" style="width:100%;height:200px">';
		readfile(ROOT_DIR.'/language/'.quotemeta($this->language->current).'/agreement.html');
		echo '</div>';
		echo parent::build_form('user/register',$elems,'400px',$desc,$attr,$custom,'form',true);
		echo '<p style="width:400px;text-align:left">[string]all_fields_are_required[/string]</p>';
		echo '</div>';
	}
	
	function send_mail_confirmation()
	{
		if (isset($this->session->var['user_id'],$this->session->var['user_pass']) && $this->user->active == 0)
		{
			if (isset($this->session->var['mail_confirmation_sent']) && $this->session->var['mail_confirmation_sent']>time()-3600)
			{
				return false;
			}
			$lang=(count($this->language->languages)>1) ? $this->language->current.'/' : '';
			$link='<a href="'.HOME.'/index.php?'.$lang.'user/&id='.$this->user->id.'&key='.md5($this->user->joined).'">'.HOME.'/index.php?'.$lang.'user/&id='.$this->user->id.'&key='.md5($this->user->joined).'</a>';
			$message=file_get_contents(ROOT_DIR.'/language/'.quotemeta($this->language->current).'/registration.html');
			$message=str_replace('{header}',SITE_NAME,$message);
			$message=str_replace('{link}',$link,$message);
			$this->mail->sendMail($this->user->mail,SEND_MAIL_FROM,SEND_MAIL_FROM_NAME,$this->language->words['registration'],$message);
			$this->session->register('mail_confirmation_sent',time());
			return true;
		} else return false;
	}
	
	function activate($id,$key)
	{
		$this->db->query("select joined from ".DB_PREFIX."_users where id='".$this->db->escape_string($id)."'");
		$user=$this->db->fetch_array();
		if (!empty($user) && $key==md5($user['joined']))
		{
			if (!$this->db->query("update ".DB_PREFIX."_users set active='1' where id='".$this->db->escape_string($id)."'"))
			{
				$this->error='[string]database_error[/string]';
			}
		}
	}
	
	function re_send_mail_confirmation()
	{ 
		if (isset($this->session->var['user_id'],$this->session->var['user_pass']))
		{
			if ($this->send_mail_confirmation('',$this->session->var['user_id']))
				$this->message='[string]mail_confirmation_sent[/string]';
			else 
				$this->error='[string]mail_confirmation_not_sent[/string]';
		}
	}
	
	function build_profile()
	{
		if (isset($this->session->var['user_id'],$this->session->var['user_pass']))
		{
			$this->build_information_form();
		} else 
		{
			$this->build_auth_form();
		}
	}
	
	function authorize($login,$pass,$redirect=true)
	{
		if (empty($login) || empty($pass)) return ;
		
		$this->db->query("select id,passwd from ".DB_PREFIX."_users where login='".$this->db->escape_string($login)."'");
		$user=$this->db->fetch_array();
		$pass=$this->user->crypt_password($pass);
		if (!empty($user) && $user['passwd'] == $pass)
		{
			$this->session->register('user_id',$user['id']);
			$this->session->register('user_pass',$user['passwd']);
			if (isset($_SERVER['HTTP_REFERER']) && $redirect)
			{
				parent::redirect($_SERVER['HTTP_REFERER']);
			}
		} else 
		{
			$this->error='[string]wrong_login_or_password[/string]';
		}
	}
	
	function build_auth_form()
	{
		$elems=array(
					'custom',
					'text',
					'password',
					'submit',
					'custom'					
					);
		$attr=array(
					'',
					'name="login" style="width:100%"',
					'name="password" style="width:100%"',
					'value="[string]send[/string]" style="width:100px"',
					''
					);
		$descr=array(
					' ',
					'[string]login[/string]',
					'[string]password[/string]',
					' ',
					' '
					);
		$custom=array(
					(ALLOW_USER_REGISTER || $this->user->group == 1) ? parent::build_anchor('user/register','[string]registration[/string]') : '',
					'',
					'',
					'',
					ALLOW_USER_REGISTER ? parent::build_anchor('user/remind','[string]forgot_your_password[/string]') : ''
					);
		
		echo '<div style="width:100%" align="center">';
		echo '<p style="width:300px;text-align:left;font-weight:bold;margin-top:20px">[string]authorization[/string] :</p>';
		echo parent::build_form('user',$elems,'300px',$descr,$attr,$custom,'form',true);
		echo '</div>';
	}
	
	function build_information_form()
	{
		if (!isset($this->session->var['user_id']) || !isset($this->session->var['user_pass'])) return;
		
		$this->user->identify();
		
		$login=$this->user->login;
		$joined=date('d.m.Y',$this->user->joined);
		$name=$this->user->name;
		$info=$this->user->info;
		
		$deleteAva=(!file_exists(ROOT_DIR.'/upload/user/'.md5($this->user->login).'.ava')) ? 'disabled' : '';
		
		if ($this->user->active != 1)
		{
			$activate=parent::build_anchor('user/activate','[string]did_not_recieve_activation_message[/string]');
		} else 
			$activate='';
		
		$gender='<input type="radio" name="user_gender" value="" '.((empty($this->user->gender)) ? 'checked' : '').' style="border:none;background:none" /><span style="font-size:10px">[string]dont_show_gender[/string]</span>&nbsp;';
		$gender.='<input type="radio" name="user_gender" value="M" '.(($this->user->gender=='M') ? 'checked' : '').' style="border:none;background:none" /><span style="font-size:10px">[string]male[/string]</span>&nbsp;';	
		$gender.='<input type="radio" name="user_gender" value="F" '.(($this->user->gender=='F') ? 'checked' : '').' style="border:none;background:none" /><span style="font-size:10px">[string]female[/string]</span>';
		
		if (!empty($this->user->dob))
		{
			$dob_arr=explode('.',$this->user->dob);
		} else 
		{
			$dob_arr=array('','','');
		}
		
		$dob_day_sel='<select name="dob_day" style="width:50px">';
		$dob_day_sel.='<option value="">[string]day[/string]</option>';
		for ($i=1;$i<=31;$i++)
		{
			$i=str_pad($i,2,'0',STR_PAD_LEFT);
			if ($i==$dob_arr[0])
				$dob_day_sel.='<option value="'.$i.'" selected>'.$i.'</option>';
			else 
				$dob_day_sel.='<option value="'.$i.'">'.$i.'</option>';

		}
		$dob_day_sel.='</select>';
		
		$months=$this->user->dob_months;
		
		$dob_month_sel='<select name="dob_month" style="width:100px">';
		$dob_month_sel.='<option value="">[string]month[/string]</option>';
		for ($i=1;$i<13;$i++)
		{
			$i=str_pad($i,2,'0',STR_PAD_LEFT);
			if ($i==$dob_arr[1])
				$dob_month_sel.='<option value="'.$i.'" selected>[string]'.$months[$i].'[/string]</option>';
			else 
				$dob_month_sel.='<option value="'.$i.'">[string]'.$months[$i].'[/string]</option>';

		}
		$dob_month_sel.='</select>';
		
		$dob_year_sel='<select name="dob_year" style="width:50px">';
		$dob_year_sel.='<option value="">[string]year[/string]</option>';
		for ($i=1960;$i<=date('Y',time());$i++)
		{
			if ($i==$dob_arr[2])
				$dob_year_sel.='<option value="'.$i.'" selected>'.$i.'</option>';
			else 
				$dob_year_sel.='<option value="'.$i.'">'.$i.'</option>';

		}
		$dob_year_sel.='</select>';
		
		$dob=$dob_day_sel.'&nbsp;&nbsp;'.$dob_month_sel.'&nbsp;&nbsp;'.$dob_year_sel;
		
		$country='<select name="user_country" style="width:250px">';
		$country.='<option value="">[string]choose[/string]</option>';
		foreach ($this->user->countries as $code=>$country_name)
		{
			if ($this->user->country==$code)
				$country.='<option value="'.$code.'" selected>'.$country_name.'</option>';
			else 
				$country.='<option value="'.$code.'">'.$country_name.'</option>';
		}
		$country.='</select>';
		
		$elems=array(
					'text',
					'custom',
					'custom',
					'file',
					'checkbox',
					'custom',
					'custom',
					'custom',
					'custom',
					'custom',
					'text',
					'text',
					'text',
					'custom',
					'password',
					'password',
					'custom',
					'password',
					'submit'
					);
		$attr=array(
					'name="user_name" style="width:100%" value="'.$name.'"',
					'',
					'',
					'name="user_avatar" style="width:100%"',
					'name="delete_avatar" '.$deleteAva,
					'',
					'',
					'',
					'',
					'',
					'name="user_icq" style="width:100%" value="'.$this->user->icq.'"',
					'name="user_msn" style="width:100%" value="'.$this->user->msn.'"',
					'name="user_skype" style="width:100%" value="'.$this->user->skype.'"',
					'',
					'name="user_new_password" style="width:100%"',
					'name="user_new_password_re" style="width:100%"',
					'',
					'name="user_password" style="width:100%"',
					'value="[string]send[/string]" style="width:100px"'
					);
		$descr=array(
					'[string]name[/string]',
					'[string]information[/string]',
					' ',
					'[string]photo[/string]',
					'[string]delete_photo[/string]',
					' ',
					'[string]gender[/string]',
					'[string]dob[/string]',
					'[string]country[/string]',
					' ',
					'[string]icq[/string]',
					'[string]msn[/string]',
					'[string]skype[/string]',
					' ',
					'[string]new_password[/string]',
					'[string]new_password_re[/string]',
					' ',
					'[string]current_password[/string]*',
					' '
					);
		$custom=array(
					'',
					'<textarea name="user_info" cols="50" rows="10" style="width:100%" >'.$info.'</textarea>',
					'<br />',
					'',
					'',
					'<br />',
					$gender,
					$dob,
					$country,
					'<br />',
					'',
					'',
					'',
					'<br />',
					'',
					'',
					'<br />'
					);
		
		echo '<h3>[string]my_profile[/string]</h3>';
		echo '<div style="float:right">'.parent::build_anchor('user/logout','[string]logout[/string]').'</div>';
		echo '<table><tr><td valign="top">'.$this->user->photo.'</td><td valign="top" style="padding-left:10px">';
		echo '<b>'.$login.'</b><br />';
		$group='[string]group_'.$this->user->group.'[/string]';
		echo '<span style="color:#4F3B48">[string]group[/string] : '.$group.'</span><br />';
		echo '<span style="color:#4F3B48">[string]joined[/string] : '.$joined.'</span><br />';
		echo '<b>'.$activate.'</b>';
		echo '</td></tr></table>';
		echo '<p>[string]information_note_1[/string]<br />[string]information_note_2[/string]<br />[string]information_note_4[/string]<br />[string]information_note_5[/string]<br />[string]information_note_6[/string]</p><br />';
		echo '<div align="center">';
		echo parent::build_form('user',$elems,'500px',$descr,$attr,$custom,'form',true);
		echo '<p style="width:500px;text-align:left">[string]information_note_3[/string]</p>';
		echo '</div>';
	}
	
	function change_information()
	{
		if (!isset($this->session->var['user_id']) || !isset($this->session->var['user_pass'])) return;
		
		if ($this->session->var['user_pass'] == $this->user->crypt_password($_POST['user_password']))
		{
			$name='';
			if (!empty($_POST['user_name']))
			{
				if ($this->user->validate_word($_POST['user_name'],1,255,true))
				{
					$name=$_POST['user_name'];
				} else 
				{
					$this->error='[string]invalid_name[/string]';
				}
			}
			
			$info=(!empty($_POST['user_info'])) ? htmlspecialchars($_POST['user_info']) : null;
			
			$gender=(!empty($_POST['user_gender']) && ($_POST['user_gender']=='M' || $_POST['user_gender']=='F')) ? $_POST['user_gender'] : ''; 
			
			$dob='';
			if (!empty($_POST['dob_day']) && !empty($_POST['dob_month']) && !empty($_POST['dob_year']))
			{
				if (is_numeric($_POST['dob_day']) && $_POST['dob_day']>=1 && $_POST['dob_day']<=31 && array_key_exists($_POST['dob_month'],$this->user->dob_months) && is_numeric($_POST['dob_year']) && $_POST['dob_year']>=1960 && $_POST['dob_year']<=date('Y',time()))
				{
					$dob=str_pad($_POST['dob_day'],2,'0',STR_PAD_LEFT).'.'.$_POST['dob_month'].'.'.$_POST['dob_year'];
				} else 
				{
					$this->error='[string]invalid_dob[/string]';
				}
			}
			
			$country=(!empty($_POST['user_country']) && array_key_exists($_POST['user_country'],$this->user->countries)) ? $_POST['user_country'] : '';
			
			$icq='';
			if (!empty($_POST['user_icq']) && is_numeric(str_replace(' ','',str_replace('-','',$_POST['user_icq'])))) 
			{
				$icq=htmlspecialchars($_POST['user_icq']);
			} elseif (!empty($_POST['user_icq'])) 
			{
				$this->error='[string]invalid_icq[/string]';
			}
			
			$msn=(!empty($_POST['user_msn'])) ? htmlspecialchars($_POST['user_msn']) : '';
			
			$skype=(!empty($_POST['user_skype'])) ? htmlspecialchars($_POST['user_skype']) : '';
			
			if (!$this->db->query("update ".DB_PREFIX."_users set 
									name='".$this->db->escape_string($name)."',
									info='".$this->db->escape_string($info)."',
									gender='".$this->db->escape_string($gender)."',
									dob='".$this->db->escape_string($dob)."',
									country='".$this->db->escape_string($country)."',
									icq='".$this->db->escape_string($icq)."',
									msn='".$this->db->escape_string($msn)."',
									skype='".$this->db->escape_string($skype)."' 
									where id='".$this->db->escape_string($this->session->var['user_id'])."'"))
			{
				$this->error='[string]database_error[/string]';
			}
			
			if (empty($this->error) && empty($this->message)) $this->message='[string]profile_updated[/string]';
		} else 
		{
			$this->error='[string]wrong_password[/string]';
		}
	}
	
	function change_password()
	{
		if (!isset($this->session->var['user_id']) || !isset($this->session->var['user_pass'])) return;
		
		if ($this->session->var['user_pass'] == $this->user->crypt_password($_POST['user_password']))
		{
			if (empty($_POST['user_new_password_re']) || $_POST['user_new_password'] != $_POST['user_new_password_re'])
			{
				if (!empty($this->error))
					$this->error.='<br />[string]passwords_does_not_match[/string]';
				else 
					$this->error='[string]passwords_does_not_match[/string]';
			} elseif(!$this->user->validate_word($_POST['user_new_password'],6,255)) 
			{
				if (!empty($this->error))
					$this->error.='<br />[string]invalid_password[/string]';
				else 
					$this->error='[string]invalid_password[/string]';
			} else
			{
				$password=$this->user->crypt_password($_POST['user_new_password']);
				if (!$this->db->query("update ".DB_PREFIX."_users set passwd='".$this->db->escape_string($password)."' where id='".$this->db->escape_string($this->session->var['user_id'])."'"))
				{
					if (!empty($this->error))
						$this->error.='<br />[string]database_error[/string]';
					else 
						$this->error='[string]database_error[/string]';
				} else 
				{
					$this->authorize($this->user->login,$_POST['user_new_password'],false);
					$this->message='[string]password_changed[/string]';
				}
			}
		} else 
		{
			$this->error='[string]wrong_password[/string]';
		}
	}
	
	function change_avatar($file)
	{
		if (!isset($this->session->var['user_id']) || !isset($this->session->var['user_pass'])) return;
		
		if ($this->session->var['user_pass'] == $this->user->crypt_password($_POST['user_password']))
		{
			if ($this->user->validate_avatar($file))
			{
				switch ($this->user->resize_avatar)
				{
					case true :
						if (!$this->user->resize_avatar($file['tmp_name'],md5($this->user->login),true))
						{
							if (!empty($this->error))
								$this->error.='<br />[string]could_not_save_file[/string]';
							else 
								$this->error='[string]could_not_save_file[/string]';
						}
						break;
					default:
						if (!@copy($file['tmp_name'],ROOT_DIR.'/upload/user/'.md5($this->user->login).'.ava'))
						{
							if (!empty($this->error))
								$this->error.='<br />[string]could_not_save_file[/string]';
							else 
								$this->error='[string]could_not_save_file[/string]';
						}
						break;
				}
			} else 
			{
				if (!empty($this->error))
					$this->error.='<br />[string]invalid_file_uploaded[/string]';
				else 
					$this->error='[string]invalid_file_uploaded[/string]';
			}
		} else 
		{
			$this->error='[string]wrong_password[/string]';
		}
	}
	
	function delete_avatar()
	{
		if (!isset($this->session->var['user_id']) || !isset($this->session->var['user_pass'])) return;
		
		if ($this->session->var['user_pass'] == $this->user->crypt_password($_POST['user_password']))
		{
			$ava_path=ROOT_DIR.'/upload/user/'.md5($this->user->login).'.ava';
			if (file_exists($ava_path))
			{
				if (!unlink($ava_path))
				{
					$this->error='[string]could_not_delete_file[/string]';
				}
			} else 
			{
				if (!empty($this->error))
					$this->error.='<br />[string]file_not_found[/string]';
				else 
					$this->error='[string]file_not_found[/string]';
			}
		} else 
		{
			$this->error='[string]wrong_password[/string]';
		}
	}
	
	function show_information($login)
	{
		if (!isset($this->session->var['user_id'],$this->session->var['user_pass']))
		{
			$this->build_auth_form();
			return;
		}
		
		$this->db->query("select * from ".DB_PREFIX."_users where login='".$this->db->escape_string($login)."'");
		$user=$this->db->fetch_array();
		if (!empty($user))
		{
			$name=$user['name'];
			$group='[string]group_'.$user['group_id'].'[/string]';
			$joined=date('d.m.Y',$user['joined']);
			$info=nl2br($user['info']);
			$ava_path=ROOT_DIR.'/upload/user/'.md5($login).'.ava';
			$gender='[string]not_defined[/string]';
			if (!empty($user['gender']))
			{
				switch ($user['gender'])
				{
					case 'M':
						$gender='[string]male[/string]';
						break;
					case 'F':
						$gender='[string]female[/string]';
						break; 
				}
			}
			$dob=!empty($user['dob']) ? $user['dob'] : '[string]not_defined[/string]';
			$country=!empty($user['country']) ? $this->user->countries[$user['country']] : '[string]not_defined[/string]';
			$icq=!empty($user['icq']) ? $user['icq'] : '[string]not_defined[/string]';
			$msn=!empty($user['msn']) ? $user['msn'] : '[string]not_defined[/string]';
			$skype=!empty($user['skype']) ? $user['skype'] : '[string]not_defined[/string]';
			
			if (file_exists($ava_path))
			{
				$image=@getimagesize($ava_path);
				$image_size=!empty($image) ? $image[3] : '';
				$photo='<img src="'.PROTOCOL.'://'.SITE_HOST.'/upload/user/'.md5($login).'.ava" '.$image_size.' />';
			} else 
			{
				$photo='<img src="'.PROTOCOL.'://'.SITE_HOST.'/sawanna/images/user.jpg" width="100" height="100" />';
			}
			
			echo '<h3>[string]user_profile[/string]</h3>';
			
			echo '<div style="border:1px solid #DDDDDD;padding:10px;background-color:#FFFFFF;background-image:url(\''.HOME.'/sawanna/images/palma.jpg\');background-position: bottom right;background-repeat:repeat-y">';
			
			echo '<table><tr><td valign="top">'.$photo.'</td><td valign="top" style="padding-left:10px">';
			echo '<b>'.$login.'</b><br /><br />';
			if (!empty($name))
			{
				echo '<span>[string]name[/string] : </span><span class="users_name">'.$name.'</span><br />';
			}
			echo '<span class="users_group">[string]group[/string] : '.$group.'</span><br />';
			echo '<span class="users_joined">[string]joined[/string] : '.$joined.'</span><br />';
			echo '</td></tr></table>';
			
			echo '<div style="padding:25px">';
			if (!empty($user['gender']))
			{
				echo '<span class="users_gender_str">[string]gender[/string] : </span><span class="users_gender">'.$gender.'</span><br />';
			}
			echo '<span class="users_dob_str">[string]dob[/string] : </span><span class="users_dob">'.$dob.'</span><br />';
			echo '<span class="users_country_str">[string]country[/string] : </span><span class="users_country">'.$country.'</span><br />';
			echo '<br />';
			echo '<span class="users_icq_str">[string]icq[/string] : </span><span class="users_icq">'.$icq.'</span><br />';
			echo '<span class="users_msn_str">[string]msn[/string] : </span><span class="users_msn">'.$msn.'</span><br />';
			echo '<span class="users_skype_str">[string]skype[/string] : </span><span class="users_skype">'.$skype.'</span><br />';
			echo '</div>';
			
			echo '</div>';
			
			echo '<p style="text-align:left;padding:10px">'.$info.'</p>';
		} else 
		{
			$this->error='[string]user_not_found[/string]';
		}
	}
	
	function remind()
	{
		if (isset($this->session->var['user_id'],$this->session->var['user_pass']))
		{
			parent::redirect(parent::build_url('home'));
		}
		
		echo '<p>[string]remind_text[/string]</p><br />';
		
		$elems=array(
					'text',
					'text',
					'custom',
					'text',
					'submit'
					);
					
		$attr=array(
					'name="login" style="width:200px"',
					'name="mail" style="width:200px"',
					'',
					'name="captcha" style="width:100px"',
					'value="[string]send[/string]"'
					);
					
		$desc=array(
					'[string]login[/string]',
					'[string]mail[/string]',
					' ',
					'[string]enter_code[/string]',
					' '
					);
					
		$custom=array(
					'',
					'',
					'<img src="'.parent::build_url('captcha').'" width="100" height="30" border="1" />'
					);
					
		echo '<div align="center">';
		echo parent::build_form('user/remind',$elems,'400px',$desc,$attr,$custom,'form',true);
		echo '</div>';
	}
	
	function doremind()
	{
		if (isset($this->session->var['user_id'],$this->session->var['user_pass']))
		{
			parent::redirect(parent::build_url('home'));
		}
		
		if (isset($this->session->var['remind_sent']) && $this->session->var['remind_sent']>time()-3600)
		{
			$this->error="[string]remind_not_sent[/string]";
			return ;
		}
	
		if (!isset($_POST['captcha']) || empty($_POST['captcha']))
		{
			$this->error="[string]captcha_not_match[/string]";
			return ;
		}
		
		if (!$this->captcha->check($_POST['captcha']))
		{
			$this->error="[string]captcha_not_match[/string]";
			return ;
		}
		
		$this->db->query("select mail from ".DB_PREFIX."_users where login='".$this->db->escape_string($_POST['login'])."'");
		$user=$this->db->fetch_array();
		if (empty($user) || $user['mail'] != $_POST['mail'])
		{
			$this->error="[string]wrong_login_or_mail[/string]";
			return ;
		} else 
		{
			$chars='abcdefghijklmnopqrstuvwxyz';
			$new_password='';
			
			for ($i=0;$i<10;$i++)
			{
				$new_password.=$chars[mt_rand(0,25)];
			}
			
			$password=$this->user->crypt_password($new_password);
			if (!$this->db->query("update ".DB_PREFIX."_users set passwd='".$this->db->escape_string($password)."' where login='".$this->db->escape_string($_POST['login'])."'"))
			{
				$this->error='[string]database_error[/string]';
				return ;
			} else 
			{
				$message=file_get_contents(ROOT_DIR.'/language/'.quotemeta($this->language->current).'/forgot_password.html');
				$message=str_replace('{header}',SITE_NAME,$message);
				$message=str_replace('{password}',$new_password,$message);
				$this->mail->sendMail($user['mail'],SEND_MAIL_FROM,SEND_MAIL_FROM_NAME,$this->language->words['your_new_password'],$message);
				$this->session->register('remind_sent',time());
				$this->message='[string]remind_sent[/string]';
				return ;
			}
		}
	}
	
	function logout()
	{
		$this->session->clear('user_id');
		$this->session->clear('user_pass');
		$url=parent::build_url('user');
		parent::redirect($url);
	}
}

function user_init($env)
{
	global $UserInterface;
	
	header("Cache-Control: no-cache, must-revalidate");
	header("Expires: ".date('r',time()-3600)); 
	
	$UserInterface=new CUserInterface($env['user']);
	$UserInterface->db=&$env['db'];
	$UserInterface->query=&$env['query'];
	$UserInterface->session=&$env['session'];
	$UserInterface->captcha=&$env['captcha'];
	$UserInterface->language=&$env['language'];
	$UserInterface->tpl=&$env['tpl'];
	$UserInterface->mail=&$env['mail'];
	$UserInterface->ok=&$env['ok'];
}

function user_exec()
{
	global $UserInterface;
	
	switch ($UserInterface->query)
	{
		case 'register' :
			if (!ALLOW_USER_REGISTER && $UserInterface->user->group != 1)
			{
				$UserInterface->error='[string]registration_stopped[/string]';
				break;
			}
			if (isset($_POST['login'],$_POST['password'],$_POST['password_re'],$_POST['mail']))
			{
				if (!empty($_POST['login']) && !empty($_POST['password']) && !empty($_POST['password_re']) && !empty($_POST['mail']))
				{
					if (!isset($_POST['agree']) || $_POST['agree'] != 'on')
					{
						$UserInterface->error='[string]agreement_is_required[/string]';
						$UserInterface->build_register_form();
					} elseif ($_POST['password'] != $_POST['password_re'])
					{
						$UserInterface->error='[string]passwords_does_not_match[/string]';
						$UserInterface->build_register_form();
					} else 
					{
						if (!$UserInterface->register($_POST['login'],$_POST['password'],$_POST['mail']))
						{
							$UserInterface->build_register_form();
						}
					}
				} else 
				{
					$UserInterface->error='[string]all_fields_are_required[/string]';
					$UserInterface->build_register_form();
				}
			} else 
			{
				$UserInterface->build_register_form();
			}
			break;
		case 'activate' :
			$UserInterface->re_send_mail_confirmation();
			$UserInterface->build_profile();
			break;
		case 'remind' :
			
			if (isset($_POST['login']) && !empty($_POST['login']) && isset($_POST['mail']) && !empty($_POST['mail']))
			{
				$UserInterface->doremind();
				if (empty($UserInterface->error))
				{
					$UserInterface->build_auth_form();
					break;
				}
			}
			$UserInterface->remind();
			break;
		case 'logout' :
			$UserInterface->logout();
			break;
		default : 
			if (strlen($UserInterface->query)>7 && substr($UserInterface->query,0,5)=='view/')
			{
				$view=substr($UserInterface->query,5);
				$UserInterface->show_information($view);
			} else 
			{
				if (isset($_GET['id'],$_GET['key']))
				{
					$UserInterface->activate($_GET['id'],$_GET['key']);
				}
				
				if (isset($_POST['login'],$_POST['password']) && !empty($_POST['login']) && !empty($_POST['password']))
				{
					$UserInterface->authorize($_POST['login'],$_POST['password']);
				}
				
				if ((isset($_POST['user_name']) || isset($_POST['user_info']) || isset($_POST['user_gender']) || isset($_POST['user_country']) || isset($_POST['user_icq']) || isset($_POST['user_msn']) || isset($_POST['user_skype']) || isset($_POST['dob_day'],$_POST['dob_month'],$_POST['dob_year'])) && !empty($_POST['user_password']))
				{
					$UserInterface->change_information();
				}
				if (isset($_POST['delete_avatar']) && $_POST['delete_avatar']=='on' && !empty($_POST['user_password']))
				{
					$UserInterface->delete_avatar();
				}
				if (!empty($_FILES['user_avatar']) && !empty($_FILES['user_avatar']['name']) && !empty($_POST['user_password']))
				{
					$UserInterface->change_avatar($_FILES['user_avatar']);
				}
				if (!empty($_POST['user_new_password']) && !empty($_POST['user_password']))
				{
					$UserInterface->change_password();
				}
				if ((isset($_POST['user_name']) || isset($_POST['user_info']) || isset($_POST['user_new_password']) || isset($_POST['delete_avatar']) || isset($_POST['user_avatar'])) && empty($_POST['user_password']))
				{
					$UserInterface->error='[string]current_password_is_required[/string]';
				}
				$UserInterface->build_profile();
			}
			break;
	}
	
	$result=array($UserInterface->message,$UserInterface->error,'[string]user_cabinet[/string]');
	return $result;
}

function user_clear()
{
	global $UserInterface;
	
	unset(
		$UserInterface->db,
		$UserInterface->user,
		$UserInterface->query,
		$UserInterface->session,
		$UserInterface->captcha,
		$UserInterface->language,
		$UserInterface->tpl,
		$UserInterface->mail,
		$UserInterface->message,
		$UserInterface->error,
		$UserInterface->ok
		);
}
?>