<?php
defined("SAWANNA") or die();


#################################################################
# sawanna_languages
# An array which register the site languages
# NOTE! The language must have a name such a name of its directory.
# NOTE! All translatable strings will be included from the lang.php file
/* Example :
$sawanna_languages=array
(
'ru' => 'English'    // the right side is a string which will be displayed in languages menu.
); */
#################################################################

$sawanna_languages=array
(
//'en' => 'English',
//'ru' => 'Русский'
);





###########################################################
# sawanna_workspaces
# An array which register the site workspaces.
# NOTE! The default workspace must be defined in configuration file.
# NOTE! Also the administrative workspace defined in configuration file is required.
# NOTE! The `ajax`, `captcha` and `rss` named workspaces are reserved. 
# NOTE! All elements must be also arrays.
/* Example :
$sawanna_workspaces=array
(
'workspace'     => array(
					'header' => array('parent_navigator'),     //  the left side is the template component
					'left'   => array('child_navigator'),      //  the right side is a module or modules which will be called
					'body'   => 'static',
					'right'  => array('login'),
					'footer' => array('alter_navigator')
					 )
);
*/
###########################################################
$sawanna_workspaces=array
(
'home'     => array(
					'header' => array('pictograms','languages','sitelogo','parent_navigator'),
					'left'   => array('child_navigator','news_preview'),
					'body'   => array('node','article'),
					'right'  => array('login','searchBar'),
					'footer' => array('alter_navigator')
					 ),
'public'    => array(
					'header' => array('pictograms','languages','sitelogo','parent_navigator'),
					'left'   => array('child_navigator','news_preview'),
					'breadcrumbs' => 'breadcrumbs',
					'body'   => array('node'),
					'right'  => array('login','searchBar'),
					'footer' => array('alter_navigator')
					 ),
'article'    => array(
					'header' => array('pictograms','languages','sitelogo','parent_navigator'),
					'left'   => array('child_navigator','news_preview'),
					'breadcrumbs' => 'breadcrumbs',
					'body'   => array('article','comments'),
					'right'  => array('login','searchBar'),
					'footer' => array('alter_navigator')
					 ),
'user'      => array(
					'header' => array('pictograms','languages','sitelogo','parent_navigator'),
					'left'   => array('child_navigator','news_preview'),
					'body'   => array('user'),
				    'right'  => array('searchBar'),
					'footer' => array('alter_navigator')
					 ),
'users'      => array(
					'header' => array('pictograms','languages','sitelogo','parent_navigator'),
					'left'   => array('child_navigator','news_preview'),
					'body'   => array('users'),
				    'right'  => array('login','searchBar'),
					'footer' => array('alter_navigator')
					 ),
'feedback'      => array(
					'header' => array('pictograms','languages','sitelogo','parent_navigator'),
					'left'   => array('child_navigator','news_preview'),
					'breadcrumbs' => 'breadcrumbs',
					'body'   => array('feedback'),
				 	'right'  => array('login','searchBar'),
					'footer' => array('alter_navigator')
					 ),
'map'      => array(
					'header' => array('pictograms','languages','sitelogo','parent_navigator'),
					'left'   => array('child_navigator','news_preview'),
					'breadcrumbs' => 'breadcrumbs',
					'body'   => array('map'),
				    'right'  => array('login','searchBar'),
					'footer' => array('alter_navigator')
					 ),
'search'      => array(
					'header' => array('pictograms','languages','sitelogo','parent_navigator'),
					'left'   => array('child_navigator','news_preview'),
					'body'   => array('search'),
				    'right'  => array('login'),
					'footer' => array('alter_navigator')
					 ),
'news'    => array(
					'header' => array('pictograms','languages','sitelogo','parent_navigator'),
					'left'   => array('child_navigator','archive'),
					'body'   => array('news','comments'),
					'right'  => array('login','searchBar'),
					'footer' => array('alter_navigator')
					 ),					 
ADMIN_WORKSPACE     => array(
					'header' => array('pictograms','languages','sitelogo','parent_navigator'),
					'left'   => array('adminBar'),
					'body'   => array('welcome','phpinfo','stat','pageAdmin','articleAdmin','menuAdmin','userAdmin','newsAdmin','files','comments','commentsAdmin','config','addons','langpack','themes'),
					'right'  => array('login'),
					'footer' => array('alter_navigator')
					 )
);




#######################################################
# sawanna_templates
# An array which assigns the template to all workspaces
# NOTE! The template must be located in current theme directory
/* Example :
$sawanna_templates=array
(
'workspace' => 'template'  // template file extension (tpl) will be added by script
); */
#######################################################
$sawanna_templates=array
(
'home'     => 'main',
'public'   => 'main',
'article' => 'main',
'user'     => 'main',
'users'    => 'main',
'feedback' => 'main',
'map'     => 'main',
'search'     => 'main',
'news'     => 'main',
'admin'   => 'main'
);




####################################################
# sawanna_modules
# An array which contains all modules names
# Before calling the module it must be registered here
# NOTE! The modules must be located in module directory.
/* Example :
$sawanna_modules=array(
'name'    =>  'name/index.php'   //  the right side is address where the module is located (NOTE! its root is the module directory)
); */
####################################################
$sawanna_modules=array(
'node'     => 'page/index.php',
'user'     => 'user/index.php',
'login'     => 'user/login.php',
'parent_navigator' => 'navigator/parent.php',
'child_navigator' => 'navigator/child.php',
'alter_navigator' => 'navigator/alter.php',
'pageAdmin'    =>  'page/admin.php',
'menuAdmin'    =>  'navigator/admin.php',
'feedback'   => 'services/feedback.php',
'map'   => 'services/map.php',
'languages'  => 'services/languages.php',
'pictograms' => 'services/pictograms.php',
'userAdmin' => 'user/admin.php',
'search'  => 'services/search.php',
'searchBar' => 'services/searchbar.php',
'adminBar' => 'services/adminbar.php',
'phpinfo' => 'services/phpinfo.php',
'stat' => 'services/statistics.php',
'welcome' => 'services/welcome.php',
'news' => 'news/index.php',
'news_preview' => 'news/preview.php',
'newsAdmin' => 'news/admin.php',
'archive' => 'news/archive.php',
'files' => 'services/files.php',
'article' => 'article/index.php',
'articleAdmin' => 'article/admin.php',
'comments' => 'comments/index.php',
'commentsAdmin' => 'comments/admin.php',
'sitelogo' => 'services/sitelogo.php',
'config' => 'services/configuration.php',
'addons' => 'services/addons.php',
'langpack' => 'services/langpack.php',
'themes' => 'services/themes.php',
'breadcrumbs' => 'breadcrumbs/index.php',
'users'  => 'services/users.php'
);




####################################################
# sawanna_ajax_components
# An array which contains all ajax components names
# To recieve ajax requests the component must be registered here
# NOTE! The components must be located in module directory.
/* Example :
$sawanna_ajax_components=array(
'component'    =>  'component/index.php'   //  the right side is address where the component is located (NOTE! its root is the module directory)
); */
####################################################
$sawanna_ajax_components=array(
'pageAdmin'    =>  'page/admin.php',
'menuAdmin'       =>    'navigator/admin.php',
'upload'      =>  'services/upload.php',
'userAdmin'      => 'user/admin.php',
'articleAdmin' => 'article/admin.php'
);






####################################################
# sawanna_rss_components
# An array which contains all rss components names
# To generate rss content the component must be registered here
# NOTE! The components must be located in module directory.
/* Example :
$sawanna_rss_components=array(
'component'    =>  'component/index.php'   //  the right side is address where the component is located (NOTE! its root is the module directory)
); */
####################################################
$sawanna_rss_components=array(
'news' => 'news/index.php',
'article' => 'article/index.php'
);



########################################################
# sawanna_admin_components
# An array which contains all protected components names
# These modules can run only administrators
/* Example :
$sawanna_admin_components=array(
'component'
); */
########################################################
$sawanna_admin_components=array(
'pageAdmin',
'menu',
'menuAdmin',
'upload',
'userAdmin',
'adminBar',
'phpinfo',
'stat',
'welcome',
'newsAdmin',
'files',
'articleAdmin',
'config',
'addons',
'langpack',
'themes',
'commentsAdmin'
);






###################################################
# sawanna_admin_panel_elements
# An array which will be used building admin panel
# NOTE! All elements must be also arrays
/* Example :
$sawanna_admin_panel_elements=array(
'element'=> array(
				'name' => 'elem',                                 // used to generate unique id
				'desc' => 'Component Description',                  //  displays in component window
				'btn' => HOME.'/sawanna/images/element_ico.gif',     // url of component icon to display in admin panel
				'winWidth' => '500px',                             //  component window width
				'winHeight' => '400px',                           //  component window height
				'winTitle' => 'Component Title',                  //  component window title
				'url' => 'ajax/component',                        //  url from which will be requested content for window (NOTE! ajax workspace is required, the component must be registered)
				'workspace' => 'home'                           //  workspace (or workspaces if array) in which element to display
				)
); */
###################################################
$sawanna_admin_panel_elements=array(
'new_page'=> array(
				'name' => 'newPage',
				'desc' => '[string]new_page[/string]',
				'btn' => HOME.'/sawanna/images/new_page.gif',
				'winWidth' => '640px',
				'winHeight' => '540px',
				'winTitle' => '[string]page[/string]',
				'url' => 'ajax/pageAdmin/&component=page&act=create',
				'workspace' => array('home','public')
				),
'edit_page'=> array(
				'name' => 'editPage',
				'desc' => '[string]edit_page[/string]',
				'btn' => HOME.'/sawanna/images/edit_page.gif',
				'winWidth' => '640px',
				'winHeight' => '540px',
				'winTitle' => '[string]page[/string]',
				'url' => 'ajax/pageAdmin/&component=page&act=edit',
				'workspace' => 'public'
				),
'delete_page'=> array(
				'name' => 'deletePage',
				'desc' => '[string]delete_page[/string]',
				'btn' => HOME.'/sawanna/images/delete_page.gif',
				'winWidth' => '500px',
				'winHeight' => '190px',
				'winTitle' => '[string]page[/string]',
				'url' => 'ajax/pageAdmin/&component=page&act=del',
				'workspace' => 'public'
				),
'new_article'=> array(
				'name' => 'newArticle',
				'desc' => '[string]new_article[/string]',
				'btn' => HOME.'/sawanna/images/new_page.gif',
				'winWidth' => '640px',
				'winHeight' => '520px',
				'winTitle' => '[string]article[/string]',
				'url' => 'ajax/articleAdmin/&component=article&act=create',
				'workspace' => 'article'
				),
'edit_article'=> array(
				'name' => 'editArticle',
				'desc' => '[string]edit_article[/string]',
				'btn' => HOME.'/sawanna/images/edit_page.gif',
				'winWidth' => '640px',
				'winHeight' => '520px',
				'winTitle' => '[string]article[/string]',
				'url' => 'ajax/articleAdmin/&component=article&act=edit',
				'workspace' => 'article'
				),
'delete_article'=> array(
				'name' => 'deleteArticle',
				'desc' => '[string]delete_article[/string]',
				'btn' => HOME.'/sawanna/images/delete_page.gif',
				'winWidth' => '500px',
				'winHeight' => '190px',
				'winTitle' => '[string]article[/string]',
				'url' => 'ajax/articleAdmin/&component=article&act=del',
				'workspace' => 'article'
				),
'menu'=> array(
				'name' => 'menu',
				'desc' => '[string]menu_editor[/string]',
				'btn' => HOME.'/sawanna/images/menu.gif',
				'winWidth' => '500',
				'winHeight' => '300',
				'winTitle' => '[string]menu[/string]',
				'url' => 'ajax/menuAdmin/&component=menu&act=edit',
				'workspace' => array('home','public','article','admin','user','users','feedback','news')
				),
'upload'=> array(
				'name' => 'upload',
				'desc' => '[string]upload_files[/string]',
				'btn' => HOME.'/sawanna/images/upload.gif',
				'winWidth' => '500',
				'winHeight' => '320',
				'winTitle' => '[string]uploads[/string]',
				'url' => 'ajax/upload',
				'workspace' => array('home','public','article','admin','user','users','feedback','news')
				),
'users'=> array(
				'name' => 'users',
				'desc' => '[string]edit_users[/string]',
				'btn' => HOME.'/sawanna/images/users.gif',
				'winWidth' => '500',
				'winHeight' => '450',
				'winTitle' => '[string]users[/string]',
				'url' => 'ajax/userAdmin/&component=userAdmin&act=edit',
				'workspace' => array('home','public','article','admin','user','users','feedback','news')
				)
);





#######################################################
# bad_words
# An array which contains the bad words
# During initialisation all GET,COOKIE and some SERVER variables will be checked.
# If its defined to check the POST data in configuration file they will be checked too.
# NOTE! If bad word matched script stops working
/* Example :
$bad_words=array(
"bad"
); */
####################################################### 
$bad_words=array(
"'",
'select',
'union',
'insert',
'update',
'delete',
'alter',
'drop',
'benchmark',
'char',
'hex',
'load_file',
'outfile',
'\\x00'
);

$bad_logins=array(
'makaka'
);

$searchBots=array(
'Mozilla/5.0 (compatible; Googlebot/2.1; +http://www.google.com/bot.html)',
'Yandex/1.01.001 (compatible; Win16; I)'
);
				
?>