<?php
defined("SAWANNA") or die();

class CLanguage
{
	var $languages;
	var $current;
	var $db;
	var $words;
	var $error;
	
	function CLanguage(&$db)
	{
		global $sawanna_languages;
		$this->languages=$sawanna_languages;
		$this->current=null;
		$this->db=&$db;
		$this->words=array();
		$this->error="";
	}
	
	function init($lang='')
	{
		if (!empty($lang))
		{
			if (!$this->assign($lang)) return false;
		} else
		{
		          $accept_lang='';
		          if (defined('ACCEPT_LANGUAGE') && ACCEPT_LANGUAGE && !empty($_SERVER['HTTP_ACCEPT_LANGUAGE']))
		          {
		              $l=explode(';',$_SERVER['HTTP_ACCEPT_LANGUAGE']);
		              if (isset($l[0]) && !empty($l[0]))
		              {
		                  if (array_key_exists($l[0],$this->languages)) $accept_lang=$l[0];
		                  else 
		                  {
		                      $ll=explode(',',$l[0]);
		                      if (isset($ll[0]) && !empty($ll[0]) && array_key_exists($ll[0],$this->languages)) $accept_lang=$ll[0];
		                      elseif (isset($ll[1]) && !empty($ll[1]) && array_key_exists($ll[1],$this->languages)) $accept_lang=$ll[1];
		                  }
		              }
		          }
		          
		          if (!empty($accept_lang))
		          {
		              if (!$this->assign($accept_lang)) return false;
		          } elseif (!$this->assign(DEFAULT_LANGUAGE)) return false;
		}
		
		require_once(ROOT_DIR."/language/".$this->current."/lang.php");
		$this->words=$language_words;
		
		$this->db->query("select value from ".DB_PREFIX."_global where name='language_words_".$this->db->escape_string($this->current)."'");
		while ($glob=$this->db->fetch_array()) {
			$add_words=unserialize($glob['value']);
		
			if (is_array($add_words))
				$this->words=array_merge($this->words,$add_words);
		}
		
		return true;
	}
	
	function assign($language)
	{
		$language=quotemeta($language);
		
		if (!array_key_exists($language,$this->languages))
		{
			$this->error="Language '".$language."' not registered.";
			return false;
		}
		if (!file_exists(ROOT_DIR."/language/".$language."/lang.php"))
		{
			$this->error="Language '".$language."' not found.";
			return false;
		}
		$this->current=$language;
		return true;
	}
	
	function parse_words($text)
	{
		$string="";
		while (true)
		{
			if (($b_pos=strpos($text,"[string"))===false) break;
			if (($e_pos=strpos($text,"/string]"))===false) break;
				
			$string=substr($text,$b_pos+8,$e_pos-$b_pos-9);
			
			if (array_key_exists($string,$this->words))
				$text=str_replace("[string]".$string."[/string]",$this->words[$string],$text);
			elseif (DEBUG_MODE) 
				$text=str_replace("[string]".$string."[/string]","[".$string."]",$text);
			else 
				$text=str_replace("[string]".$string."[/string]","",$text);
		}
		return $text;
	}
}
?>