<?php
################################################################
# NOTE! node access is full if 1, users only if 2, nobody if 0
#		weight must be a value of (-128 to 127) 
################################################################

defined("SAWANNA") or die();

class CNavigator
{
	var $workspace;
	var $query;
	var $current;
	var $db;
	var $language;
	var $user;
	
	function CNavigator($workspace,$query,&$db,&$language,&$user)
	{
		$this->workspace=$workspace;
		$this->query=$query;
		$this->current=!empty($this->query) ? $this->workspace.'/'.$this->query : $this->workspace;
		$this->db=&$db;
		$this->language=&$language;
		$this->user=&$user;
	}
	
	function create($name,$parent=0,$link='',$mark='',$weight=0,$access=1)
	{
		if (!empty($weight) && !is_numeric($weight)) $weight=0;
		
		if ($this->db->query("insert into ".DB_PREFIX."_navigation (name,language,parent,link,mark,weight,access) values ('".$this->db->escape_string($name)."','".$this->db->escape_string($this->language->current)."','".$this->db->escape_string($parent)."','".$this->db->escape_string($link)."','".$this->db->escape_string($mark)."','".$this->db->escape_string($weight)."','".$this->db->escape_string($access)."')"))
			return true;
		else 
			return false;
	}
	
	function update($columns,$conditions)
	{
		if (!is_array($conditions) || empty($conditions)) return false;
		if (!is_array($columns) || empty($columns)) return false;
		
		$vals='';
		foreach ($columns as $column=>$value)
		{
			if (!empty($vals)) $vals.=',';
			$vals.=$this->db->escape_string($column)."='".$this->db->escape_string($value)."'";
		}
		
		$condition="language='".$this->db->escape_string($this->language->current)."'";
		foreach ($conditions as $column=>$value)
		{
			$condition.=' and ';
			$condition.=$this->db->escape_string($column)."='".$this->db->escape_string($value)."'";
		}
		
		if ($this->db->query("update ".DB_PREFIX."_navigation set ".$vals." where ".$condition))
			return true;
		else 
			return false;
	}
	
	function delete($conditions)
	{
		if (!is_array($conditions) || empty($conditions)) return false;
		
		$condition="language='".$this->db->escape_string($this->language->current)."'";
		foreach ($conditions as $column=>$value)
		{
			$condition.=' and ';
			$condition.=$this->db->escape_string($column)."='".$this->db->escape_string($value)."'";
		}
		
		if ($this->db->query("delete from ".DB_PREFIX."_navigation where ".$condition))
			return true;
		else 
			return false;
	}
	
	function get($conditions)
	{
		if (!is_array($conditions)) return ;
		
		$condition="language='".$this->db->escape_string($this->language->current)."'";
		
		foreach ($conditions as $column=>$value)
		{
			$condition.=' and ';
			$condition.=$this->db->escape_string($column)."='".$this->db->escape_string($value)."'";
		}
		
		switch ($this->user->group)
		{
			case 1 :
				$condition.='';
				break;
			case 2 :
				$condition.=' and ';
				$condition.="access <> '0'";
				break;
			default:
				$condition.=' and ';
				$condition.="access = '1'";
				break;
		}
		
		$result=$this->db->sub_query("select * from ".DB_PREFIX."_navigation where ".$condition."  order by weight");
		return $result;
	}
}
?>