<?php
################################################################
# NOTE! node access is full if 1, users only if 2, nobody if 0
################################################################

defined("SAWANNA") or die();

class CNode
{
	var $db;
	var $language;
	var $user;
	
	function CNode(&$db,&$language,&$user)
	{
		$this->db=&$db;
		$this->language=&$language;
		$this->user=&$user;
	}
	
	function create($name='',$content,$keywords='',$workspace,$link,$mark='',$access=1)
	{
		if ($this->db->query("insert into ".DB_PREFIX."_nodes (name,content,language,author_id,published,keywords,workspace,link,mark,access) values ('".$this->db->escape_string($name)."','".$this->db->escape_string($content)."','".$this->db->escape_string($this->language->current)."','".$this->db->escape_string($this->user->id)."','".time()."','".$this->db->escape_string($keywords)."','".$this->db->escape_string($workspace)."','".$this->db->escape_string($link)."','".$this->db->escape_string($mark)."','".$this->db->escape_string($access)."')"))
			return true;
		else 
			return false;
	}
	
	function update($columns,$conditions)
	{
		if (!is_array($conditions) || empty($conditions)) return false;
		if (!is_array($columns) || empty($columns)) return false;
		
		$vals='';
		foreach ($columns as $column=>$value)
		{
			if (!empty($vals)) $vals.=',';
			$vals.=$this->db->escape_string($column)."='".$this->db->escape_string($value)."'";
		}
		
		$condition="language='".$this->db->escape_string($this->language->current)."'";
		foreach ($conditions as $column=>$value)
		{
			$condition.=' and ';
			$condition.=$this->db->escape_string($column)."='".$this->db->escape_string($value)."'";
		}
		
		if ($this->db->query("update ".DB_PREFIX."_nodes set ".$vals." where ".$condition))
			return true;
		else 
			return false;
	}
	
	function delete($conditions)
	{
		if (!is_array($conditions) || empty($conditions)) return false;
		
		$condition="language='".$this->db->escape_string($this->language->current)."'";
		foreach ($conditions as $column=>$value)
		{
			$condition.=' and ';
			$condition.=$this->db->escape_string($column)."='".$this->db->escape_string($value)."'";
		}
		
		if ($this->db->query("delete from ".DB_PREFIX."_nodes where ".$condition))
			return true;
		else 
			return false;
	}
	
	function get($conditions)
	{
		if (!is_array($conditions)) return ;
		
		$condition="language='".$this->db->escape_string($this->language->current)."'";
		foreach ($conditions as $column=>$value)
		{
			$condition.=' and ';
			$condition.=$this->db->escape_string($column)."='".$this->db->escape_string($value)."'";
		}
		
		switch ($this->user->group)
		{
			case 1 :
				$condition.='';
				break;
			case 2 :
				$condition.=' and ';
				$condition.="access <> '0'";
				break;
			default:
				$condition.=' and ';
				$condition.="access = '1'";
				break;
		}
		
		$result=$this->db->sub_query("select * from ".DB_PREFIX."_nodes where ".$condition." order by published desc");
		return $result;
	}
}
?>