<?php
defined("SAWANNA") or die();

class CSession
{
	var $workspace;
	var $var;
	var $db;
	var $sid;
	var $shash;
	var $error;
	
	function CSession(&$db,$workspace)
	{
		$this->workspace=$workspace;
		$this->var=array();
		$this->db=&$db;
		$this->sid=null;
		$this->shash=null;
		$this->error=null;
	}
	
	function init()
	{
		$this->empty_trash();
		
		$userAgent=isset($_SERVER['HTTP_USER_AGENT']) ? $_SERVER['HTTP_USER_AGENT'] : 'Sawanna';
		
		$this->shash=md5($userAgent.$_SERVER['REMOTE_ADDR'].SITE_HOST);
		$this->sid=md5(SITE_NAME.microtime().$this->shash);
		
		if (SESSION_EMULATE)
		{
			$sid='';
			if (isset($_GET['sid'])) $sid=$_GET['sid'];
			if (isset($_COOKIE['sid'])) $sid=$_COOKIE['sid'];
			
			if (!empty($sid)) $this->sid=$sid;  //   required for ajax requests. NOTE! sid should be changed every time the script called, but in this case the session will be lost after ajax request. 
			
			if (!empty($sid))
			{
				$this->db->query("select value from ".DB_PREFIX."_session where id='".$this->db->escape_string($sid)."'");
				$val=$this->db->fetch_array();
				if (!empty($val))
				{
					$val=explode(";",$val['value']);
					foreach ($val as $values)
					{
						$_val=explode("=",$values,2);
						if (isset($_val[0],$_val[1])) $__val[$_val[0]]=$_val[1];
					}
			
					if (isset($__val['sid'],$__val['shash']))
					{
						if ($__val['shash'] == $this->shash)
						{
							foreach ($__val as $key=>$value)
							{
								$this->var[$key]=$value;
							}
						} else 
						{
							/* is not catastrophic
							$this->error='Bad session hash recieved.';
							return false;
							*/
						}
					}
					
					if (isset($this->var['cookie_enabled']))
					{
						/*
						if ($this->var['cookie_enabled']=='true' && isset($_GET['sid']))
						{
							$this->error='invalid session id transfer type.';
							return false;
						}
						*/
						if ($this->var['cookie_enabled']=='false' && isset($_COOKIE['sid']))
						{
							$this->error='invalid session id transfer type.';
							return false;
						}
					} else
					{
						if (isset($_COOKIE['sid'])) 
						{
							$this->register('cookie_enabled','true');
							if (CLEAN_URL) $this->register('clean_url','true');
						} else 
						{
							$this->register('cookie_enabled','false');
							if (CLEAN_URL) $this->register('clean_url','false');
						}
					}
					
					if (!($this->db->query("update ".DB_PREFIX."_session set id='".$this->db->escape_string($this->sid)."' , regtime='".time()."' where id='".$this->db->escape_string($sid)."'")))
					{
						$this->error=$this->db->error;
						return false;
					}
					
					if ($this->var['cookie_enabled']=='true' && $this->workspace != 'ajax') setcookie('sid',$this->sid,time()+SESSION_LIFE_TIME,'/','.'.SITE_HOST);
					return true;
				}
			}
			
			if (!($this->db->query("insert into ".DB_PREFIX."_session (id,regtime) values ('".$this->db->escape_string($this->sid)."','".time()."')")))
			{
				$this->error=$this->db->error;
				return false;
			}
			
			if ($this->workspace != 'ajax') setcookie('sid',$this->sid,time()+SESSION_LIFE_TIME,'/','.'.SITE_HOST);	
			return true;
		} else
		{
			session_start();
			if (isset($_SESSION['sid'],$_SESSION['shash']))
			{
				$this->sid=$_SESSION['sid'];     //   required for ajax requests. NOTE! sid should be changed every time the script called, but in this case the session will be lost after ajax request. 
				
				if ($_SESSION['shash'] == $this->shash)
				{
					foreach ($_SESSION as $key=>$value)
					{
						$this->var[$key]=$value;
					}
				} else 
				{
					/* is not catastrophic
					$this->error='Bad session hash recieved.';
					return false;
					*/
				}
				
				if (!isset($this->var['cookie_enabled']))
				{
					if (isset($_COOKIE['PHPSESSID']))
					{
						$this->register('cookie_enabled','true');
						if (CLEAN_URL) $this->register('clean_url','true');
					} else 
					{
						$this->register('cookie_enabled','false');
						if (CLEAN_URL) $this->register('clean_url','false');
					}
				}
			}
			return true;
		}
	}
	
	function fix()
	{
		$this->register('sid',$this->sid);
		$this->register('shash',$this->shash);
		
		if (SESSION_EMULATE)
		{
			$val=array();
			foreach ($this->var as $key=>$value)
			{
				$val[]=$key."=".$value;
			}
			$_val=implode(";",$val);
			$this->db->query("update ".DB_PREFIX."_session set value='".$this->db->escape_string($_val)."' where id='".$this->db->escape_string($this->sid)."'");
		}
	}
	
	function register($key,$value)
	{
		$this->var[$key]=$value;
		
		if (!SESSION_EMULATE) :
			$_SESSION[$key]=$value;
		endif;
	}
	
	function clear($key)
	{
		unset($this->var[$key]);
		
		if (!SESSION_EMULATE) :
			unset($_SESSION[$key]);
		endif;
	}
	
	function empty_trash()
	{
		if (SESSION_EMULATE)
		{
			$time=time()-SESSION_LIFE_TIME;
			$this->db->query("delete from ".DB_PREFIX."_session where regtime < ".$time);
		}
	}
}
?>