<?php
defined("SAWANNA") or die();

class CDatabase
{
	var $connection_id;
	var $result_id;
	var $error;
	
	function CDatabase()
	{
		$this->connection_id=0;
		$this->result_id=0;
		$this->error="";
	}
	
	function init()
	{
		if (defined('SAWANNA_INSTALLER') && !$this->check_install())
		{
			if (!($this->connection_id=sqlite_open(DB_HOST)))
			{
				$this->error="Failed to open or create database '".DB_HOST."'";
			}
			return false;
		}
		
		if (!($this->connection_id=sqlite_open(DB_HOST)))
		{
			$this->error="Failed to open or create database '".DB_HOST."'";
			return false;
		}
		return true;
	}
	
	function check_install()
	{
		clearstatcache();
		if (!@filesize(DB_HOST))
		{
			$this->error='Sawanna is not installed !';
			return false;
		}
		return true;
	}
	
	function query($query_str)
	{
		
		if (!($this->result_id=sqlite_query($query_str,$this->connection_id)))
		{
			if (DEBUG_MODE)
			{
				$this->error=sqlite_error_string(sqlite_last_error($this->connection_id));
				return false;
			} else 
			{
				die();
			}
		}
		return true;
	}
	
	function sub_query($query_str)
	{
		
		if (!($result=sqlite_query($query_str,$this->connection_id)))
		{
			if (DEBUG_MODE)
			{
				$this->error=sqlite_error_string(sqlite_last_error($this->connection_id));
				return false;
			} else 
			{
				die();
			}
		}
		return $result;
	}
	
	function fetch_array($result=0)
	{
		if (empty($result)) $result=$this->result_id;
		if (!$arr=sqlite_fetch_array($result,SQLITE_ASSOC))
			return false;
		return $arr;
	}
	
	function num_rows($result=0)
	{
		if (empty($result)) $result=$this->result_id;
		if (!($co=sqlite_num_rows($result)))
			return false;
		else
			return $co;
	}
	
	function escape_string($string)
	{
		if (get_magic_quotes_gpc())
		{
	        $string = stripslashes($string);
	    }
		return sqlite_escape_string($string);
	}
	
	function close()
	{
		sqlite_close($this->connection_id);
	}
}
?>