<?php
#####################################################################################################
# NOTE! User group is 0 if not logged, 2 if logged as user, 3 if banned, 1 if logged as administrator
#       User is active if `active` property is 1
#       If user is deleted login , password , info , mail are empty, group , active are 0, name is [*]
#####################################################################################################

defined("SAWANNA") or die();

class CUser
{
	var $db;
	var $session;
	var $name;
	var $id;
	var $group;
	var $login;
	var $mail;
	var $joined;
	var $info;
	var $gender;
	var $dob;
	var $country;
	var $icq;
	var $msn;
	var $skype;
	var $active;
	var $photo_path;
	var $error;
	var $utf8;
	var $groups;
	var $countries;
	var $dob_months;
	var $resize_avatar;
	
	function CUser(&$db,&$session,&$utf8)
	{
		$this->db=&$db;
		$this->session=&$session;
		$this->name='[string]guest[/string]';
		$this->id=null;
		$this->group=0;
		$this->login=null;
		$this->mail=null;
		$this->joined=null;
		$this->info=null;
		$this->gender=null;
		$this->dob=null;
		$this->country=null;
		$this->icq=null;
		$this->msn=null;
		$this->skype=null;
		$this->active=0;
		$this->photo='<img src="'.PROTOCOL.'://'.SITE_HOST.'/sawanna/images/user.jpg" width="100" height="100" />';
		$this->error='';
		$this->utf8=&$utf8;
		$this->groups=array(1,2,3);
		$this->get_countries();
		$this->get_months();
		$this->resize_avatar=true;
	}
	
	function identify()
	{
		if (isset($this->session->var['user_id'],$this->session->var['user_pass']))
		{
			$this->db->query("select * from ".DB_PREFIX."_users where id='".$this->db->escape_string($this->session->var['user_id'])."'");
			$user=$this->db->fetch_array();
			if (!empty($user) && $this->session->var['user_pass'] == $user['passwd'])
			{
				$this->name=$user['name'];
				$this->id=$user['id'];
				$this->group=$user['group_id'];
				$this->login=$user['login'];
				$this->mail=$user['mail'];
				$this->joined=$user['joined'];
				$this->info=$user['info'];
				$this->active=$user['active'];
				$ava_path=ROOT_DIR.'/upload/user/'.md5($this->login).'.ava';
				if (file_exists($ava_path))
				{
					$image=@getimagesize($ava_path);
					$image_size=!empty($image) ? $image[3] : '';
					$this->photo='<img src="'.PROTOCOL.'://'.SITE_HOST.'/upload/user/'.md5($this->login).'.ava" '.$image_size.' />';
				} else 
				{
					$this->photo='<img src="'.PROTOCOL.'://'.SITE_HOST.'/sawanna/images/user.jpg" width="100" height="100" />';
				}
				$this->gender=$user['gender'];
				$this->dob=$user['dob'];
				$this->country=$user['country'];
				$this->icq=$user['icq'];
				$this->msn=$user['msn'];
				$this->skype=$user['skype'];
			} else
			{
				$this->session->clear('user_id');
				$this->session->clear('user_pass');
			}
		}
	}
	
	function register($login,$pass,$mail)
	{
		global $bad_logins;
		
		if (!ALLOW_USER_REGISTER && $this->group != 1)
		{
			$UserInterface->error='[string]registration_stopped[/string]';
			return false;
		}
		if (!$this->validate($login,$pass,$mail))
		{
			$this->error.='[string]register_failed[/string]';
			return false;
		}
		
		if ($this->group != 1 && eregi('^(super.*)?admin.*',$login))
		{
			$this->error.='[string]bad_login_detected[/string]';
			return false;
		}
		
		if ($this->group != 1 && in_array($login,$bad_logins))
		{
			$this->error.='[string]bad_login_detected[/string]';
			return false;
		}
		
		$this->db->query("select id from ".DB_PREFIX."_users where login='".$this->db->escape_string($login)."'");
		$exists=$this->db->fetch_array();
		if (!empty($exists))
		{
			$this->error='[string]login_exists[/string]';
			return false;
		}
		
		$pass=$this->crypt_password($pass);
		$active=USER_E_MAIL_CHECK ? 0 : 1;
		
		if (!$this->db->query("insert into ".DB_PREFIX."_users (login,passwd,mail,joined,group_id,active) values ('".$this->db->escape_string($login)."','".$this->db->escape_string($pass)."','".$this->db->escape_string($mail)."','".time()."','2','".$active."')"))
		{
			$this->error='[string]database_error[/string]';
			if (DEBUG_MODE) $this->error.='<br />'.$this->db->error;
			return false;
		}
		return true;
	}
	
	function crypt_password($pass)
	{
		return md5(md5($pass).strrev($pass));
	}
	
	function validate($login,$pass,$mail)
	{
		if (!$this->validate_word($login,3,64))
		{
			$this->error.='[string]invalid_login[/string]'.' ';
			return false;
		}
		if (!$this->validate_word($pass,6,255))
		{
			$this->error.='[string]invalid_password[/string]'.' ';
			return false;
		}
		if (!$this->validate_mail($mail))
		{
			$this->error.='[string]invalid_mail[/string]'.' ';
			return false;
		}
		return true;
	}
	
	function validate_word($word,$min,$max,$utf8=false)
	{
		 if (empty($word)) return false;
		 if (substr($word, 0, 1) == ' ') return false;
		 if (substr($word, -1) == ' ') return false;
		 if (strpos($word, '  ') !== false) return false;
		 if (!$utf8 && preg_match('/[^0-9a-zA-Z_\x20-]/',$word)) return false;
		 if ($utf8)
		 {
		 	$this->utf8->load_string($word);
		 	if (!$this->utf8->is_valid())
		 	{
		 		$this->utf8->clear();
		 		return false;
		 	} else 
		 	{
		 		$this->utf8->clear();
		 	}
		 }
		 if (strlen($word) < $min) return false;
		 if (strlen($word) > $max) return false;
		 return true;
	}
	
	function validate_mail($mail) {
		 if (empty($mail)) return false;
	  	 if (strpos($mail," ") !== false) return false;
		 if (!preg_match("/^\w+([\.\w-]+)*\w@\w(([\.\w-])*\w+)*\.\w{2,4}$/",$mail)) return false;
		 if (strlen($mail)>255) return false;
	     return true;
	}
	
	function validate_avatar($file)
	{
		if (!is_array($file)) return false;
		if (strpos($file['type'],'image')===false) return false;
		if (!$file['size'] || $file['size'] > 102400) return false;
		
		$size=@getimagesize($file['tmp_name']);
		if (!$size || ($size[2] != IMAGETYPE_JPEG && $size[2] != IMAGETYPE_GIF && $size[2] != IMAGETYPE_PNG)) return false;
		if (!$this->resize_avatar && ($size[0]>100 || $size[1]>100)) return false;
		
		$content=file_get_contents($file['tmp_name']);
		if (preg_match('/[<]([\x20]){0,}script([^>]){0,}[>]/',$content)) return false;
		unset($content);
		if (substr($file['name'],strrpos($file['name'],'.')+1)=='php') return false;
		
		return true;
	}
	
	function resize_avatar($img_path,$avaname,$crop=false)
	{
		$src=false;
		$size=@getimagesize($img_path);
		if (!$size) return false;

		switch ($size[2])
		{
			case IMAGETYPE_JPEG :
				$src=@imagecreatefromjpeg($img_path);
				break;
			case IMAGETYPE_PNG :
				$src=@imagecreatefrompng($img_path);
				break;
			case IMAGETYPE_GIF :
				$src=@imagecreatefromgif($img_path);
				break;
		}
		if ($src)
		{
			$src_width=$size[0];
			$src_height=$size[1];
			$src_x=0;
			$src_y=0;
						
			$dst_width=100;
			$dst_height=100;
			$dst_x=0;
			$dst_y=0;
			
			$dst=imagecreatetruecolor($dst_width,$dst_height);
			$bg_color=@imagecolorallocate($dst, 255, 255, 255);
			@imagefill($dst, 0, 0, $bg_color);

			if ($crop)
			{
				switch (true)
				{
					case ($dst_width/$dst_height) > ($src_width/$src_height) :
						$src_height=$src_width*($dst_height/$dst_width);
						$src_y=($size[1]-$src_height)/2;
						break;
					case ($dst_width/$dst_height) < ($src_width/$src_height) :
						$src_width=$src_height*($dst_width/$dst_height);
						$src_x=($size[0]-$src_width)/2;
						break;
				}
			} else 
			{
				switch (true)
				{
					case ($dst_width/$dst_height) < ($src_width/$src_height) :
						$_dst_height=$dst_width*($src_height/$src_width);
						$dst_y=($dst_height-$_dst_height)/2;
						$dst_height=$_dst_height;
						unset($_dst_height);
						break;
					case ($dst_width/$dst_height) > ($src_width/$src_height) :
						$_dst_width=$dst_height*($src_width/$src_height);
						$dst_x=($dst_width-$_dst_width)/2;
						$dst_width=$_dst_width;
						unset($_dst_width);
						break;
				}
			}
			
			if (!@imagecopyresampled($dst,$src,$dst_x,$dst_y,$src_x,$src_y,$dst_width,$dst_height,$src_width,$src_height)) return false;
			if (!@imagejpeg($dst,ROOT_DIR.'/upload/user/'.$avaname.'.ava')) return false;
			
			imagedestroy($src);
			imagedestroy($dst);
			
			return true;
		} else return false;
	}
	
	function get_countries()
	{
		$this->countries = array(
							'AF' => 'Afghanistan',
							'AL' => 'Albania',
							'DZ' => 'Algeria',
							'AS' => 'American Samoa',
							'AD' => 'Andorra',
							'AO' => 'Angola',
							'AI' => 'Anguilla',
							'AQ' => 'Antarctica',
							'AG' => 'Antigua and Barbuda',
							'AR' => 'Argentina',
							'AM' => 'Armenia',
							'AW' => 'Aruba',
							'AU' => 'Australia',
							'AT' => 'Austria',
							'AZ' => 'Azerbaijan',
							'BS' => 'Bahamas',
							'BH' => 'Bahrain',
							'BD' => 'Bangladesh',
							'BB' => 'Barbados',
							'BY' => 'Belarus',
							'BE' => 'Belgium',
							'BZ' => 'Belize',
							'BJ' => 'Benin',
							'BM' => 'Bermuda',
							'BT' => 'Bhutan',
							'BO' => 'Bolivia',
							'BA' => 'Bosnia and Herzegovina',
							'BW' => 'Botswana',
							'BV' => 'Bouvet Island',
							'BR' => 'Brazil',
							'IO' => 'British Indian Ocean Territory',
							'BN' => 'Brunei Darussalam',
							'BG' => 'Bulgaria',
							'BF' => 'Burkina Faso',
							'BI' => 'Burundi',
							'KH' => 'Cambodia',
							'CM' => 'Cameroon',
							'CA' => 'Canada',
							'CV' => 'Cape Verde',
							'KY' => 'Cayman Islands',
							'CF' => 'Central African Republic',
							'TD' => 'Chad',
							'CL' => 'Chile',
							'CN' => 'China',
							'CX' => 'Christmas Island',
							'CC' => 'Cocos (Keeling) Islands',
							'CO' => 'Colombia',
							'KM' => 'Comoros',
							'CG' => 'Congo',
							'CD' => 'Congo',
							'CK' => 'Cook Islands',
							'CR' => 'Costa Rica',
							'CI' => 'Cote D\'ivoire',
							'HR' => 'Croatia',
							'CU' => 'Cuba',
							'CY' => 'Cyprus',
							'CZ' => 'Czech Republic',
							'DK' => 'Denmark',
							'DJ' => 'Djibouti',
							'DM' => 'Dominica',
							'DO' => 'Dominican Republic',
							'TP' => 'East Timor',
							'EC' => 'Ecuador',
							'EG' => 'Egypt',
							'SV' => 'El Salvador',
							'GQ' => 'Equatorial Guinea',
							'ER' => 'Eritrea',
							'EE' => 'Estonia',
							'ET' => 'Ethiopia',
							'FK' => 'Falkland Islands (Malvinas)',
							'FO' => 'Faroe Islands',
							'FJ' => 'Fiji',
							'FI' => 'Finland',
							'FR' => 'France',
							'FX' => 'France, Metropolitan',
							'GF' => 'French Guiana',
							'PF' => 'French Polynesia',
							'TF' => 'French Southern Territories',
							'GA' => 'Gabon',
							'GM' => 'Gambia',
							'GE' => 'Georgia',
							'DE' => 'Germany',
							'GH' => 'Ghana',
							'GI' => 'Gibraltar',
							'GR' => 'Greece',
							'GL' => 'Greenland',
							'GD' => 'Grenada',
							'GP' => 'Guadeloupe',
							'GU' => 'Guam',
							'GT' => 'Guatemala',
							'GN' => 'Guinea',
							'GW' => 'Guinea-bissau',
							'GY' => 'Guyana',
							'HT' => 'Haiti',
							'HM' => 'Heard and Mc Donald Islands',
							'VA' => 'Holy See (Vatican City State)',
							'HN' => 'Honduras',
							'HK' => 'Hong Kong',
							'HU' => 'Hungary',
							'IS' => 'Iceland',
							'IN' => 'India',
							'ID' => 'Indonesia',
							'IR' => 'Iran (Islamic Republic of)',
							'IQ' => 'Iraq',
							'IE' => 'Ireland',
							'IL' => 'Israel',
							'IT' => 'Italy',
							'JM' => 'Jamaica',
							'JP' => 'Japan',
							'JO' => 'Jordan',
							'KZ' => 'Kazakhstan',
							'KE' => 'Kenya',
							'KI' => 'Kiribati',
							'KP' => 'Korea, Democratic People\'s Republic',
							'KR' => 'Korea, (South Korea)',
							'KW' => 'Kuwait',
							'KG' => 'Kyrgyzstan',
							'LA' => 'Lao People\'s Democratic Republic',
							'LV' => 'Latvia',
							'LB' => 'Lebanon',
							'LS' => 'Lesotho',
							'LR' => 'Liberia',
							'LY' => 'Libyan Arab Jamahiriya',
							'LI' => 'Liechtenstein',
							'LT' => 'Lithuania',
							'LU' => 'Luxembourg',
							'MO' => 'Macau',
							'MK' => 'Macedonia, The Former Yugoslav Republic',
							'MG' => 'Madagascar',
							'MW' => 'Malawi',
							'MY' => 'Malaysia',
							'MV' => 'Maldives',
							'ML' => 'Mali',
							'MT' => 'Malta',
							'MH' => 'Marshall Islands',
							'MQ' => 'Martinique',
							'MR' => 'Mauritania',
							'MU' => 'Mauritius',
							'YT' => 'Mayotte',
							'MX' => 'Mexico',
							'FM' => 'Micronesia, Federated States',
							'MD' => 'Moldova',
							'MC' => 'Monaco',
							'MN' => 'Mongolia',
							'MS' => 'Montserrat',
							'MA' => 'Morocco',
							'MZ' => 'Mozambique',
							'MM' => 'Myanmar',
							'NA' => 'Namibia',
							'NR' => 'Nauru',
							'NP' => 'Nepal',
							'NL' => 'Netherlands',
							'AN' => 'Netherlands Antilles',
							'NC' => 'New Caledonia',
							'NZ' => 'New Zealand',
							'NI' => 'Nicaragua',
							'NE' => 'Niger',
							'NG' => 'Nigeria',
							'NU' => 'Niue',
							'NF' => 'Norfolk Island',
							'MP' => 'Northern Mariana Islands',
							'NO' => 'Norway',
							'OM' => 'Oman',
							'PK' => 'Pakistan',
							'PW' => 'Palau',
							'PA' => 'Panama',
							'PG' => 'Papua New Guinea',
							'PY' => 'Paraguay',
							'PE' => 'Peru',
							'PH' => 'Philippines',
							'PN' => 'Pitcairn',
							'PL' => 'Poland',
							'PT' => 'Portugal',
							'PR' => 'Puerto Rico',
							'QA' => 'Qatar',
							'RE' => 'Reunion',
							'RO' => 'Romania',
							'RU' => 'Russian Federation',
							'RW' => 'Rwanda',
							'KN' => 'Saint Kitts and Nevis',
							'LC' => 'Saint Lucia',
							'VC' => 'Saint Vincent and the Grenadines',
							'WS' => 'Samoa',
							'SM' => 'San Marino',
							'ST' => 'Sao Tome and Principe',
							'SA' => 'Saudi Arabia',
							'SN' => 'Senegal',
							'SC' => 'Seychelles',
							'SL' => 'Sierra Leone',
							'SG' => 'Singapore',
							'SK' => 'Slovakia (Slovak Republic)',
							'SI' => 'Slovenia',
							'SB' => 'Solomon Islands',
							'SO' => 'Somalia',
							'ZA' => 'South Africa',
							'GS' => 'South Georgia and the South Sandwich Islands',
							'ES' => 'Spain',
							'LK' => 'Sri Lanka',
							'SH' => 'St. Helena',
							'PM' => 'St. Pierre and Miquelon',
							'SD' => 'Sudan',
							'SR' => 'Suriname',
							'SJ' => 'Svalbard and Jan Mayen Islands',
							'SZ' => 'Swaziland',
							'SE' => 'Sweden',
							'CH' => 'Switzerland',
							'SY' => 'Syrian Arab Republic',
							'TW' => 'Taiwan, Province of China',
							'TJ' => 'Tajikistan',
							'TZ' => 'Tanzania, United Republic',
							'TH' => 'Thailand',
							'TG' => 'Togo',
							'TK' => 'Tokelau',
							'TO' => 'Tonga',
							'TT' => 'Trinidad and Tobago',
							'TN' => 'Tunisia',
							'TR' => 'Turkey',
							'TM' => 'Turkmenistan',
							'TC' => 'Turks and Caicos Islands',
							'TV' => 'Tuvalu',
							'UG' => 'Uganda',
							'UA' => 'Ukraine',
							'AE' => 'United Arab Emirates',
							'GB' => 'United Kingdom',
							'US' => 'United States',
							'UM' => 'United States Minor Outlying Islands',
							'UY' => 'Uruguay',
							'UZ' => 'Uzbekistan',
							'VU' => 'Vanuatu',
							'VE' => 'Venezuela',
							'VN' => 'Viet Nam',
							'VG' => 'Virgin Islands (British)',
							'VI' => 'Virgin Islands (U.S.)',
							'WF' => 'Wallis and Futuna Islands',
							'EH' => 'Western Sahara',
							'YE' => 'Yemen',
							'YU' => 'Yugoslavia',
							'ZM' => 'Zambia',
							'ZW' => 'Zimbabwe'
							);
	}
	
	function get_months()
	{
		$this->dob_months=array(
					'01' => 'january',
					'02' => 'february',
					'03' => 'march',
					'04' => 'april',
					'05' => 'may',
					'06' => 'june',
					'07' => 'july',
					'08' => 'august',
					'09' => 'september',
					'10' => 'october',
					'11' => 'november',
					'12' => 'december'
					);
	}
}

?>