<?php
############################################################
# This class is experimental.
# At the moment supported only latin and cyrilic characters.
############################################################

/*
$cyr_lower_chars=array('а','б','в','г','д','е','ё','ж','з','и','й','к','л','м','н','о','п','р','с','т','у','ф','х','ц','ч','ш','щ','ъ','ы','ь','э','ю','я');
$cyr_upper_chars=array('А','Б','В','Г','Д','Е','Ё','Ж','З','И','Й','К','Л','М','Н','О','П','Р','С','Т','У','Ф','Х','Ц','Ч','Ш','Щ','Ъ','Ы','Ь','Э','Ю','Я');
$latin_lower_chars=array('a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z');
$latin_upper_chars=array('A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z');
$numbers=array('1','2','3','4','5','6','7','8','9','0');
*/

defined("SAWANNA") or die();

class CUTF8
{
	var $chars;
	var $valid_simbols;
	
	function CUTF8()
	{
		$this->chars=array();
		$this->valid_simbols=array('32','45','95'); // ascii
	}
	
	function load_string($string)
	{
		$this->chars=array();
		
		$new_char=true;
		$bytes_count=0;
		$offset=0;
		$_i=0;
		for ($i=0;$i<strlen($string);$i++)
		{
			$byte=substr($string,$i,1);
			$byte=str_pad(base_convert(bin2hex($byte),16,2),8,'0',STR_PAD_LEFT);
			
			if ($new_char)
			{
				$begin=strpos($byte,'0')+1;
				$this->chars[$offset]=substr($byte,$begin);
				$bytes_count=($begin-1)>0 ? $begin-1 : 1;
				if ($bytes_count!=1) 
				{
					$new_char=false;
					$_i=$i;
				}
			} else 
			{
				$begin=strpos($byte,'0')+1;
				$this->chars[$offset].=substr($byte,$begin);
				if ($i>=$_i+$bytes_count-1) 
				{
					$new_char=true;
				}
			}
			
			if ($new_char) $offset++;
		}

		for ($i=0;$i<count($this->chars);$i++)
		{
			$this->chars[$i]=bindec($this->chars[$i]);
		}
	}
	
	function is_cyrilic($char)
	{
		if (($char>=1040 && $char<=1103) || $char==1025 || $char==1105) 
			return true;
		else 
			return false;
	}
	
	function is_latin($char)
	{
		if (($char>=65 && $char<=90) || ($char>=97 && $char<=122))
			return true;
		else 
			return false;
	}
	
	function is_number($char)
	{
		if (($char>=48 && $char<=57))
			return true;
		else 
			return false;
	}
	
	function convert($to)
	{
		$chars=array();
		
		if ($to=='windows-1251') 
		{
			foreach ($this->chars as $char)
			{
				if ($this->is_cyrilic($char))
				{
					if ($char==1025) $chars[]=$char-857;
					elseif($char==1105) $chars[]=$char-921;
					else $chars[]=$char-848;
				} else
					$chars[]=$char;
			}
			
			$this->chars=$chars;
		}
	}
	
	function is_valid()
	{
		foreach ($this->chars as $char)
		{
			if (!$this->is_cyrilic($char) && !$this->is_latin($char) && !$this->is_number($char) && !in_array($char,$this->valid_simbols))
			{
				return false;	
			}
		}
		return true;
	}
	
	function to_lower()
	{
		$chars=array();
		
		foreach ($this->chars as $char)
		{
			switch (true)
			{
				case $this->is_cyrilic($char) :
					if ($char==1025) $chars[]=$char+80;
					elseif($char>=1040 && $char<=1071) $chars[]=$char+32;
					else $chars[]=$char;
					
					break;
				case $this->is_latin($char) :
					if($char>=65 && $char<=90) $chars[]=$char+32;
					else $chars[]=$char;
					
					break;
				default:
					$chars[]=$char;
			}
		}
		
		$this->chars=$chars;
	}
	
	function to_upper()
	{
		$chars=array();
		
		foreach ($this->chars as $char)
		{
			switch (true)
			{
				case $this->is_cyrilic($char) :
					if ($char==1105) $chars[]=$char-80;
					elseif($char>=1072 && $char<=1103) $chars[]=$char-32;
					else $chars[]=$char;
					
					break;
				case $this->is_latin($char) :
					if($char>=97 && $char<=122) $chars[]=$char-32;
					else $chars[]=$char;
					
					break;
				default:
					$chars[]=$char;
			}
		}
		
		$this->chars=$chars;
	}
	
	function char($char)
	{
		if ($this->is_cyrilic($char))
		{
			$cyr_chars=array(
								1072 => 'а',
								1073 => 'б',
								1074 => 'в',
								1075 => 'г',
								1076 => 'д',
								1077 => 'е',
								1105 => 'ё',
								1078 => 'ж',
								1079 => 'з',
								1080 => 'и',
								1081 => 'й',
								1082 => 'к',
								1083 => 'л',
								1084 => 'м',
								1085 => 'н',
								1086 => 'о',
								1087 => 'п',
								1088 => 'р',
								1089 => 'с',
								1090 => 'т',
								1091 => 'у',
								1092 => 'ф',
								1093 => 'х',
								1094 => 'ц',
								1095 => 'ч',
								1096 => 'ш',
								1097 => 'щ',
								1098 => 'ъ',
								1099 => 'ы',
								1100 => 'ь',
								1101 => 'э',
								1102 => 'ю',
								1103 => 'я',
								
								1040 => 'А',
								1041 => 'Б',
								1042 => 'В',
								1043 => 'Г',
								1044 => 'Д',
								1045 => 'Е',
								1025 => 'Ё',
								1046 => 'Ж',
								1047 => 'З',
								1048 => 'И',
								1049 => 'Й',
								1050 => 'К',
								1051 => 'Л',
								1052 => 'М',
								1053 => 'Н',
								1054 => 'О',
								1055 => 'П',
								1056 => 'Р',
								1057 => 'С',
								1058 => 'Т',
								1059 => 'У',
								1060 => 'Ф',
								1061 => 'Х',
								1062 => 'Ц',
								1063 => 'Ч',
								1064 => 'Ш',
								1065 => 'Щ',
								1066 => 'Ъ',
								1067 => 'Ы',
								1068 => 'Ь',
								1069 => 'Э',
								1070 => 'Ю',
								1071 => 'Я',
								);
			return $cyr_chars[$char];
		} else 
		{
			return chr($char);
		}
		
	}
	
	function return_string()
	{
		$string='';
		
		foreach ($this->chars as $char)
		{
			$string.=$this->char($char);
		}
		
		return $string;
	}
	
	function clear()
	{
		array_splice($this->chars,0);
	}
}

?>