<?php
define("SAWANNA",1);

require_once('./settings.php');

if (!defined('ROOT_DIR') || !defined('SITE_HOST') || !defined('HOME') || !defined('DB_TYPE') || !defined('DB_HOST') || (DB_TYPE!='SQLite' && (!defined('DB_NAME') || !defined('DB_USER') || !defined('DB_PASS'))) || !defined('DB_PREFIX'))
{
	die();
}

require_once("./sawanna/config.php");
require_once("./sawanna/sawanna.inc.php");

register_shutdown_function('sawanna_clear');

$Sawanna = new CSawanna();
$Sawanna->init();

if (CLEAN_URL) $Sawanna->session->var['clean_url']=true;

$xml='<?xml version="1.0" encoding="UTF-8"?>'."\n";
$xml.='<urlset xmlns="http://www.sitemaps.org/schemas/sitemap/0.9">'."\n";

$urls=array();
$Sawanna->db->query("select workspace,link from ".DB_PREFIX."_nodes where access='1' order by id");
while ($node=$Sawanna->db->fetch_array()) {
	if (in_array($node['workspace'].'/'.$node['link'],$urls)) continue;
	$urls[]=$node['workspace'].'/'.$node['link'];
	
	$xml.='<url>'."\n";
	$xml.='<loc>';
	$xml.=$Sawanna->build_url($node['workspace'].'/'.$node['link'],false,true);
	$xml.='</loc>'."\n";
	$xml.='<changefreq>daily</changefreq>'."\n";
	$xml.='</url>'."\n";
}

$xml.='</urlset>';
echo $xml;

$Sawanna->ok=true;
$_SERVER['QUERY_STRING']='Sitemap';
$Sawanna->log->register(true);

function sawanna_clear()
{
	global $Sawanna;
	if (isset($Sawanna) && !$Sawanna->ok)
	{
		if (isset($Sawanna->log))
		{
			$_SERVER['QUERY_STRING']='Sitemap';
			$Sawanna->log->register(false);
		}
	}
	$Sawanna->clear();
}
?>